zig (0.13.0-1) unstable; urgency=medium

  [ Andrew Kelley ]
  * init
  * link against LLVM
  * input output
  * add license
  * read a file
  * tokenize
  * preprocessor detects #include directives
  * preprocessor runs once
  * some half done thing I forgot about ¯\_(ツ)_/¯
  * tokenizing hello.zig
  * building part of the hello world AST
  * parser generator beginnings
  * parsergen parsing a simple grammar
  * progress toward more complex parser gen
  * experiment with being a linker
  * delete ELF parsing code
  * generated parser understands tuples
  * parser generator supports sub rules
  * parser generator supports a simple OR
  * grammar doesn't need the option() construct
  * delete parser generator. let's try recursive descent
  * parsing hello.zig example with recursive descent
  * more detailed AST inspection
  * semantic analysis checks for multiple definitions of functions
  * partial hello world codegen
  * hello world IR code looks good
  * codegen: fix param type of const strings
  * write object file and fix void return type
  * add unreachable expression
  * hello world example working
  * fix not using subtarget features
  * debug information for functions
  * debug symbols implemented; debugging with gdb works
  * only \n and ' ' are valid whitespace characters
  * debug/release mode
  * simple vim syntax highlighting
  * support linker directives
  * cleanup
  * build: improve findllvm script
  * build: fix findllvm script

  [ Josh Wolfe ]
  * fix typo

  [ Andrew Kelley ]
  * fix invalid memory write
  * parser: more AST printing code for debug purposes

  [ Josh Wolfe ]
  * inline AstNodeStatement

  [ Andrew Kelley ]
  * assert(false) -> zig_unreachable()

  [ Josh Wolfe ]
  * clean up noreturn stuff

  [ Andrew Kelley ]
  * fix the remaining TODOs in the source

  [ Josh Wolfe ]
  * inline AstNodeStatementExpression

  [ Andrew Kelley ]
  * parser: force ast printer to be correct
  * no errors during codegen
  * add tests

  [ Josh Wolfe ]
  * more readable integer constant
  * add hook for environment variable ZIG_DEBIAN_HACK. see #1.

  [ Andrew Kelley ]
  * call ld with correct -dynamic-linker argument
  * support C-style comments, plus nesting
  * allow empty function and return with no expression
  * add pub and export visibility modifiers and optimization
  * figure out integers
  * rename standalone.cpp to run_tests.cpp
  * add tests for compile errors
  * add root export declaration which is overridable by command line options
  * more vim doc files
  * remove unnecessary codegen llvm initialization
  * ability to export .o file
  * parse and codegen for math expressions
  * remove LLVMZigTargetMachineEmitToFile
  * parser: add missing `static`
  * add unary expression
  * rename unary expression to prefix op expression
  * function call names are expressions

  [ Josh Wolfe ]
  * flatten expression ast to hide operator precedence

  [ Andrew Kelley ]
  * codegen: fix wrong node type

  [ Josh Wolfe ]
  * merge arithmetic binary operator gen functions

  [ Andrew Kelley ]
  * add missing panic for shared library output

  [ Josh Wolfe ]
  * inline PrimaryExpr ast node

  [ Andrew Kelley ]
  * ability to generate shared library and h file
  * minor parser refactoring
  * add directive to specify root export version
  * add bad version string test case

  [ Josh Wolfe ]
  * factor analysis code out of codegen
  * rename variable

  [ Andrew Kelley ]
  * analyze no longer depends on llvm C++ API

  [ Josh Wolfe ]
  * untangle analyze_node into a stricter call graph

  [ Andrew Kelley ]
  * all LLVM C++ API contained to one file

  [ Josh Wolfe ]
  * no more TypeId. use g->builtin_types.
  * implement basics of type checking

  [ Andrew Kelley ]
  * refactor code to prepare for multiple files

  [ Josh Wolfe ]
  * fix ast printer names

  [ Andrew Kelley ]
  * closer to multiple files working
  * analyze looks for root export decl only in the root source file
  * colored error messages that tell the source file
  * add --color cli arg to override tty detection
  * support multiple files
  * add test for bad import

  [ Josh Wolfe ]
  * string literals have type *const u8
  * implicit void statements and all tests pass with type checking

  [ Andrew Kelley ]
  * support if conditionals
  * fix parameter access and thus shared library example
  * add test for undeclared identifier error
  * fix execution reaches end of non-void

  [ Josh Wolfe ]
  * parsing variable declaration

  [ Andrew Kelley ]
  * add labels and goto

  [ Josh Wolfe ]
  * analysis for variable declaration, but not variable reference
  * fix analysis for variable reference
  * local variables work
  * tests for local variables
  * fix if-else type mismatch crash
  * add bool literals
  * tests for bool stuff
  * correkt spelling error
  * can't declare unreachable variables
  * test for separate scopes not colliding
  * fix codegen for void parameters
  * test for void parameters

  [ Andrew Kelley ]
  * parseh command, parses a C .h file and produces extern decls
  * parseh: detect fixed size integer types
  * more C header interoperability
  * exporting .h file supports void
  * parseh: fix wrong fn parameters in some cases
  * fix reading source from stdin
  * error for extern function with void parameter
  * run_tests supports --reverse arg
  * add unused label error
  * update README
  * fix hello world example
  * update README
  * add mutable local variables

  [ Josh Wolfe ]
  * cmake needs to be taught a lesson in debian paths
  * initialize mutable variables to zero
  * let is now a statement, not an expression
  * getting started on array types

  [ Andrew Kelley ]
  * add debugging info for array type
  * all variables have memory addresses
  * integrate debug scopes with block context
  * add local variables to debug info
  * codegen: do all the allocas at beginning of function
  * codegen: set target triple and data layout
  * codegen does signed, unsigned, and floating point math
  * add array access syntax
  * array access support
  * support assigning to arrays
  * add test for arrays
  * parseh: add c header files
  * parseh: better results for stdio.h
  * ability to call external variadic functions

  [ Josh Wolfe ]
  * fix typo

  [ Andrew Kelley ]
  * parseh: cleanup types
  * readme: update int types
  * doc: update vim syntax
  * add language reference documentation
  * add inline assembly support
  * provide std.zig and add it to import paths
  * hello world working without libc
  * move roadmap to github issues
  * readme: update current status
  * prepare codebase for struct and string support
  * std: print_str no longer requires length argument
  * progress on struct support

  [ Josh Wolfe ]
  * fix a + b + c and similar
  * fix short circuit expressions
  * tokenizing assignment operators
  * parsing assignment operators
  * codegen and tests for modify operators. closes #16

  [ Andrew Kelley ]
  * structs are working

  [ Josh Wolfe ]
  * prefer checking a type's id over comparing it to a builtin_types entry

  [ Andrew Kelley ]
  * fix incorrect debug info path to imports
  * add number literal type
  * std: factor out the write syscall and make it public

  [ Josh Wolfe ]
  * fix compile -Werrors
  * prefer `int *token_index` over new_token_index

  [ Andrew Kelley ]
  * instead of *mut and *const, & and &const
  * doc: update vim syntax
  * `const` and `var` instead of `let` and `let mut`
  * analyze: BlockContext has concept of module scope
  * add global variable support
  * constant initializers allow simple expressions
  * std: expose exit syscall
  * support inline assembly expressions with return type
  * std: more efficient inline assembly
  * std: even more efficient inline assembly
  * codegen: add support for shortening cast

  [ Josh Wolfe ]
  * tokenizer parses all number literal types
  * more number literal syntax is supported. floats still need work

  [ Andrew Kelley ]
  * when linking with libc use the C runtime library
  * readme: add note about discovering libc path
  * readme: provide bash to get c dir

  [ Josh Wolfe ]
  * better radix handling in float parsing. base 10 still doesn't work.
  * some tests for number literals
  * add number literal tests for integers
  * base 10 decimals work now. closes #15

  [ Andrew Kelley ]
  * add implicit casting support
  * implicit casting from constant size array to string
  * analyze: clean up type checking
  * fix assignment operators for struct fields
  * support addressof operator and struct pointer field access
  * use realpath to avoid duplicate imports
  * structs have debug information
  * add some brainstorming example zig code
  * codegen: fix struct pointer field access
  * analyze: error for infinite size struct
  * add test for invalid struct field access
  * codegen: support byvalue struct assignment
  * inline assembly uses -> instead of return
  * add struct value expression
  * add test for error for redefinition of struct
  * add error for byvalue struct param on exported fn
  * add error for missing or duplicate field in struct value expr
  * add test for invalid field in struct value expression
  * add while loop
  * add test for while loop
  * add break expression
  * add error for break outside loop
  * implement continue expression
  * parse if maybe expression
  * analyze if maybe var expressions
  * block expressions require parens
  * basic maybe type working
  * error for if var expression not maybe type
  * closer to guess number example working
  * ability to access pointers with array indexing syntax
  * fix implicit cast after unreachable bad code gen
  * codegen: emit debug metadata for parameters
  * fix various bugs related to guess number example
  * add rand example that doesn't yet work
  * add #typeof() compiler function
  * implement #sizeof()
  * multiple files example no longer use libc
  * partial import segregation
  * import segregation for types
  * cleanup readme
  * add member functions
  * member functions get a namespaced symbol
  * add pointer dereferencing operator
  * fix crash when struct field is invalid
  * fix binary operators incorrectly assuming i32
  * fix += not allowed for pointers
  * progress toward compile time constant expression evaluation
  * add #min_value() and #max_value()
  * fix some errors in rand example
  * analyze: ability to call a method on a struct pointer
  * `#sizeof` allowed in constant expression
  * update rand example
  * array syntax is [10]i32 instead of [i32; 10]
  * support unknown size arrays
  * add unknown size array test
  * codegen: fix member function invocation
  * codegen: fix array access of struct field
  * codegen: arithmetic is all wrapping for now
  * codegen: fix lshr/ashr not looking at int sign
  * fix bug in RNG example
  * support pub structs. move rand to std lib.
  * fix undefined reference to memcpy in release mode
  * while detects simple constant condition
  * re-add errno.zig
  * add ?? maybe unwrapping binary operator
  * tokenize: detect "..." after a number literal
  * implement array slicing syntax
  * fix codegen for implicit maybe wrap
  * codegen: fix else if expression and maybe unwrap expr
  * fix guess number example. now it works
  * implement unknown size array indexing and slicing
  * add restrict qualifier on pointer arguments
  * suport checked arithmetic operations via intrinsics
  * rename `restrict` to `noalias`
  * implement pub const
  * add memcpy and memset intrinsics
  * order-independent declarations
  * detect and report top level decl dependency loop
  * order-independent declarations even from imports
  * cleanup guess number example
  * parsing enum declarations
  * refactor out the horrible beast that was codegen_node
  * update enum parsing to new plan
  * delete unused enumfield and enumdecl node types
  * fix codegen for void struct fields
  * resolve enum types and emit debug info
  * simple enum support
  * doc: rename match to switch in vim syntax
  * support enums with values attached
  * fix not adding builtin functions code
  * fix build with gcc
  * all types are now expressions
  * fix noalias codegen
  * instead of 'as' to cast, call type as function
  * parser: type expressions cannot be assignment
  * fix next_node_index on wrong struct
  * overflow intrinsics take type as first argument
  * merge constant expression evaluator with analyzer
  * delete parseh
  * fix build with gcc
  * solve the mystery of undefined reference error
  * fix readme formatting
  * more readme formatting
  * reduce precedence of {} suffix operator
  * add void arrays test
  * rename "use" to "import"
  * parser: fix not setting container init kind
  * fix error message for struct initialization on array
  * support array literals
  * rename "alwaysinline" to "inline"
  * better main symbol prototype
  * proposed cat example implementation
  * fix cat example
  * fix nested arrays
  * add for loop which can iterate over arrays
  * refactor std to use for loop
  * pave the road for function pointers
  * add function pointer support
  * add error for shadowing a type
  * revise plan for cat example
  * use signed integer for sizes of things
  * Revert "delete parseh"
  * add switch statement to language reference
  * add switch statement support to parser
  * cmake: detect libLLVM.so

  [ MovingtoMars ]
  * start working on lang spec
  * rename value_count to member_count

  [ Andrew Kelley ]
  * basic support for switch expression
  * doc: remove string keyword from vim syntax highlighting
  * parsing error value decls and error value literals
  * number literal rework
  * allow constants to have number literal values
  * implicit casts rewrite the AST
  * add test for const number literal
  * add undefined reserved word
  * add compile error for non constant expr global
  * support statically initialized structs
  * un-special case constant global strings
  * support statically initialized array literal
  * add undefined literal
  * implement undefined literal
  * character literal returns a number literal
  * fix no error emitted for redeclaring global var
  * implement literal error values
  * codegen: fix field access of arrays
  * main returns %void
  * fix hang when returning from while loop
  * various small cleanups
  * introduce the error keyword and type
  * fix number literal implicit cast
  * ability to return structs byvalue from functions
  * fix parameter access of sret functions
  * support the `%return` expression
  * update std lib to use error type and global variables
  * implement %% operator
  * fix tests and add %% operator test
  * bootstrap: use %% operator instead of cast
  * update README
  * implement %% prefix operator
  * codegen: get rid of cur_block_context
  * syntax: back to -> for return type, no more =>
  * compiler enforces checking for error
  * implement compile time string concatenation
  * analyze: fix crash when return type is invalid
  * add the C integer types
  * add constant expression evaluation for negation
  * variable initializations are now mandatory
  * update README
  * different extern syntax and simplify parsing top level decls
  * add c_import top level decl
  * docs: update deps to llvm and clang 3.7.1
  * upgrade to the libclang C++ API
  * parseh works for simple functions
  * fix crash when compiling empty file
  * add error for `@typeof` or `&` of number literal
  * remove bogus example code
  * add explicit cast from isize/usize to pointer
  * fix codegen for pointers to void
  * fix comparing incompatible number literals crash
  * fix `%%` prefix operator codegen for simple values
  * parseh: recognize typedef types
  * parseh correctly handles C's void type

  [ MovingtoMars ]
  * simple malloc and free using mmap
  * malloc fails on proper errors
  * check mmap return against -1

  [ Andrew Kelley ]
  * fix stdio duplicately defining va_list
  * parseh: still produce output when not all types are known
  * build command supports -isystem argument

  [ MovingtoMars ]
  * malloc fails on mmap error code properly

  [ Andrew Kelley ]
  * move AST rendering code to separate file
  * c_import of stdio.h works for some functions

  [ MovingtoMars ]
  * basic float printing
  * cleanup float printing
  * remove accidental printf from float printing

  [ Andrew Kelley ]
  * parseh: add --c-import-warnings option
  * parseh recognizes C enums
  * add parseh tests
  * add restrict -> noalias parseh test
  * add parseh test for multiple fn prototypes
  * std: remove incorrect float printing code
  * null pointer optimization for ?&T
  * parseh understands simple structs
  * parseh understands elaborated structs and enums
  * parsh understands constant sized arrays
  * ability to refer to member function directly
  * ability to call member functions directly
  * fix function calling of pointers
  * add test for calling the result of if-else expr
  * parser: allow missing fn name and missing param names
  * ability to specify function type
  * parseh handles self referential structs and fn pointers
  * parseh understands bodyless struct used in fn
  * fix incorrect loading of files over 8192 bytes
  * attempt to get preprocessor entities from libclang
  * parseh understands simple character literal macro

  [ MovingtoMars ]
  * float printing mostly works
  * better f64_is_nan
  * remove some magic numbers from float printing
  * fix some inaccuracy in float printing

  [ Andrew Kelley ]
  * parseh understands number literal defines
  * parseh defines can reference other defines
  * parseh fix crash
  * parseh understands variable declarations
  * parseh properly ignores anonymous structs
  * parseh understands types better and handles some situations better
  * codegen extern global variables correctly
  * delete bogus --help text
  * fix some parseh crashes
  * parseh: use the decayed type not original type
  * parseh understands forward struct definitions
  * parseh handles typedef void better
  * parser: fix parsing of type decls
  * parseh: correct debug for forward decls
  * add --library-path cli option
  * typedecl top level decls respect pub
  * fix C interaction with maybe function pointers
  * support casting between int and float types
  * support casting between floats
  * codegen: fix negation for floats
  * fix invalid const expr eval for negative floats
  * roadmap item acheived enough to put in README
  * parseh: do not create macro alias for extern vars
  * parseh understands macros which alias global fn ptr vars
  * add ?? prefix operator
  * optimization: avoid codegening unused functions
  * build: fix release mode
  * c_import top level decl supports pub
  * inline is a keyword instead of a directive
  * remove the constructor of hash map
  * codegen: avoid a table lookup
  * codegen: avoid table lookup in assembly expression
  * codegen: avoid table lookup for field access
  * add test for var local eval const expr
  * build: prefer llvm-config
  * add abort function and "cold" fn attribute
  * unreachable causes a trap in debug mode
  * codegen: ?? prefix operator causes trap in debug mode
  * build: fix libc path finding
  * fx segfault with colliding bogus top level functions
  * fix crash when incomplete struct used as argument
  * fix various semantic analyzer crashes
  * fix false positive error with same named methods in incomplete struct
  * add @compile_var builtin and "is_big_endian" compile var
  * types sized and aligned with LLVM target data layout API
  * add @compile_var("is_release")
  * fix debug info for arrays being 1 element too short
  * fix debug symbols for byval arguments
  * basic support for building a test target
  * test runner prints test names
  * fix handling of implicit casts in binary operators
  * skip analyzing parameters of invalid function call
  * add ability to call function pointer field
  * fix running tests when linking with libc
  * allow defining errors with the same name
  * move os_get_random_bytes to os.zig
  * fix crash when initializing struct if field is invalid
  * implement constant values for enums with payload
  * for loop supports break and continue
  * ability to explicitly cast bool to int
  * fix debug info for bool type
  * codegen: fix switch expressions for enums with payloads
  * switch statements resolve peer compatibility
  * no namespace required when switching on enum
  * support variable in switch expression prongs
  * switch trap in debug mode when no prong found
  * another planned feature complete
  * fix explicit casting from integer literal to float
  * add rand.float32 to standard library

  [ realazthat ]
  * Added code for generating nonnull attributes

  [ Andrew Kelley ]
  * codegen: use gen_index for nonnull attribute
  * add nonnull to functions with pointer return type
  * update for loop syntax
  * parsing code for defer and more
  * simple unconditional defer support
  * codegen: return respects unconditional defer
  * implement %defer and ?defer
  * parser recognizes %return in a prefix op expression
  * rhs of ?? and %% can be any expression
  * add test for ?? return and add const expr eval for ? prefix op
  * std: remove auto flushing of stderr. use printf
  * parseh understands simple string literal macros
  * parseh: fix not properly demoting structs to typedefs
  * unreachable return type can cast to any other return type
  * ability to explicitly cast maybe pointers to each other
  * add debug info for slices
  * fix debug type of ptr and len fields of slices
  * fix a bogus call to bignum_normalize causing assertion failure
  * blocks with one statement pass constant expression eval
  * add debug info for loop variables
  * implement @const_eval
  * error for non const expr in array size outside fn
  * remove ptr field access of arrays
  * array.len generates a constant number literal expression
  * improve performance for get_fn_type
  * parseh: tiny performance improvement
  * add link to tetris example
  * support static linking against libc

  [ Josh Wolfe ]
  * fix some of the ubuntu build trouble

  [ Andrew Kelley ]
  * support overriding the dynamic linker argument to ld
  * fix build with GCC
  * std: fix parse_u64 implementation and add test
  * @const_eval returns poison value for type when it fails
  * fix -dynamic-linker arg to ld when not overridden
  * if statements can be const expr evaluated
  * minor readme rewording
  * don't create debug type for void arrays
  * add link to intro in readme
  * add "targets" command to list architectures, oses, abis
  * targets command shows which ones are native
  * cleanup target data organization
  * ability to cross compile
  * fix division by 0 crashing compiler
  * add compile error for missing enumeration value in switch
  * add @compile_var("os") and @compile_var("arch")

  [ Serge Paquet ]
  * fix undefined LONG_LONG_MAX compilation error

  [ Andrew Kelley ]
  * add @compile_var("environ")
  * i386 support
  * std: delete malloc and free
  * c integer size takes into account architecture and OS
  * fix build on GCC
  * avoid codegening functions never called from conditional compilation
  * if statement children nodes know if they're compiled out
  * add @ctz, @clz and compiler_rt implementation
  * parseh: fix branching on undefined memory
  * a = b % c uses the types of b and c instead of a
  * add windows C int sizes
  * fix some c header symbol collisions
  * dummy implementation of os_get_random_bytes for windows
  * if any c imports fail, don't emit undefined identifier errors
  * respect link order in source code
  * parseh: more specific warning for different calling conventions
  * parseh: support attributed types
  * parseh: ZIG_PARSEH_CFLAGS -> ZIG_NATIVE_PARSEH_CFLAGS
  * parseh: fix __cdecl causing a fn ptr to be double ptr
  * update readme
  * use llvm-config to find llvm include dirs
  * MacOS has the same int sizes as Linux
  * handle libc include path and libc lib path differently
  * first pass at linking on macos
  * add missing system library to darwin linker job
  * linking on darwin: provide builtins and -arch
  * update bootstrap to work for macos too
  * prepend underscore to non exported functions
  * add windows os code
  * os: fix ability to compile for windows
  * rename 'environ' to 'env_type'
  * fix 64 bit integer printing for mingw
  * use PRIuMAX instead of PRIu64 for mingw
  * back to normal print specifiers
  * os: implement windows os layer
  * update run_tests to work on windows
  * link: on windows link test runner and builtin o files
  * fix build error with signed/unsigned

  [ notkild ]
  * Add support to open, create and close file

  [ Andrew Kelley ]
  * rewrite how importing works
  * fix comparison of unsigned integers error
  * rename syscall.zig to linux.zig
  * better hash table performance
  * c_void is provided outside of C imports
  * fix detection of @import and @c_import inside fn body
  * build: std files each specify install destination
  * update to llvm 3.8.0
  * README: update dependencies
  * add multiline string literal
  * support simple generic functions
  * fix generics not using ast clone
  * ability to compare function pointers at compile time
  * add error for gt and lt comparison of invalid types
  * support multiple generic function instances
  * generic functions use correct type for generic args
  * fix evaluating generic function instance in wrong context
  * fix segfault in generic functions

  [ Josh Wolfe ]
  * fix gcc compile errors

  [ Andrew Kelley ]
  * update cat example, refactor std

  [ Josh Wolfe ]
  * fix gcc compile error

  [ Andrew Kelley ]
  * fix crash when passing empty string to function
  * support hex escapes in string literals

  [ Josh Wolfe ]
  * fix parsing of hex literal 0xb

  [ Andrew Kelley ]
  * implement @err_name builtin function
  * fix debug symbols regression after llvm 3.8.0
  * fix cat example by flushing stdout at end
  * re-introduce goto
  * add @breakpoint()
  * goto: jumping out of scope runs defers
  * add error for assigning null to non-nullable pointer
  * update readme
  * fix crash when casting undefined to slice
  * add error for accessing empty array
  * move some tests into self hosted
  * unsigned ints implicitly cast to signed ints when they fit
  * add error for unable to infer expression type in if statements
  * compile-time function evaluation of pure functions
  * eval: support more node types
  * eval: ability to eval more things
  * passing all tests
  * add error for dividing by zero in static function evaluation
  * more eval tests and fix eval call analyze code
  * eval: support array literals
  * fix evaluating generic functions in wrong context
  * fix crash with generic function and implicit cast
  * move more tests to self-hosted land
  * update README
  * update readme
  * move 2 tests to self hosted land
  * add @embed_file builtin function
  * rearrange standard library a bit
  * fix crash in non-const expression in struct literal outside fn
  * std: remove broken windows random implementation
  * implement constant initialization of enum values
  * add test for public enums
  * enum init uses container init syntax instead of fn call
  * fix casting with imported symbol not working
  * add optional continue expression to while loop
  * for loop: add ability to get pointer to elem var
  * fix undeclared identifier not marking function as impure
  * ability to use a struct with no fields
  * better parsing of C macros
  * add syntax to allow symbols to have arbitrary strings as names
  * parseh: support anonymous enums and enums with initializers

  [ Josh Wolfe ]
  * fix gcc build errors
  * fix vim syntax highlighting for multiline strings

  [ Andrew Kelley ]
  * build: add test coverage target
  * fix returning empty struct from function
  * fix handling of slice of zero bits type
  * cat example: fix not flushing stderr
  * add skeleton for union support
  * add compile error for invalid equality operator uses
  * add codegen for pointer comparison
  * rename unknown_size_array to slice
  * fix ability to parse character literals
  * support switching on error union type

  [ Josh Wolfe ]
  * vim syntax: single-line strings must be contained in a single line

  [ Andrew Kelley ]
  * add array bounds checking in debug mode
  * ability to compare booleans
  * add missing debug entry for breakpoint
  * better parameter codegen
  * better alignment value for stack variables
  * ability to specify body of an extern function
  * add array multiplication operator
  * build: link against libLLVM.so if available
  * implement string escapes
  * support maybe destructuring into a pointer variable
  * beginnings of network standard library code
  * more networking standard library code
  * add cmpxchg builtin function
  * add fence builtin function
  * add integer wrapping
  * add tests for integer overflow crashing
  * add tests for integer wrapping
  * add debug safety for left shifting
  * add shl_with_overflow builtin function
  * fix eval integer wrapping and add tests
  * implicit wrap widening cast on integer peer types
  * add frame_address and return_address builtins
  * link: don't put -l in front of .a or .so files
  * better array concatenation semantics
  * self hosted tests test release mode too
  * std: separate str and cstr
  * support generic data structures
  * generic args available to member functions
  * ability to cast slice to u8 slice
  * add debug safety for division
  * add div_exact builtin fn
  * fix null literal outside function
  * ability to cast u8 slice to bigger slice
  * add list implementation to standard library
  * not-yet-working implementation of generic hash map
  * add debug safety for shortening casts
  * support variable declarations in structs
  * fix ability to use previous generic params and
  * add hashmap to standard library
  * some work in progress networking code
  * builtin: use explicit type instead of typeof function
  * recognize ar program and pass --gc-sections to ld
  * add readonly attribute to relevant functions and parameters

  [ José Miguel Sánchez ]
  * Add --zig-std-dir
  * For the sake of correctness: we can always rely on ZIG_STD_DIR

  [ Andrew Kelley ]
  * ability to cast maybe pointer to isize/usize
  * std: fix linux.get_errno
  * we have generics now
  * std: make parsing an unsigned number generic
  * update README with website
  * add error for wrong return type of main
  * std: take advantage of ability to cast maybe pointer to isize
  * add compile_err builtin
  * switch on compile var marks entire namespaces
  * add 64 bit division test
  * add int_type builtin function
  * add bit_count, is_wrapping, is_signed fields to int types

  [ Travis McDemus ]
  * Add unsigned and signed generic print fns

  [ Andrew Kelley ]
  * compiler-rt: add __aeabi_uldivmod
  * fix crash when error evaluating target of for expr
  * add beginning of print stack trace function
  * support extern C ABI for return types
  * add some docs about builtin functions
  * linux: accept calls accept4 with 0 for flags
  * fix raw string literal crash
  * fix offset map for inline assembly error messages
  * inline assembly: allow empty output list
  * don't add no-frame-pointer-elim for inline functions
  * fix tokenizing string symbols with hex characters in them
  * parseh: support octal in C macro string literal
  * ability to cast explicitly from int to enum
  * fix duplicate type defined when imported from parseh
  * fix not resolving use declarations
  * rename NodeTypeStructDecl to NodeTypeContainerDecl
  * inline parameters
  * std: add OutStream.write_byte
  * unsigned integers for sizes of things
  * std: improve rand implementation and API
  * std: cleanup of rand
  * explicit wrapping integer operations
  * remove multiline comments
  * std: add vaporware plans for floating point builtins
  * std: add tests for mt32 and mt64
  * new multiline string syntax
  * implement multiline C string syntax
  * ability to have a return type of 'type'
  * add zeroes value
  * add style guide
  * add CBuf to standard library
  * std: conform to style guidelines
  * std: replace print_u64/i64 with printInt
  * fix crash when calling method on slice
  * progress toward stack trace printing
  * std: more progress toward stack printing
  * implement `?return` expression
  * implement null as a literal type
  * add ability to explicitly cast enum with no payload to int
  * tokenizer: add missing return statement on float overflow
  * stronger static eval recursive test
  * fix c hello world example
  * fix std io input to work for non seekable fds
  * restore shared library functionality
  * port to llvm 3.9
  * generate debug info for global constants

  [ Wink Saville ]
  * Add Email list
  * Fix email address of Email list

  [ Andrew Kelley ]
  * fix gcc 5.4.0compile errors
  * README: clarify build vs runtime dependencies
  * rename compileErr builtin to compileError
  * rename errName builtin to errorName
  * maxValue and minValue builtins return number literal
  * build: fix warning on gcc 6.2
  * build: add missing static in tokenizer
  * build: remove -Wmissing-prototypes
  * ability to infer parameter types
  * std: avoid calling close twice in InStream

  [ Constantine Tarasenkov ]
  * Fix for C pointer generator

  [ Andrew Kelley ]
  * std: use parameter type inference on min and max functions
  * langref: correct builtin function names
  * rename LLVMZig to ZigLLVM
  * fix compile error message for wrong arg count on method
  * add compile error for assigning through const
  * fix crash with []type{} expression
  * std: fix compile error for unsupported os
  * change `unreachable{}` to `@unreachable()`

  [ alter ]
  * MacOSX compatibility

  [ Andrew Kelley ]
  * darwin compat fixups
  * tests: use a more robust path to self_hosted.zig
  * fix compiler crash involving slice with const slice child
  * ability to specify -framework linker args for MacOS
  * use size_t for indexes
  * tests: correct test name
  * avoid emitting "no member" errors when use import fails
  * fix error when switch prong has implicit cast
  * exporting an object creates an h file
  * fix incorrect linking from previous commit
  * fix compile crash when leaving out for loop parameter
  * os: fix file descriptor leak in os_exec
  * stack trace is able to figure out compilation unit
  * fix compiler crash for misspelled type with pointer only reference
  * enums support member functions
  * ability to have struct to have a field which is slice of itself
  * refactor field access code into more generic container code
  * add error message for method call on non method
  * fix crash when doing binary not on integer literal
  * emit error for extern function
  * cstr.len and cstr.cmp can run at compile time
  * std/rand: remove unneeded TODO
  * add this keyword refers to thing in immediate scope
  * clean up test directory
  * remove compiler directives
  * fix regression: debug safety sometimes incorrectly disabled
  * *WIP*
  * empty function compiles successfully with IR
  * simple add function works with IR
  * fix warning on some compiler versions
  * IR in 2 passes
  * explicit casting works with IR
  * IR if statements WIP
  * IR working for if statements
  * add variable declaration IR
  * add variable declaration initialization IR

  [ François Saint-Jacques ]
  * capitalize builtins in doc

  [ Andrew Kelley ]
  * IR: introduce concept of lvalues
  * IR supports variable assignment
  * IR can inline loops
  * IR: phi instruction works at compile time
  * IR analysis unrolls a complicated loop
  * IR: ability to assign to an array at runtime
  * more test coverage
  * more test coverage, change 'got' to 'found' in errors
  * ir: ability to modify global vars
  * ir: support return expression
  * *WIP*

  [ Steve Perkins ]
  * quicksort
  * sortCmp allows for a custom cmp function
  * sort requires compare function.
  * add sort to CMakeLists + std/index

  [ Andrew Kelley ]
  * add concept of inline for, inline while, inline var
  * IR: support this literal and bool literal
  * WIP moving all analysis to IR
  * IR: support slice types
  * IR: support pointer types
  * IR: move unused codegen code to commented out in bottom of ir.cpp
  * IR: gen string literal
  * IR handles global variables correctly
  * IR: fix prefix op eval setting wrong type
  * IR: fix hang for unreachable functions
  * IR: add assembly instruction
  * IR: implement compile time array access
  * IR: implement pointer dereferencing (even at compile time)
  * remove superseded eval code
  * IR: pointers to constants don't copy data
  * IR: pointers to constants use correct addresses
  * remove AST cloning code and add AST render for while loops
  * IR: inline assembly working
  * IR: support setDebugSafety builtin function
  * IR: correctly codegening memset and memcpy
  * IR: fix decl references pointerness
  * IR: more maybe type support
  * IR: implement compileVar builtin and more
  * IR: error for uncasted null lit variable
  * IR: implement ir_print for maybe type
  * IR: support sizeOf builtin
  * IR: support unwrap maybe operation
  * IR: implement ctz and clz builtins
  * IR: fix detection of invalid codegen
  * IR: fix codegen for arrays
  * IR: implement setFnVisible builtin
  * IR: generating a switch statement
  * IR: switch expression works with numbers
  * IR: support switch with range
  * IR: add error for non static const on switch case range
  * IR: support inline switch
  * IR: support import builtin function
  * IR: fix parsing while loop
  * IR: support goto and labels
  * IR: fix crash when duplicate label error
  * IR: add inline goto
  * IR: detect error for exceeding branch quota
  * IR: add ref instruction
  * IR: fix not checking for error in unary bool not
  * IR: silence irrelevant function prototype errors
  * IR: function call porting progress
  * rename BlockContext to Scope
  * rewrite scope implementation
  * IR: re-organize where state goes to prepare for generics
  * add missing copyright notices
  * IR: compile time function evaluation
  * IR: inline function evaluation works on generic functions
  * IR: implement generic function calls
  * IR: implement break and continue
  * IR: implement short circuit bool or, and
  * remove the boolean argument from setFnTest
  * IR: implement defer
  * IR: implement compile time eval unwrap maybe
  * IR: add error for assigning runtime value to inline var
  * delete unused builtin function stuff
  * IR: add minValue, maxValue, and negation
  * IR: add compileError builtin fn
  * IR: a bunch of fixes and some additions
  * IR: omit debug safety checks in for loop codegen
  * IR: better array len instruction
  * IR: fix errorName builtin
  * IR: support error union type
  * IR: don't crash if number literal used with pure error
  * IR: fix implementation of parseh
  * IR: implement embedFile builtin
  * IR: implement fence and cmpxchg builtins
  * IR: implement divExact builtin
  * IR: implement truncate builtin
  * IR: implement intType builtin
  * IR: implement compile time array multiplication
  * IR: implement compile time array concatenation
  * IR: implement alloca builtin
  * IR: implement memcpy, memset, and slice expression
  * IR: implement memberCount builtin
  * IR: implement breakpoint builtin
  * IR: implement character literal
  * IR: implement the rest of the builtin functions
  * IR: implement maybe return expression
  * fix external function calls
  * IR: panic with a TODO instead of generating invalid code
  * IR: add more instructions
  * IR: fix switching on enum
  * IR: fix compile time switch eval for enums
  * IR: fix `this` expression
  * IR: consolidate Ref and PrefixOpAddressOf instructions
  * IR: allow undefined compile time values sometimes
  * IR: support var type args and fix phi peer type resolution
  * IR: make generic function type have zero_bits flag
  * IR: unreachable has lowest priority when resolving peer types
  * IR: update some std code to newest zig
  * IR: add runime negation
  * IR: fix type of decls accessed via namespace
  * IR: basic support for implicit casting to const pointer
  * IR: fix container field access via container pointer
  * IR: fix err variable in ErrOkOr instruction
  * IR: phi instruction handles unreachable values correctly
  * IR: fix codegen of ref instruction
  * IR: all structs anonymous
  * hello.zig working with all structs anonymous
  * IR: ability to return a container from a function
  * remove duplicate definition of container_string
  * IR: memoize compile-time evaluated fn invocations
  * IR: add FnProto instruction
  * workaround for Arch being a primitive type
  * IR: add MaybeOkOr instruction
  * errors from inline fn calls include stack trace
  * better error message generic instantiations
  * IR: if and switch guaranteed compile time if target expr is
  * IR: start a new passing self hosted test suite
  * organize tests
  * IR: support error defers
  * IR: support maybe defers
  * IR: update all error messages to be useful if generic instantiation
  * IR: fix lazy eval of enum field access
  * IR: enum init support
  * IR: implement runtime enum init and switch on enum with variable
  * get_error_type calls ensure_complete_type on child
  * IR: fix phi instruction when one of the predecessors is unreachable
  * update more std library to new zig
  * IR: fix compile time evaluation of else prong in switch
  * migrate all the temporary tests to new test file
  * IR: port some tests
  * pass void parameters test
  * IR: port some tests
  * IR: port more tests
  * IR: port more tests
  * IR: fix switch enum variable for void enum field
  * IR: port another test
  * IR: fix missing implicit casts in init expressions
  * port more tests
  * IR: support const ref
  * IR: support compile time global pointer reinterpret
  * IR: port more tests
  * IR: port more tests
  * IR: pass enumToInt test
  * IR: port more tests
  * IR testing: rename cases3 dir to cases
  * IR: pass explicitCastMaybePointers test
  * IR: pass genericMallocFree test
  * IR: port more tests
  * IR: pass staticEvalListInit test
  * IR: port all passing tests over
  * IR: pass intToPtrCast test
  * IR: pass pointerComparison test
  * IR: pass cStringConcatenation test
  * IR: pass intToEnum test
  * IR: pass castSliceToU8Slice test
  * IR: pass passSliceOfEmptyStructToFn test
  * IR: pass pointerToVoidReturnType test
  * IR: pass genericFnWithImplicitCast test
  * rename self_hosted3 to self_hosted
  * IR: error for returning from defer expression
  * IR: better basic block dependency detection
  * IR: handle phi instruction with 0 resulting incoming values
  * eradicate use of zeroes in std
  * IR: add error for goto jumping over variable declaration
  * IR: implement binary not instruction
  * IR: progress toward compiling standard library
  * IR: std makes it to codegen
  * IR: std library passes codegen
  * fix debug information for function pointers in structs
  * IR: add unreachable code compiler error
  * IR: pass MT19937_64 test
  * fix mem.sliceAsInt regression
  * containers created during eval get names for parameters
  * fix mul and sub overflow ops being rendered as addition
  * fix hash map implementation
  * self hosted tests import std library
  * pass undeclared identifier test
  * pass unreachable variable test
  * fix compiler rt
  * pass cannot assign to constant test
  * pass array access compile error tests
  * pass more tests by updating expected error messages
  * pass more tests
  * don't mark call instruction as generated
  * add compile error for initializing struct with non struct type
  * pass conflicting variable name test
  * don't try to eval extern functions at compile time
  * fix some tests
  * fix unable to eval const expr test case
  * pass unnecessary if statement test
  * pass division by zero test
  * partially fix parseh command
  * IR: implement error for missing or extra switch prongs
  * fix a few tests
  * better error message for unable to eval const expr
  * fix some tests
  * pass more tests
  * pass some parseh tests
  * IR: implement macro for function aliasing function pointer
  * IR: fix array concatenation
  * fix use decl regression
  * fix crash when casting fn call arg
  * fix some bugs with structs
  * fix some stuff when llvm has assertions on
  * fix enum codegen and implement comptime switch var on enums
  * fix handling of invalid enumeration
  * fix llvm assertion failure for zero bits structs
  * fix get_maybe_type not ensuring complete child type
  * fix array of enums. also render debug info for const vars
  * fix handling of const values for 2d arrays
  * add test for short-circuit AND and OR assignment
  * implement error when assigning to field of const struct
  * equality comparison of void types is known at compile time
  * ability to equality compare with null
  * add test for compile time bool not operator
  * add test for compile error returning from defer expression
  * get rid of zeroes literal
  * use comptime instead of inline for var and params
  * introduce comptime expression
  * remove staticEval builtin in favor of comptime expression
  * mem.free no longer requires explicit type argument
  * update charToDigit to take advantage of switch syntax
  * basic support for functions with variable length arguments
  * various fixes
  * printf var args proof of concept
  * update cat example code
  * fix runtime branching tricking the comptime evaluation
  * fix behavior for comptime and runtime basic block phi
  * fix sometimes using wrong outer scope for generating defers
  * fix compile time initialization of array with undefined
  * fix crash when assigning too large value to integer
  * readme update
  * add integer literal to pointer explicit cast
  * fix crash when passing void to var args function
  * fix var args allocating wrong amount of memory in compiler
  * document setDebugSafety builtin function
  * prefix op maybe and error are for types only
  * remove ability to mark if and switch as inline
  * fix behavior when initializing struct with undefined
  * fix ability to call method on variable at compile time
  * add try expression
  * update outdated comment
  * make --target-os freestanding work
  * implement packed structs
  * exported global variables get emitted as external in LLVM
  * typedefs work for binary math operations
  * add ability to set linker script
  * add setGlobalAlign and setGlobalSection builtin functions
  * add volatileStore() builtin function
  * in freestanding environment, assume gnu binutils
  * preserve names of exported variables
  * ability to set global variable alignment and ...
  * add compile error when setting non power of 2 alignment
  * remove volatileStore builtin; add volatile pointers
  * memcpy and memset builtins support volatile pointers
  * inline assembly supports `%=` syntax
  * memset and memcpy implementations need not return dest
  * infer hard float from target environments that imply it
  * even external functions which provide definitions get nounwind
  * setGlobalSection and setGlobalAlign work for functions
  * `%=` in inline assembly survives optimization
  * all functions are nounwind because zig does not support exceptions
  * fix volatile not respected for loads
  * delete unneeded IR code and fix assigning to const ptr
  * use printf in test runner code
  * tell LLVM the target sub arch type
  * try expression can omit variable assignments
  * fix assigning to const ptr through struct or index
  * fix volatile not respected for storing through a struct pointer
  * improved behavior on debug safety crash
  * coldcc works better
  * variables, memcpy, and memset all get alignment
  * inline assembly allows clobbers with no input
  * std.io supports printing integers as hex values
  * lots of miscellaneous things all in one big commit
  * remove the depends_on_compile_var code
  * zig logo in readme
  * rework compile-time known pointer values
  * fix crash on string literal with character code >= 128
  * std.io.parseUnsigned buf parameter is const
  * slice and array re-work plus some misc. changes
  * printf: only include + sign on signed ints if width specified
  * fix tokenization assertion failure on some float numbers
  * fix crash when return value is ??void
  * add runtime debug safety for dividing integer min value by -1
  * ability to declare const bitfields
  * move int and array types to central table
  * move volatile pointers to central type table
  * reading from a bit field partially works
  * support arithmetic for non byte aligned integer types
  * ability to write to bit fields
  * pointers with bit offset contain length
  * fix assertion failure when first use of a struct is sizeOf
  * more robust detection of types that failed to resolve
  * correct size of types for packed structs
  * bitfields support for array of non-store-aligned packed structs
  * fix regression with bit fields that align properly
  * fix wrong format specifier
  * update std code for MacOS
  * fix use decls not always working
  * add character format specifier to std.io.OutStream.printf
  * add compile error for control flow using comptime var at runtime
  * add compile error for ignoring return value
  * fix unwrap error payload not emitting debug safety
  * unwrap error payload instruction has side effects only if safety check on
  * README: more robust suggested configuration command
  * fix examples
  * add passing test for floating point edge case
  * more robust const struct values
  * fix inability to write to global in some cases
  * rename CBuf to Buffer0 and some minor std API changes
  * fix assertion failure for some switch errors
  * add compile error for assigning number literal to non-comptime var

  [ Jackie Meggesto ]
  * Fix unused return value in darwin.zig

  [ Andrew Kelley ]
  * remove zeroes from vim syntax file
  * add basic emacs syntax file
  * fix assertion error, trying to dereference to array
  * fix a case of invalid ptr const-ness
  * support passing var args directly
  * break off some of std.io into std.fmt, generalize printf
  * update to llvm 4.0
  * fix not allocating enough memory for passing args
  * add default value for macosx version min when compiling natively
  * codegen nullable void the same way as bool
  * types with zero bits do not have a pointer handle
  * use lld instead of system linker
  * add --each-lib-rpath option and corresponding config option
  * fix behavior with reinterpreting constant memory
  * introduce new test syntax
  * lazy analysis of top level declarations
  * fix test regression regarding shadowing names
  * unify main entry point regardless of whether linking libc
  * on Darwin/MacOS/iOS, add c to link libs implicitly
  * improvements for windows and libc integration
  * don't mangle symbols with underscores
  * use intel dialect for inline assembly
  * introduce copyable concept
  * add test for implicit conversion from array to mutable slice
  * add comptime top level declaration
  * new unreachable syntax
  * replace "&&" and "||" with "and" and "or"
  * organize std and make import relative to current file
  * add comptime eval for some uint comparisons with 0
  * update langref
  * add debug safety checks for remainder division
  * add stack protector safety when linking libc
  * std/mem: take advantage of new printf

  [ Josh Wolfe ]
  * fix cmake finding dependencies for ubuntu

  [ Andrew Kelley ]
  * first pass at zig build system
  * change `@bitcast` to `@ptrcast`

  [ Josh Wolfe ]
  * ignore eclipse project configuration
  * clean up analysis of {blocks}
  * show implicit semicolon rules in langref grammar
  * Require top-level-declaration comptime use {}
  * fix confusion in block expression parsing
  * variable declarations must be followed by semicolon
  * allow implicit semicolon after defer {}
  * add secret void expression after defer statement if it's the last statement in a block
  * defer without a block body requires a following semicolon
  * fix else-if parsing

  [ Andrew Kelley ]
  * zig build system progress
  * expose environment variables in standard library
  * proof of concept build system
  * zig build system: add setLinkerScript and setTarget
  * delete alloca builtin function
  * fix std build for darwin
  * link: delete code that checks the linker version
  * API for command line args
  * zig build system improvements, add some std API
  * zig build system: delete ./build file on success
  * link: fix ignoring first linker arg
  * link: correctly print debug linker invocation
  * zig build system: fix cleanup on error, report spawn error
  * doc: link to Andrea's emacs mode
  * support module level assembly
  * more accurate detection of pub main
  * fix crash when referencing invalid member of builtin enum
  * ability to use zig as an assembler
  * add support to use zig as a linker driver
  * std: ChildProcess.spawn looks at PATH env var
  * Update zig build system to support user defined options
  * zig build: use -D for options instead of -O
  * fix runtime struct initialization of bitfield
  * peer resolve types [N]T, [M]T as []const T
  * fix var args having wrong index when runtime param before it
  * add compile error for the bug of unable to call var ags at compile time
  * ability to implicitly cast integer literal to &const Int
  * fix std.mem.IncrementingAllocator
  * allow implicit cast from `[N]T` to `&const []const T`
  * add enumTagName builtin function
  * fix mangling exported global variables
  * fix for loops not working at compile-time
  * fix some -Wconversion errors
  * run alwaysinline pass in debug mode
  * zig build system writes template build.zig file when none exists
  * try harder to find lld
  * build: ignore libLLD.so when it is a broken symlink
  * ability to inline at function callsite
  * fix crash when using zig to link

  [ Josh Wolfe ]
  * make it an error to ignore a statement's value
  * block statement lists never get fake expressions

  [ Andrew Kelley ]
  * typedefpocalypse
  * all internal functions get unnamed_addr attribute
  * move emacs/vim files to separate repos
  * zig build system understands the concept of dependencies

  [ Josh Wolfe ]
  * comptime ({}) should not get an implicit semicolon
  * add tests for implicit semicolon. closes #297

  [ Andrew Kelley ]
  * zig build system: ability to link against dynamic library step
  * improvements to zig build system and unwrap error safety
  * zig build system: implement custom command step
  * zig build system: progress toward install and uninstall
  * build examples in ./run_tests
  * zig build system creates symlinks atomically
  * add compile error for intToPtr with a 0-bit ptr

  [ Raul Leal ]
  * Implicit cast from T to %?T

  [ Andrew Kelley ]
  * minor clean ups from previous commit
  * rename `@intType` to `@IntType` to follow convention
  * add `@fieldParentPtr` builtin function
  * std.rand API follows idiomatic convention for init
  * bail out of analysis on first error during comptime eval
  * error when building exe with no entry point
  * convert compare-output tests to use zig build system
  * convert build examples tests to zig build system
  * convert std lib tests to zig build system
  * remove unused test code
  * update zig build help text when no build.zig found
  * convert assemble and link tests to zig build system
  * convert debug safety tests to zig build system
  * test framework supports name prefix and filter argument
  * convert parseh tests to zig build system
  * delete test_artifacts directory when tests complete

  [ Raul Leal ]
  * Add @offsetOf builtin function

  [ Andrew Kelley ]
  * add compile error tests for offsetOf builtin
  * zig build system supports building a library
  * add example which exercises addObject in the zig build system
  * rename `@ptrcast` to `@ptrCast` to follow convention
  * add Travis CI integration
  * std: fix PATH resolution when spawning child
  * remove `?return` and `?defer`
  * update syntax for try and nullable unwrapping
  * std.os.ChildProcess: fix closing wrong file descriptors
  * add peer type resolution for T and ?T
  * slicing now returns correct const-ness
  * new compile errors for setGlobalAlign and setGlobalSection builtins
  * fix crash when unwrapping error with no error decls
  * zig build system: installFile and installClibrary

  [ Josh Wolfe ]
  * add test_artifacts to .gitignore, so you can commit while tests are running
  * remove redundant unreachable code error
  * refactor ir_gen_block to make different return paths more clear

  [ Andrew Kelley ]
  * make undefined as a constant value lazy

  [ Josh Wolfe ]
  * blocks check that their statements are void
  * fix check-statement-is-void. add tests
  * defer requires expr to be void. closes #341

  [ Andrew Kelley ]
  * better stack traces for ELF x86_64
  * stack traces support compile units with no pc range
  * update README
  * readme update
  * readme update
  * update travis badge to new url
  * add some timing diagnostics
  * compile time improvement - add __zig_panic_slice fn
  * compile time improvement - move overflow math safety to fns
  * compile time improvement - move bounds checking to function calls
  * revert the last 3 compile time improvements
  * build system: addAssembly and addObject functions
  * build system: consolidate duplicate code and more
  * zig test no longer requires a separate test_runner.o file
  * add no-elim-base-pointer to __zig_fail function
  * add compile error for returning local variable address
  * phi instruction retains stack ptr hint
  * zig puts temporary object files in zig-cache folder
  * build system: remove setLinkerScriptContents
  * add implicit cast from [0]T to %[]T
  * back to AT&T syntax for assembly
  * add peer type resolution `[]T` and `[0]T`
  * zig build: when compiling C files put .o files in cache dir
  * zig build: organize build artifacts
  * zig build: refactor CLibrary and CExecutable into same struct
  * fix regression from previous commit
  * zig build can build and install static C libraries
  * zig build: improved API for installing C build artifacts
  * zig build: support install for zig artifacts
  * `@import("builtin")` instead of `@compileVar`
  * basic support for specifying packages at the command line
  * make debug safety stuff lazy
  * allow undefined to be resolved with other types
  * fix compiler crash when referencing a variable...
  * add safe release build mode
  * fix debug info for nullable type
  * zig build: copy args for addCommand
  * slightly better memset/memcpy implementation
  * zig build: inherit stdin for running commands

  [ Andrea Orru ]
  * Generic doubly linked list. (#361)

  [ Andrew Kelley ]
  * zig build: cache_root is relative to build_root
  * add compile error for shadowing variable
  * remove test and try expressions in favor of if expressions
  * change while syntax
  * implement while for nullables and error unions
  * std: take advantage of new while syntax
  * implement else on loops and break can give an expression
  * std: rename List to ArrayList and re-organize...
  * add compile error when unable to inline a function
  * builtin functions for division and remainder division
  * allow division and remainder operators sometimes
  * switch expression - add compile errors
  * fix comptime switch on enum with ref payload
  * add test case for all prongs unreachable in switch
  * detect duplicate switch value even when else prong present
  * update README
  * fix inability to initialize global pointer to global array element
  * rename c_long_double to c_longdouble
  * std.fmt.format prints bool values
  * delete @generatedCode builtin function
  * move docs to ziglang.org
  * zig build: allow calling b.standardReleaseOptions...
  * ability to slice ptr to hard coded integer at comptime
  * inline function call with builtin function instead...
  * add compile error for casting negative value to...
  * add compile error for comptime division by zero
  * fix printf format specifier
  * add compile error for compile-time integer cast truncating bits
  * typeId builtin instead of isInteger, isFloat, etc
  * change slicing syntax from ... to ..
  * add setFloatMode builtin and std.math.floor
  * flip the enum order of FloatMode
  * fix compiler crash when indexing types
  * add error for break/continue exiting defer expression
  * add compile error for goto leaving defer expression
  * building with mingw for windows
  * std.fmt can print nullables, errors, and error unions
  * clean up behavior test names
  * fix segfault with array of variadic functions
  * fix segfault with array of generic functions
  * implicitly cast by value var args parameters to const references
  * const global values can reference each other

  [ Andrea Orru ]
  * Generalize join.
  * Updated comment.

  [ Andrew Kelley ]
  * fix crash when unwrapping optional field of global variable
  * fix crash when writing to const hardcoded ptr
  * change std.rand.Rand.rangeUnsigned to std.rand.Rand.range
  * add appveyor integration testing
  * compileError builtin includes "referenced by" notes
  * progress toward hello world without libc in windows
  * progress toward windows hello world working
  * partial implementation of printing floating point numbers with errol3
  * fix compiler segfault on `null ?? x`
  * fix alignOf builtin

  [ Marc Tiehuis ]
  * Add math library

  [ Andrew Kelley ]
  * parseh: fix not recognizing integer suffixes on hex numbers
  * update C headers to clang 4.0.0
  * fix peer type resolution for array and error

  [ scurest ]
  * allow trailing commas

  [ Andrew Kelley ]
  * std: refactor pow to be generic

  [ Marc Tiehuis ]
  * Get tests passing under release mode

  [ Andrew Kelley ]
  * build: link against system libs reported by llvm-config
  * workaround for llvm bug
  * don't call c.getrandom because older libcs don't have it

  [ Marc Tiehuis ]
  * Add math special case tests and general fixes
  * Add install targets for math library files

  [ Andrew Kelley ]
  * fix incorrect install line in cmakelists

  [ Marc Tiehuis ]
  * Fixes for release mode tests
  * Fix scalbn constant multiplier
  * Fix pow tests
  * Return undefined in frexp instead of 0 on nan input

  [ Andrew Kelley ]
  * better bigint/bigfloat implementation
  * remove unused enum

  [ Marc Tiehuis ]
  * Add Visual Studio Code extension link

  [ Andrew Kelley ]
  * fix initializing undefined and crash when casting to invalid type
  * add missing stdcallcc to ExitProcess decl
  * remove duplicate gitignore entry
  * silence false positives about uninitialized variables
  * fix segfault when var args fn proto shows up in ir printing
  * fix invalid target info
  * fix constant debug info when number literal is 0
  * Revert "silence false positives about uninitialized variables"
  * limit generated C preprocessor tokens to alphabet

  [ Marc Tiehuis ]
  * Correct floating-point literal allowed ranges

  [ Andrew Kelley ]
  * add ability to explicitly cast float to integer
  * fix printing floating point compile errors
  * README: add the zen of zig
  * zen update
  * add ptrToInt builtin, remove usize(ptr) cast
  * more intuitive left shift and right shift operators

  [ Marc Tiehuis ]
  * Fix coverage build command

  [ Andrew Kelley ]
  * fix tokenization error pointing to wrong character
  * update gitignore
  * organize file path of compiler_rt
  * compiler_rt implementations for __fixuns* functions
  * fix wrong value for clz, ctz at compile time
  * add compiler_rt functions for f128
  * fix big integer shifting by large number
  * fix bitCast for big integers
  * make casting between __float128 and long double explicit
  * cast between __float128 and double to fix build in some places
  * depend on libquadmath
  * remove dependency on quadmath.h
  * include compiler-rt tests in main testing suite
  * add compiler-rt fns: udivmodti4, udivti3, umodti3
  * make udivmod generic and add tests
  * slightly nicer floating point printing
  * bit shifting safety
  * add compile error for globally shadowing a primitive type
  * std: better int log2 implementation for number literals
  * add setEvalBranchQuota builtin function
  * fix floating point printing
  * compile-time f32, f64 operations are now correctly lossy
  * zen update
  * fix not propagating parseh aliases through pub use decls
  * move zen of zig to a sub command
  * std.math: remove constants that can be derived
  * more zen
  * move docs to website
  * fix compiler test errors
  * unreachable still codegens to unreachable in ReleaseFast test mode
  * refactor - codegen llvm functions lazily
  * fix some casts on const data causing segfault
  * implement comptime bitcasting from array
  * add zig-compiler-completions to Related Projects
  * float division by zero check only when FloatMode.Optimzed
  * update for llvm 5.0.0rc1
  * update travis for llvm 5
  * update build to look for llvm 5.0
  * fix invalid llvm IR for const enum
  * fix wrong switch target type with enum from .h file
  * add some asserts in switch analysis code
  * remove @alignOf and add @cAbiAlignOf and @preferredAlignOf

  [ scurest ]
  * use most_aligned_member+padding to represent enum unions

  [ Andrew Kelley ]
  * fixups from previous commit
  * codegen for enums chooses best order of tag and union fields
  * audit alignment for functions
  * progress toward tests passing on MacOS
  * fixups to linux build
  * travis: add macos script
  * travis try again
  * travis again
  * macos updates
  * all behavior tests passing for macos
  * macos passing all tests except for building a shared library
  * all tests passing in MacOS
  * embed LLD 5.0.0
  * LLD: apply "[MACH-O] Fix the ASM code generated...
  * LLD: workaround for buggy MACH-O code
  * build: use embedded LLD by default
  * remove remnants of depending on darwin system linker
  * travis: use external lld for apple
  * build: fix embedded LLD build
  * travis: use external lld for linux
  * remove workaround for LLVM not respecting "nobuiltin"
  * introduce align keyword
  * fix bitfield pointer syntax
  * pass all tests without triggering assertions
  * prevent implicitly increasing pointer alignment
  * ptrCast gives compile error for increasing alignment
  * fix tests
  * more alignment improvements
  * add test for @alignCast on a slice
  * add tests for function alignment handling
  * add "child" field to pointer type
  * generic functions can access comptime args in align value
  * @ptrCast preserves larger alignment if applicable
  * when getting an element pointer, use the best alignment
  * add alignment field to pointer type
  * compile error for not-aligned-enough pointer to cmpxchg
  * set alignment on all loads and globals
  * codegen: all stores specify align value
  * align syntax: align(4) instead of align 4
  * test suite cross-compile builds tests for other targets
  * tests use darwin, not macosx since that's what macbook reports as
  * travis: skip cross compiling osx tests
  * LLD: fix libCOFF calling exit() instead of return
  * successfully cross-building behavior tests for windows
  * compiler-rt: add __aeabi_uldivmod
  * add windows to test targets
  * allow array literals to have size and fix comptime bug
  * setEvalBranchQuota must be called from top of comptime stack

  [ Raul Leal ]
  * Opaque ptr patch

  [ Andrew Kelley ]
  * only export __chkstk for windows

  [ Josh Wolfe ]
  * fix return types of min amd max
  * Revert "fix return types of min amd max"

  [ Andrew Kelley ]
  * c-to-zig: return statement
  * c-to-zig: less than, negation, ternary

  [ Josh Wolfe ]
  * cleanup whitespace

  [ Andrew Kelley ]
  * parseh: emit_warning takes SourceLocation
  * here, have trans_qual_type

  [ Josh Wolfe ]
  * start implementing variable declaration translation
  * progress toward variable declaration translation
  * translate some variable declaration cases
  * translate while loops and implicit bitcasts

  [ Andrew Kelley ]
  * rewrite parseh to use AST instead of direct types
  * fix parseh bugs
  * parseh: fix generating functions from macros
  * parseh tests passing
  * parseh: remove unneeded hash tables
  * parseh: fix duplicate definitions
  * fix void return node and param name nodes, fix dupe macros
  * add OpaqueType builtin
  * rename parseh to parsec
  * travis: use embedded LLD and perform all tests
  * parsec: turn panics into warnings
  * better build.zig template
  * std: add os.sleep
  * std: add ChildProcess.kill
  * README: add notepad++ syntax highlighting project
  * std: os.ChildProcess knows when its child died
  * fix ChildProcess.spawn on darwin
  * std.os.ChildProcess: don't expect all SIGCHLD to come from spawn
  * std.ChildProcess.spawn: handle 0 from waitpid correctly
  * fix std.Buffer.endsWith

  [ Jonathan Marler ]
  * Switched find order for llvm, means it will choose llvm version 5.0 before any other version. (#446)

  [ Marc Tiehuis ]
  * Add exit function (#450)
  * Add appendSlice function (#448)

  [ Andrew Kelley ]
  * build: add more search paths for libclang
  * std.fmt knows how to format &[N]u8
  * more compile errors for non-const variables of things
  * rename some behavior tests
  * add import test
  * support parens in C macros
  * variables are allowed to be pointers to opaque

  [ jean-dao ]
  * std.io.InStream: add readLine function (#458)

  [ Jonathan Marler ]
  * Allow INVALID_HANDLE_VALUE for windows to work on 32-bit and 64-bit. (#457)

  [ Andrew Kelley ]
  * fix not verifying GlobalLinkage and AtomicOrder types
  * fix uninitialized variable

  [ jean-dao ]
  * c macros: support hex chars (#459)

  [ Jonathan Marler ]
  * Add support for MSVC
  * Modified cmake to use LLVM imported packages.

  [ Andrew Kelley ]
  * local var

  [ Josh Wolfe ]
  * wip c to zig stuff
  * not my segfault
  * oh, actually it was

  [ Andrew Kelley ]
  * fix error messages

  [ Josh Wolfe ]
  * analysis of result used

  [ Andrew Kelley ]
  * fix up msvc stuff to make it work on linux and macos too
  * add Child property of slice type

  [ Jonathan Marler ]
  * Fixed a couple compilation errors for MSVC 64-bit (#475)

  [ Andrew Kelley ]
  * add SoftFloat-3d
  * depend on embedded SoftFloat-3d instead of __float128
  * do not depend on __int128
  * bump incrementing allocator memory in build system to 20MB

  [ Jonathan Marler ]
  * Fixed softfloat header file for msvc (#482)

  [ Marc Tiehuis ]
  * Add dash arguments for cli

  [ Andrew Kelley ]
  * add release-safe to the test matrix
  * std.os.ChildProcess: fix fd leak
  * add option to run tests in LLDB and turn it on for macos travis
  * fix use of uninitialized variable in alignCast
  * add -mllvm support
  * fix build for travis osx
  * fix crash when enum has invalid field
  * zig build: use stack protector for C code in debug mode
  * add test for struct with invalid field
  * std.build: simpler API
  * add macos instructions to readme
  * README: macos instructions: simplify
  * README: macos instructions: suggest running tests
  * std.build: explicitly disable stack protector when nostdlib
  * std.build: catch mistake of setting output path to build dir
  * add --verbose-link option
  * coff linking passes -DEBUG
  * std: fix os.sleep on darwin and windows

  [ Marc Tiehuis ]
  * Stop debug allocator ever panicking (#492)

  [ Andrew Kelley ]
  * parsec: don't make pointless block in fn body
  * all parsec tests passing

  [ Josh Wolfe ]
  * optimize >>= operator for common case
  * fix tests

  [ Andrew Kelley ]
  * parsec: cleaner shifting code for fixed size types

  [ Josh Wolfe ]
  * translate expr++ from c to zig

  [ Andrew Kelley ]
  * parse-c: fix anonymous enums
  * parse-c: support function calls

  [ Josh Wolfe ]
  * if statement
  * add some tests
  * logical and, logical or
  * ==, !=

  [ Andrew Kelley ]
  * parse-c: field access expressions
  * parse-c: null statements

  [ Josh Wolfe ]
  * bitwise binary operators
  * assign

  [ Andrew Kelley ]
  * parse-c: fix undefined array literals

  [ Josh Wolfe ]
  * add sub mul div rem

  [ Andrew Kelley ]
  * parse-c: array access expression

  [ Josh Wolfe ]
  * fix assignment needing an lvalue

  [ Andrew Kelley ]
  * parse-c: support c style cast
  * parse-c: support implicit cast to void *
  * parse-c: support sizeof

  [ Josh Wolfe ]
  * chain assignment
  * fix chain assignment semicolon

  [ Andrea Orru ]
  * LinkedList helper functions (#493)

  [ Andrew Kelley ]
  * README: adds for contributors we want
  * macho linking: support full lib paths correctly
  * std.build: fix building C dynamic libraries on darwin
  * std.build: fix -install_name for darwin dynamic C linking
  * zig build: add linkFramework API
  * improvements to windows support
  * windows gui hello world
  * windows API functions are not stdcalls
  * Revert "windows API functions are not stdcalls"
  * fix i386 windows stdcall
  * fix docs
  * update std.os.ChildProcess API
  * std.os.ChildProcess: ability to set both uid and gid
  * add std.fmt.trim
  * std.os.ChildProcess: setgid before setuid
  * implement setreuid, setregid for darwin
  * add fmt.parseInt
  * README: we support x86_64 macos

  [ Josh Wolfe ]
  * add reset() method to IncrementingAllocator (#501)

  [ Andrew Kelley ]
  * add test for std.mem.IncrementingAllocator
  * implement IncrementingAllocator for Windows

  [ Marc Tiehuis ]
  * Allow 128-bit hex float literals

  [ Andrew Kelley ]
  * fix build on mingw
  * simpler cmake for msvc
  * better implementation of os_spawn_process for windows
  * add ___chkstk_ms compiler-rt function
  * fix previous commit
  * compiler-rt: add _aulldiv and _aullrem for i386 windows
  * disable /W4 on MSVC
  * better output for cross platform zig test on windows
  * zig test on 64-bit windows runs 32-bit tests
  * workaround for invalid binary created on windows
  * better divTrunc codegen
  * update C headers to clang 5.0.0
  * fix typo in target_can_exec logic
  * don't try to use cold calling convention on windows
  * remove zigrt
  * improve bit shift API in std.math
  * workaround llvm bug for windows alignment
  * fix codegen on windows
  * add windows 32 bit to test matrix
  * travis: fix typo in linux script
  * travis: older wine only works with i386 builds
  * travis: set -e on osx script
  * update hello world examples
  * build: escape backslashes in path arguments given to cmake
  * fix implementation of --zig-std-dir
  * fix build when no cmake path args specified
  * implement standard library path search
  * fix regression from previous commit
  * add git rev name to version string when available
  * support linking against MSVC libc
  * remove unused function
  * still build compiler-rt when linking msvc CRT
  * fix parse-c tests
  * better compiler-rt linkage logic
  * fix typo in compiler-rt
  * compiler-rt: strong linkage for __chkstk
  * support terminal colors for cmd.exe and msys pty
  * windows: alignstack=16 on every function
  * fix travis
  * add @setAlignStack builtin
  * replace __chkstk function with a stub that does not crash
  * use __chkstk_ms compiler-rt functions for __chkstk
  * fix tests on linux and macos
  * compiler-rt tests pass with and without libc
  * fix duplicated symbols in compiler-rt tests
  * fix mingw build

  [ Snorre ]
  * fix isatty for macOS and libc (#523)

  [ Andrea Orru ]
  * Fix for LLD on linker scripts with empty sections

  [ Andrew Kelley ]
  * fix compiler crash when invalid value used
  * better support table
  * implement os.path.dirname for windows
  * more std.os.path work for windows
  * os.path.basename implementation for windows
  * implement std.os.relative for windows
  * implement os.getCwd for windows
  * fix os.path.resolveWindows on non-windows
  * implement std.os.deleteFile for windows
  * implement os.path.real for windows and update allocator interface
  * fix build on non-windows
  * implement std.io.InStream for windows
  * use allocator.shrink instead of realloc in os.path.real
  * add module flag to emit CodeView for COFF object files
  * fix std.io.OutStream.close for windows
  * better abort() implementation for windows
  * implement command line argument parsing for windows
  * fix std.os.getRandomBytes for windows
  * implement std.os.ChildProcess for windows
  * implement os.makeDir for windows
  * fix os.makeDir for posix
  * organize windows utility functions
  * fix regressions from previous commit on windows
  * implement std.os.symLink for windows
  * implement std.os.rename  for windows
  * std.io: remove unused constants
  * implement io.OutStream.openMode for windows
  * build-exe allows direct export of WinMainCRTStartup
  * try harder to emit console colors
  * disable byval parameters on windows to work around llvm bug
  * std.mem.IncrementingAllocator: check for errors
  * implement environment variables for windows
  * fix regression on posix from previous commit
  * disable some of the failing tests
  * only SetConsoleTextAttribute to do console colors on windows
  * use correct integer type for windows BOOL
  * mingw build: delete unused variable
  * fix child process stdio piping behavior on windows
  * fix std.io.InStream for windows
  * fix posix from previous commit
  * std.io: fix bug when writing large buffer
  * set stdout and stderr to binary mode on windows
  * 16MB stack size when building with msvc
  * fix windows argument parsing
  * clean up some resources
  * LLD COFF: close handles to objects used to link
  * fix compare-output tests on windows
  * fix debug safety tests on windows
  * ability to make a DLL
  * fix regression on posix from previous commit
  * std.os.ChildProcess: on windows cwd affects exe search path
  * look for libc at runtime on windows
  * appveyor: build with msvc and publish artifacts
  * appveyor: update version to match zig version
  * fix codegen of enum name table having wrong LLVM types
  * add uwtable attribute to functions on windows

  [ Marc Tiehuis ]
  * Add c allocator (#542)

  [ Andrew Kelley ]
  * Release 0.1.0
  * build: fix logic for version when there is a git tag
  * Release 0.1.1
  * remove unsupported targets from readme
  * fix docs link
  * zig build: fix system libraries not respected for C artifacts
  * std.fmt.format supports ints smaller than u8
  * fix compiler crash regarding type name of undefined
  * report compile error instead of crashing for void in var args
  * parse-c: improve performance
  * self hosted zig: print usage

  [ scurest ]
  * Print better floats

  [ Andrew Kelley ]
  * add maximum value for @setAlignStack
  * remove CXX ABI workaround
  * wip self hosted code

  [ scurest ]
  * More corrections to float printing

  [ Andrew Kelley ]
  * fix missing compiler_rt in release modes
  * add some sanity tests for float printing
  * cleaner verbose flags and zig build prints failed command
  * fix crash on field access of opaque type
  * better output when @cImport generates invalid zig
  * add guard to c_headers for duplicate va_list on darwin

  [ Marc Tiehuis ]
  * Improve invalid character error messages (#566)

  [ Andrew Kelley ]
  * use llvm named structs for const values when possible
  * add test case for previous commit
  * delete -municode command line argument
  * breaking change to std.io API
  * fix windows build from previous commit

  [ Andreas Haferburg ]
  * Enforce "\n" line endings on Windows (#574)

  [ Dimenus ]
  * WIN32: Linking with the CRT at runtime. (#570)

  [ Andrew Kelley ]
  * bump build_runner allocator to use 30 MB
  * windows: use the same libc search within a compilation unit
  * update to llvm master
  * use llvm named structs for const values when possible
  * add missing environment
  * fix incorrect debug info for empty structs
  * fix incorrect debug info for empty structs
  * more compile-time type reflection

  [ Marc Tiehuis ]
  * Add emit command-line option (#580)

  [ dimenus ]
  * Add support for windows line endings with c macros
  * Windows libc & static libc are located in the same dir which is already covered by msvc_lib_dir

  [ Andrew Kelley ]
  * slightly more verbose error message when building object file fails
  * add compile-time reflection for function arg types
  * fix build on MacOS

  [ scurest ]
  * add test for c_allocator
  * fix redeclaration of mem (#585)
  * fix typos in std.io (#589)

  [ Andrew Kelley ]
  * add @memberType and @memberName builtin functions
  * std.io: introduce buffered I/O and change API
  * fix travis linux script
  * fix enum sizes too large
  * fix parameter of extern var args not type checked

  [ Jeff Fowler ]
  * fix typo on darwin lseek (#602)
  * Fix Stat include in darwin land (#605)

  [ Andrew Kelley ]
  * add a std lib test for reading and writing files
  * add windows implementation of io.File.getEndPos
  * fix bug when multiple function definitions exist
  * fix test failure on 32 bit windows
  * fix test failures
  * disable broken 32 bit windows test

  [ Brendon Scheinman ]
  * add epoll and timerfd support on linux

  [ Andrew Kelley ]
  * rename test
  * fix windows trying to run linux-only tests

  [ dimenus ]
  * Fixed duplicate decl detection for typedefs/enums
  * Fixed duplicate decl detection for typedefs/enums

  [ Josh Wolfe ]
  * parsec supports C NULL to pointer implicit cast
  * parsec supports C comma operator

  [ Andrew Kelley ]
  * add test case for previous commit

  [ Josh Wolfe ]
  * parsec supports bitshift operators
  * parsec supports more compound assign operators
  * parsec supports post increment/decrement with used result
  * parsec supports do loop

  [ Andrew Kelley ]
  * c-to-zig: handle UO_Deref
  * add docs for std.base64
  * basic union support
  * update fast math flags for latest llvm
  * unions have a secret field for the type
  * union secret field is the tag index instead of distinct type index
  * debug safety for unions
  * fix codegen for union init with runtime value
  * add documentation placeholders for unions

  [ dimenus ]
  * Added DLL loading capability in windows to the std lib.

  [ Andrew Kelley ]
  * add parse-c support for unions
  * parse-c: support address of operator

  [ Josh Wolfe ]
  * rework std.base64 api
  * move base64 functions into structs

  [ Andrew Kelley ]
  * rename "parsec" to "translate-c"
  * update homepage docs
  * translate-c: support pre increment and decrement operators
  * translate-c supports string literals
  * fix assertion failed when invalid type encountered
  * translate-c supports returning void
  * translate-c supports for loops
  * translate-c supports break and continue
  * add an assert to catch corrupted memory
  * fix crash when constant inside comptime function has compile error
  * translate-c: introduce the concept of scopes
  * translate-c: avoid global state and introduce var decl scopes
  * translate-c supports switch statements
  * translate-c: better way to translate switch
  * translate-c: fix translation when no default switch case
  * translate-c: support variable name shadowing
  * translate-c: support pointer casting

  [ dimenus ]
  * Added support for exporting of C field expressions

  [ Mason Remaley ]
  * Implements translation for the prefix not operator (#628)

  [ Andrew Kelley ]
  * translate-c: fix sometimes getting (no file) warnings
  * translate-c: detect macros referencing field lookup
  * translate-c: fix clobbering primitive types
  * translate-c: support const ptr initializer
  * update fast math llvm API to latest

  [ Josh Wolfe ]
  * fix os.Dir compile errors
  * add Buffer.appendFormat()

  [ Andrew Kelley ]
  * better error code for File.getEndPos failure
  * fix capturing value of switch with all unreachable prongs
  * translate-c: support static incomplete array inside function
  * fix build broken by previous commit

  [ Josh Wolfe ]
  * add mem.readIntLE and readIntBE

  [ Andrew Kelley ]
  * ability to specify tag type of enums
  * packed structs can have enums with explicit tag types
  * translate-c: only emit enum tag type if not c_int or c_uint
  * updated embedded LLD to 5.0.1rc2
  * LLD patch: COFF: better behavior when using as a library
  * LLD patch: Fix for LLD on linker scripts with empty sections
  * LLD patch: workaround for buggy MACH-O code
  * LLD patch: Fix the ASM code generated for __stub_helpers section
  * update c_headers to llvm 5.0.1rc2
  * update to LLVM 5.0.1rc2

  [ Josh Wolfe ]
  * implement insertion sort. something's broken
  * todo: fix #639

  [ Andrew Kelley ]
  * casting between integer and enum only works via tag type
  * ability to set tag values of enums
  * rework enums and unions and their relationship to each other
  * rename @EnumTagType to @TagType. add tests for union-enums
  * fix abi alignment of union-enums not counting tag type
  * more tests for unions
  * update docs regarding enums and unions
  * add test for @sizeOf on extern and packed unions
  * add test for union with 1 void field being 0 bits
  * fix build on windows
  * add test for casting union to tag type of union

  [ MIURA Masahiro ]
  * Fix the color of compiler messages for light-themed terminal.

  [ Andrew Kelley ]
  * rename builtin.is_big_endian to builtin.endian
  * fix incorrect LLVM IR for union constant when active field is void
  * read a file
  * simple tokenization
  * tokenizing string literals
  * tokenizing basic operators
  * tokenizing hello world
  * parser skeleton
  * translate-c: fix not printing clang errors
  * fix casting integer literal to enum
  * add implicit cast from enum to union
  * revert to master branch ir.cpp, fixes issue better than this branch
  * allow implicit cast from union to its enum tag type
  * allow union and its tag type to peer resolve to the tag type
  * fix enum with 1 member causing segfault
  * switch on enum which only has 1 field is comptime known
  * fix regressions from previous commit
  * add higher level arg-parsing API + misc. changes
  * upgrade to new args api
  * awkward void union field syntax no longer needed
  * translate-c: refactor prefix and suffix op C macro parsing
  * translate-c: support macros with pointer casting
  * translate-c: more complex logic for translating a C cast in a macro
  * add implicit cast from enum tag type of union to const ptr to the union
  * parse a simple variable declaration
  * tokenizing libc hello world
  * partial parameter decl parsing
  * parsing an extern fn declaration
  * rename @EnumTagType to @TagType in type names
  * mem.Allocator initializes bytes to undefined
  * rendering source code without recursion
  * add self-hosted parsing and rendering to main tests
  * self-hosted: parse var decls
  * self-hosted: parse variable declarations with types
  * self-hosted: clean up parser
  * self-hosted: parsing and rendering blocks
  * self-hosted: workaround for issue #537
  * self-hosted: refactor into multiple files
  * refactor debug.global_allocator into mem.FixedBufferAllocator
  * self-hosted: test all out of memory conditions
  * self-hosted: link with LLVM
  * stack traces: support DW_AT_ranges
  * self-hosted: move code to std.os.ChildProcess.exec
  * self-hosted: cleanup build looking for llvm-config
  * self-hosted: build tries to find llvm-config.exe
  * self-hosted: look for llvm-config in homebrew

  [ Josh Wolfe ]
  * self-hosted: implement addr of align parsing
  * self-hosted: implement var decl align

  [ Andrew Kelley ]
  * add test for allowing slice[slice.len..slice.len]
  * fix const and volatile qualifiers being dropped sometimes
  * fix compiler crash in a nullable if after an if in...
  * replace quicksort with blocksort
  * disable sort tests for 32-bit windows because of issue #537
  * fix missing import from previous commit
  * change mem.cmp to mem.lessThan and add test

  [ Josh Wolfe ]
  * roughly parsing infix operators

  [ Andrew Kelley ]
  * fix std.mem missing error.OutOfMemory decl
  * wip export rewrite
  * wip bring back export keyword
  * export keyword works again
  * bring back code that uses export and fix tests
  * add sort.min and sort.max functions to stdlib
  * fix assert when wrapping zero bit type in nullable
  * fix crash when implicitly casting array of len 0 to slice
  * add labeled loops, labeled break, labeled continue. remove goto
  * explicitly return from blocks
  * fix darwin and windows from previous commit

  [ Josh Wolfe ]
  * bufPrint returns an error

  [ Andrew Kelley ]
  * std.math: remove unnecessary inline calls and
  * fix endianness of sub-byte integer fields in packed structs
  * port most of main.cpp to self hosted compiler

  [ Josh Wolfe ]
  * source files must end with newline

  [ Andrew Kelley ]
  * std.os.path.resolve handles an absolute path that is missing the drive
  * build: add --search-prefix option

  [ Josh Wolfe ]
  * [self-hosted] tokenizer error for ascii control codes

  [ Andrew Kelley ]
  * build: findLLVM correctly handles system libraries
  * translate-c: set up debug scope for translated functions
  * std.os.path.resolve handles an absolute path that is missing the drive
  * build: add --search-prefix option
  * build: findLLVM correctly handles system libraries
  * translate-c: set up debug scope for translated functions
  * move std/debug.zig to a subdirectory

  [ Josh Wolfe ]
  * debug needs to export FailingAllocator
  * [self-hosted] source must be valid utf8. see #663
  * add source encoding rules to the docs. see #663

  [ Andrew Kelley ]
  * docs: fix typo
  * fix segfault when passing union enum with sub byte...
  * self-hosted: build against zig_llvm and embedded LLD

  [ Josh Wolfe ]
  * set compile flags for zip_cpp
  * move utf8 parsing to std
  * fix self-hosted parser test

  [ Peter Rönnquist ]
  * Added format for floating point numbers. {.x} where x is the number of decimals.

  [ Andrew Kelley ]
  * ir: new pass iteration strategy
  * doc fixes
  * add test for while respecting implicit comptime
  * add noInlineCall to docs
  * fix self hosted compiler on windows
  * readme: update macos installation instructions
  * enum tag values are expressions so no parentheses needed
  * add building the self hosted compiler to the main test suite
  * build: std files and c header files are only specified once
  * add december in review to reading material; fix docs
  * self-hosted build: use llvm-config from stage1
  * fix self-hosted build on windows
  * self-hosted compiler works on windows
  * self-hosted compiler works on macos
  * fix test regressions on windows from previous commit
  * appveyor ci: look for newer windows sdk version
  * try using appveyor's llvm copy
  * Revert "try using appveyor's llvm copy"
  * update windows build to llvm 5.0.1
  * appveyor: set VCINSTALLDIR
  * appveyor: try using vcvarsall
  * appveyor: skip building self hosted compiler for now
  * Revert "appveyor ci: look for newer windows sdk version"
  * appveyor: enable verbose link for self hosted compiler
  * workaround for microsoft releasing windows SDK with wrong version
  * translate-c: update to clang 6.0.0 which has more binary operators
  * disable NewGVN
  * fix exp1m implementation

  [ Jimmi Holst Christensen ]
  * Fixed the call to mem.readInt in Rand.scalar
  * Fixed the call to mem.readInt in endian.swap

  [ Andrea Orru ]
  * Darwin -> MacOSX, added Zen. See #438

  [ Andrew Kelley ]
  * fix struct inside function referencing local const
  * add a test for returning a type that closes over a local const
  * update hello world docs

  [ Andrea Orru ]
  * Adding zen support

  [ Andrew Kelley ]
  * replace `%return` with `try`
  * replace `a %% b` with `a catch b`
  * `a catch unreachable` generates unwrap-error code

  [ Andrea Orru ]
  * exit, createThread for zen

  [ Andrew Kelley ]
  * remove %% prefix operator

  [ Andrea Orru ]
  * Intrusive linked lists

  [ Marc Tiehuis ]
  * Add hw sqrt for x86_64
  * Fix endian swap parameters

  [ Andrew Kelley ]
  * the same string literal codegens to the same constant
  * functions which can return errors have secret stack trace param
  * *WIP* proof of concept error return traces

  [ Marc Tiehuis ]
  * Add integer rotation functions
  * Add Md5 and Sha1 hash functions

  [ Andrew Kelley ]
  * typecheck the panic function

  [ Marc Tiehuis ]
  * Add Sha2 functions
  * Change indexing variable types for crypto functions
  * Disable win32 tests for Sha2 + correct lengths

  [ Andrew Kelley ]
  * fix duplicate stack trace code
  * error return trace pointer prefixes other params
  * remove 32-bit windows from supported targets list
  * error return traces use a zig-provided function to save binary size
  * stack traces are a variable number of frames
  * clean up error return tracing
  * add builtin.have_error_return_tracing

  [ Marc Tiehuis ]
  * Add Blake2X hash functions

  [ Andrew Kelley ]
  * fix getting debug info twice in default panic handler
  * fix compiler crash related to @alignOf
  * implement bigint div and rem
  * fix bigint remainder division

  [ Marc Tiehuis ]
  * Change crypto functions to fill a buffer
  * Add crypto internal test functions

  [ Jimmi Holst Christensen ]
  * Output "undefined" on uninitialized variables
  * Fixed tests for undefined variables
  * translate_c can now translate if statements on integers and floats

  [ Josh Wolfe ]
  * Buffer.toSliceCopy
  * Revert "Buffer.toSliceCopy"

  [ Andrew Kelley ]
  * fix error return traces pointing to off-by-one source line
  * docgen auto generates table of contents
  * docgen: validate See Also sections
  * docgen: support executing exe code examples

  [ Marc Tiehuis ]
  * Fix crypto exports
  * Add throughput test program
  * Add Sha3 hashing functions

  [ Andrew Kelley ]
  * ziglang.org home page no longer in this repo

  [ Jimmi Holst Christensen ]
  * fixed xor with zero
  * More tests, and fixed none negative bigint xor
  * A few more none negative cases, just to be sure we've covered everything

  [ Andrew Kelley ]
  * update embedded LLD to 6.0.0rc1
  * LLD patch: workaround for buggy MACH-O code
  * test: fix brace expansion test not checking invalid inputs
  * fix null debug info for 0-length array type
  * emit a compile error for @panic called at compile time
  * add compile error for shifting by negative comptime integer
  * all doc code examples are now tested
  * docs: remove references to %% prefix operator
  * readme: specify that we need exactly llvm 5.0.1

  [ Jimmi Holst Christensen ]
  * Implemented windows versions of seekTo and getPos
  * Removed PLARGE_INTEGER
  * Now using the right unexpectedError in seekForward

  [ Andrew Kelley ]
  * temporary workaround for os.deleteTree not implemented for windows/mac

  [ Jimmi Holst Christensen ]
  * Removed bitcast from usize to isize in seekTo
  * We now make a more correct conversion from windows LARGE_INTEGER type to usize
  * usize might be same size as LARGE_INTEGER. If that's the case, then we don't want to compare pos to @maxValue(usize).

  [ Andrew Kelley ]
  * windows-compatible os_rename function
  * os_rename uses MoveFileEx on windows

  [ Marc Tiehuis ]
  * Fix build template to match build runner changes

  [ Andrew Kelley ]
  * fix docgen on windows
  * remove unused function, fixes mingw build
  * fix crash when switching on enum with 1 field and no switch prongs
  * appveyor: add language reference to build artifacts
  * fix crash on union-enums with only 1 field
  * add new kind of test: generating .h files. and more
  * docgen: verify internal links

  [ Marc Tiehuis ]
  * Add array type handling for gen_h

  [ Andrew Kelley ]
  * fix printf format specifier
  * clean up readme
  * replace %defer with errdefer
  * cleanups that I meant to put in the previous commit
  * rename "debug safety" to "runtime safety"
  * syntax: functions require return type. remove `->`
  * fix compiler crash on function with invalid return type
  * fix crash when align 1 field before self referential...
  * allow packed containers in extern functions
  * std: fix fn return syntax for zen os
  * add compile error for calling naked function

  [ Marc Tiehuis ]
  * Improve documentation styling for mobile devices

  [ Andrea Orru ]
  * Add IntrusiveLinkedList to index.zig

  [ Andrew Kelley ]
  * langref: remove page title header
  * add compile error for duplicate struct, enum, union fields
  * fix error message mentioning unreachable instead of noreturn
  * *WIP* error sets
  * fix assertion fail when using global var number literal
  * add some docs for reflection
  * add docs recommending to only have 1 cImport
  * docs: move source encoding section
  * add docs for memberType, memberCount, memberName
  * *WIP* error sets converting std lib
  * *WIP* error sets - fix implicit cast
  * *WIP* error sets - allow peer type resolution to create new error set

  [ David McFarland ]
  * make lld include paths private

  [ Andrew Kelley ]
  * *WIP* error sets - rewrite "const cast only" function
  * *WI* error sets - basic support working
  * *WIP* error sets - correctly resolve inferred error sets
  * *WIP* error sets - support fns called at comptime
  * *WIP* error sets - an inferred error set can end up being the global one
  * *WIP* error sets - std lib test compile but try to link against windows

  [ Ben Noordhuis ]
  * Use /dev/urandom and sysctl(RANDOM_UUID) on Linux.

  [ Andrew Kelley ]
  * add --forbid-library
  * fix accidentally linking against kernel32 on non windows
  * error sets - compile error for equality with no common errors
  * error sets - peer resolution for error unions
  * make OutStream and InStream take an error set param
  * fix test failure, organize code, add new compile error
  * handle linux returning EINVAL for large reads
  * handle linux returning EINVAL for large writes
  * error sets: fix peer resolution of error unions
  * error sets - fix most std lib compile errors

  [ Ben Noordhuis ]
  * DRY 'is slice?' conditionals in parser (#750)
  * format struct pointers as "<typename>@<address>" (#752)

  [ Andrew Kelley ]
  * update embedded LLD to 6.0.0rc2
  * LLD patch: workaround for buggy MACH-O code

  [ Jeff Fowler ]
  * improve behavior of `zig build` (#754)

  [ Ben Noordhuis ]
  * implement openSelfExe() on darwin (#753)

  [ Andrew Kelley ]
  * fix comptime fn execution not returning error unions properly
  * error sets - most tests passing
  * error sets - update langref. all tests passing
  * error set casting building

  [ Marc Tiehuis ]
  * Add ArrayList functions (#755)

  [ Andrew Kelley ]
  * error sets - fix bad value for constant error literal
  * std: fix return type of std.c.write
  * error sets: runtime safety for int-to-err and err set cast
  * if statements support comptime known test error, runtime payload
  * syntax: parse `?error!i32` as `?(error!i32)`
  * add test for comptime err to int with only 1 member of set
  * add compile error tests for error sets
  * fix build runner on windows
  * appveyor: answer Yes to all pacman questions
  * appveyor: don't try to build for mingw
  * fix crash with error peer type resolution
  * self hosted compiler: move tokenization and parsing to std lib
  * fix compiler crash switching on global error with no else
  * std lib: modify allocator idiom
  * std zig tokenizer: don't require 3 newlines at the end of the source
  * std.os and std.io API update
  * std: refactor posixOpen to be friendlier to error return traces
  * fix exported variable not named in the object file
  * introduce std.heap.ArenaAllocator and std.heap.DirectAllocator
  * remove std.heap.IncrementingAllocator
  * back to malloc instead of aligned_alloc for c_allocator
  * std.heap.ArenaAllocator: fix incorrectly activating safety check
  * workaround on windows for llvm6 missing advapi32.lib in llvm-config
  * self hosted parser tests every combination of memory allocation failure
  * fix self hosted tokenizer handling of EOF
  * self hosted: add tokenizer test fix eof handling
  * zig_llvm.cpp uses new(std::nothrow)
  * correct doc comment in self hosted parser
  * self hosted parser supports builtin fn call with no args
  * self hosted parser: support string literals
  * fix build broken by previous commit
  * std.zig.parser understands inferred return type and error inference
  * fix sometimes not type checking function parameters
  * std.zig.parser understands try. zig fmt respects a double line break.
  * fix crash when doing comptime float rem comptime int
  * fix compiler crash when struct contains...
  * zig fmt supports simple line comments
  * add an assert to catch #777
  * ability to slice an undefined pointer at compile time if the len is 0
  * improve std lib linux epoll API

  [ Ben Noordhuis ]
  * add support for stack traces on macosx
  * fix memory leak in std.debug.openSelfDebugInfo()

  [ Andrew Kelley ]
  * add async, await, suspend, resume, cancel keywords
  * parse async fn calls and cancel expressions
  * parse async fn definitions
  * add promise type
  * implement IR analysis for async function calls
  * clean up mach-o stack trace code
  * add coroutine startup IR to async functions
  * coroutines: analyze get_implicit_allocator instruction
  * ir analysis for coro_id and coro_alloc
  * IR analysis for coro.begin

  [ Ben Noordhuis ]
  * name types inside functions after variable

  [ Andrew Kelley ]
  * implement Zig IR for async functions

  [ Ben Noordhuis ]
  * allow implicit cast from `S` to `?&const S`

  [ Andrew Kelley ]
  * fix type_is_codegen_pointer being used incorrectly
  * Revert "workaround on windows for llvm6 missing advapi32.lib in llvm-config"
  * update embedded LLD to 6.0.0rc3
  * LLD patch: workaround for buggy MACH-O code
  * update C headers to clang 6.0.0rc3
  * update errors section of docs

  [ Marc Tiehuis ]
  * Add utf8 string view

  [ Andrew Kelley ]
  * codegen for calling an async function
  * codegen for cancel
  * codegen for coro_id instruction
  * codegen for coro_alloc and coro_size instructions
  * codegen for get_implicit_allocator instruction
  * codegen for coro_alloc_fail instruction
  * codegen for coro_begin instruction
  * codegen for coro_suspend instruction
  * codegen for coro_end instruction
  * codegen for coro_free instruction
  * codegen for coro_resume instruction
  * fix handle_is_ptr for promise type
  * coroutines: fix llvm error of instruction not dominating uses
  * add coroutine LLVM passes
  * async functions are allowed to accept zig types
  * fix invalid memory write in coroutines implementation
  * move coroutine init code to after coro.begin
  * parse await and suspend syntax
  * implement coroutine suspend

  [ Ben Noordhuis ]
  * allow implicit cast from &const to ?&const &const

  [ Andrew Kelley ]
  * workaround llvm coro transformations
  * workaround for llvm: delete coroutine allocation elision
  * remove signal hanlding stuff from std.os.ChildProcess
  * another llvm workaround for getelementptr
  * Revert "another llvm workaround for getelementptr"
  * llvm coroutine workaround: sret functions return sret pointer
  * revert workaround for alloc and free as coro params
  * Revert "llvm coroutine workaround: sret functions return sret pointer"

  [ Ben Noordhuis ]
  * fix assert on self-referencing function ptr field

  [ Andrew Kelley ]
  * different way of fixing previous commit
  * another workaround for llvm coroutines
  * break the data dependencies that llvm coro transforms cant handle
  * better coroutine codegen, now passing first coro test
  * run coroutine tests only in Debug mode
  * add atomicrmw builtin function
  * async function fulfills promise atomically
  * implement coroutine resume
  * add test for coroutine suspend with block
  * implementation of await
  * fix not casting result of llvm.coro.promise
  * await keyword works
  * coroutines: add await early test case
  * add optnone noinline to async functions
  * std.debug.dwarf supports line number version 4
  * add llvm 6.0.0 binaries to appveyor cache
  * fix conflict artifact accidentally in appveyor script

  [ Joshua Olson ]
  * Fix Linux gcc requirement (#807)
  * Clarify what is meant by 'libraries' (#808)

  [ Jacob Dufault ]
  * Make Utf8View public, add comments, and make iterator lowercase.

  [ Jimmi Holst Christensen ]
  * Simple translation of UO_LNot
  * Added appropriate TODO comment to UO_LNot
  * expr to bool is now it's own function. * Now while and for loops work on ints and floats, like if statements * This fixes the loop problem in #813
  * We now also use trans_to_bool_expr on bool not
  * Removed fixed todo

  [ Andrew Kelley ]
  * remove value judgement from std lib API docs
  * ptrCast builtin now gives an error for removing const qualifier
  * fix broken tests from previous commit
  * unless hf is specified in target environ, assume soft floating point
  * fix assertion when taking slice of zero-length array
  * var is no longer a pseudo-type, it is syntax
  * turn assertion into compile error for using var as return type
  * fix missing compile error for returning error from void async function

  [ Jimmi Holst Christensen ]
  * Ast Render no longer outputs erroneous semicolon closes #813

  [ Andrew Kelley ]
  * add compile error for using @tagName on extern union

  [ Jimmi Holst Christensen ]
  * Translate C can now translate switch statements again
  * Translate C will now handle ignored return values
  * Translate C now correctly converts ints, floats, ptrs and enums to bools * Boolean "and" and "or" should also work with these types. * This new method also simplifies to output code.

  [ Andrew Kelley ]
  * travis ci: update ubuntu llvm repo and CC,CXX env vars to 6
  * translate-c: add missing case labels
  * enums with 1 field and explicit tag type still get the tag type
  * fix partial inlining of binary math operator using old value
  * don't memoize comptime functions if they can mutate state via parameters
  * update to SoftFloat-3e

  [ Marc Tiehuis ]
  * Unroll Sha3 inner loop

  [ Andrea Orru ]
  * Added 6 parameters syscalls for zen
  * Fixed syntax errors in linux-i386 syscalls

  [ Andrew Kelley ]
  * omit pad zeroes in debug stack traces
  * add behavior test for coroutine frame allocation failure
  * improvements to stack traces
  * refactor stack trace code to remove global state
  * fix await multithreaded data race
  * change 5 to 6 in travis osx scripts
  * workaround for llvm-config missing xml2

  [ Andrea Orru ]
  * Simplify intrusive linked list test

  [ Andrew Kelley ]
  * xml2 workaround is relevant for linux too

  [ Andrea Orru ]
  * zen-specific: main -> _start

  [ Andrew Kelley ]
  * fix incorrect setEvalBranchQuota compile error
  * fix comptime slicing not preserving comptime mutability
  * don't memoize comptime fn calls that access comptime mutable state
  * some return types disqualify comptime fn call caching

  [ Marc Tiehuis ]
  * Add WebAssembly output workaround for LLVM 6

  [ Andrea Orru ]
  * Panic instead of segfault when returning generic type from functions closes #829

  [ Andrew Kelley ]
  * fix casting a function to a pointer causing compiler crash

  [ Andrea Orru ]
  * Compiler error when taking @offsetOf of void struct member closes #739
  * Tests for zero-bit field compiler error

  [ Andrew Kelley ]
  * fix tests broken by previous commit
  * add missing docs for setAlignStack builtin

  [ Andrea Orru ]
  * IPC structure updates
  * More precise naming
  * subscribeIRQ support

  [ Andrew Kelley ]
  * Release 0.2.0

  [ Andrea Orru ]
  * Some POSIX stuff, including a primitive write
  * Add Thread option for Mailboxes
  * Service -> Server

  [ Tesla Ice Zhang ]
  * Fix some explicit errors

  [ Ben Noordhuis ]
  * add CLANG_LIBDIRS cmake build variable
  * add LLVM_LIBDIRS to link directories

  [ Marc Tiehuis ]
  * Add addIncludeDir to TestStep + fix build template

  [ Andrew Kelley ]
  * add test for addIncludeDir for test step

  [ Andrea Orru ]
  * Message type, Undefined mailbox, read syscall, more constructors

  [ Tesla Ice Zhang ]
  * Remove unnecessary rule and re-fix an old bug

  [ Andrea Orru ]
  * Public SplitIterator

  [ Andrew Kelley ]
  * self-hosted build: print helpful message when libstdc++.a not found

  [ Wander Lairson Costa ]
  * Include libxml2 and zlib as required libraries

  [ Andrea Orru ]
  * Zen specific hacks

  [ Andrew Kelley ]
  * change async function call syntax

  [ Marc Tiehuis ]
  * Add missing pub specifier to atan2

  [ Andrew Kelley ]
  * update to llvm 7.0.0
  * ability to use async function pointers
  * create multiple llvm.memcpy and llvm.memset with different align params
  * use the llvm API for creating memcpy and memset instructions

  [ Marc Tiehuis ]
  * Fix OpqaueType usage in exported c functions
  * Fix os.File.mode function

  [ Andrew Kelley ]
  * std.os.linux exposes syscall functions and syscall numbers
  * move error ret tracing codegen to zig ir
  * fix async fns with inferred error sets
  * add promise->T syntax parsing
  * add comptime test for the type of suspend promise
  * fix invalid codegen for error return traces across suspend points

  [ Jay Weisskopf ]
  * doc: fix typo and tighten wording in error sections

  [ Andrew Kelley ]
  * fix bitrotted code in unexpected error tracing
  * fix crash when compile error in analyzing @panic call
  * std.math.cast handles signed integers
  * std/os: getting dir entries works on OS X

  [ Ben Noordhuis ]
  * non-zero exit when build.zig cannot be created
  * skeleton stage 2 support for 'zig build'

  [ Jimmi Holst Christensen ]
  * Fixed looking for windows sdk when targeting linux

  [ Andrew Kelley ]
  * fix compile time array concatenation for slices

  [ hellerve ]
  * st/os: address @andrewrk concerns

  [ Jimmi Holst Christensen ]
  * std.zig.parser can now parse top level test declarations

  [ Marc Tiehuis ]
  * Rewrite Rand functions

  [ Andrew Kelley ]
  * fix examples and rename std.rand.Rand to std.rand.Random

  [ Jimmi Holst Christensen ]
  * std.zig.parser now supports all infix operators
  * Fixed self hosted compiler compiler error from prev commit
  * std.zig.parser now parses call expr

  [ Andrew Kelley ]
  * add ZIG_STATIC cmake option

  [ Jimmi Holst Christensen ]
  * std.zig.parser now treats call expr as a suffix operator
  * std.zig.parser parses all prefix operators

  [ Andrew Kelley ]
  * find libc and zig std lib at runtime
  * appveyor and travis ci: stop passing unused configure args

  [ Jimmi Holst Christensen ]
  * Added a lot of test cases

  [ Andrew Kelley ]
  * implement os_self_exe_path in the c++ compiler for darwin

  [ Marc Tiehuis ]
  * docs: fix unclosed code tag

  [ Jimmi Holst Christensen ]
  * Fixed review commented code
  * Each test now have it's own test name
  * Added test cases to cover all of zigs syntax

  [ Andrew Kelley ]
  * fix regressions on windows

  [ Jimmi Holst Christensen ]
  * std.zig.parser now handles lib name for extern var and fn

  [ Raul Leal ]
  * Fix undeclared identifier error in readUntilDelimiterBuffer and incorrect number of parameters in readUntilDelimiterAlloc (#877)

  [ Jimmi Holst Christensen ]
  * std.zig.parser now parses multi line strings
  * std.zig.parser now parses char literals
  * std.zig.parser now parses null and bool literals

  [ Andrew Kelley ]
  * musl-friendly dynamic linking

  [ Jimmi Holst Christensen ]
  * std.zig.parser now parses error, this and unreachable

  [ Marc Tiehuis ]
  * Add run compiler command

  [ Jimmi Holst Christensen ]
  * std.zig.parser now parses slicing and array access

  [ Andrew Kelley ]
  * std.io.readLine function

  [ Jimmi Holst Christensen ]
  * std.zig.parser now parses slice and array types
  * std.zig.tokenizer fixed tokens having wrong column and line
  * std.zig.parser refactored call, slice and array access to be suffix op
  * std.zig.parser Refactor: * Slice/Array access is now not parsed in the expr contruction loop * State.ExprListItemOrEnd now takes a token id for the end token
  * std.zig.parser now parses initializers... Or, it would, if it worked
  * std.zig.parser now parses grouped expressions * I also moved some tests down, as they fail in ways I can't fix yet
  * std.zig.parser moved container initializer tests down
  * std.zig.parser Refactored top level decl parsing * Now, the arraylist from the root node is passed through the states. * This allows us to reuse the code for enums, unions and structs
  * std.zig.ast Added ContainerDecl

  [ Andrew Kelley ]
  * upload static linux artifacts on successful travis build
  * travis artifacts: don't upload extra stuff
  * travis: don't upload build/ folder as artifacts

  [ Jimmi Holst Christensen ]
  * std.zig.parser now parses regular enums, unions and struct * Still missing packed, and extern

  [ Andrew Kelley ]
  * travis: don't upload other files as artifacts
  * remove more signal handling stuff from std.os.ChildProcess
  * travis: better s3 artifacts
  * travis: don't skip tests
  * fix up logic for macos std.os.deleteTree

  [ Jimmi Holst Christensen ]
  * std.zig.parser now parses container decls
  * std.zig.tokenizer Tokens now don't contain a line and column field. * Instead, this information is optained by asking the tokenizer. * getTokenLocation takes a start_index, so relative loc can be optained
  * std.zig.parser now parses error set declarations

  [ Marc Tiehuis ]
  * Fix off-by-one error in all crypto functions

  [ Jimmi Holst Christensen ]
  * std.zig.parser should now parse operators with precedence. * This haven't been tested yet

  [ Marc Tiehuis ]
  * Add Hmac function (#890)

  [ Jimmi Holst Christensen ]
  * std.zig Major Refactor * parser now parses expression like the C++ compiler does * This makes initializers work * Added control flow expression (only return is parsed) * Added catch parsing (It doesn't quite work) * The parse can now specify states as optional.   * The parse will roll back on error if states are optional   * This can be overriden by State.Required

  [ Andrew Kelley ]
  * update to latest llvm API
  * travis: update docker image tag for llvm7

  [ Ben Noordhuis ]
  * fix use-after-free in BufMap.set()
  * fix llvm assert on version string with git sha

  [ Jimmi Holst Christensen ]
  * std.zig.parser: Initializers are now parsed and fmt correctly
  * std.zig.parser Fixed: * Parsing of the optional expression in contrl flow expr * Rendering of catch expressions

  [ Marc Tiehuis ]
  * Add common hash/checksum functions

  [ Jimmi Holst Christensen ]
  * std.zig.parser now parses labeled blocks. * There is also some code for switch range parsing
  * std.zig.parser now parses switch
  * std.zig.parser WIP generalizing parsing of payloads * Note, it doesn't work :)

  [ Andrew Kelley ]
  * error return traces for the early return case
  * codegen: fix not putting llvm allocas together
  * put the error return addresses in the coro frame
  * fix calling convention at callsite of zig-generated fns
  * error return traces work with async return case
  * add docs for packed enum
  * add docs for union methods
  * *WIP* async/await TCP server
  * running into the llvm corosplit error again
  * update what std tests to run
  * fixups from rebase
  * basic tcp server working when used with netcat
  * async tcp server proof of concept

  [ Jimmi Holst Christensen ]
  * std.zig.parser now parses while loops and labeled break and continue
  * std.zig.parser unified code for rendering and parsing semicolon in statements
  * std.zig.parser now parses for loops
  * std.zig.parser now parses if statements
  * ast.zig.parser now parses defer statements
  * std.zig.parser now parses comptime
  * std.zig.parser now parses fn types
  * std.zig.parser now parses asm expressions * We cannot render asm expressions yet

  [ Andrew Kelley ]
  * fix std.io.readline to work on windows

  [ Jimmi Holst Christensen ]
  * std.zig.parser can now render asm expressions
  * std.zig.parser changed assign expr to only be allowed in some contexts * Only allowed in while continue expr and statement expr
  * std.zig.parser now parses coroutine code
  * std.zig.tokinizer: fixed failing tests
  * std.zig: fixed compiler errors
  * std.zig.parser readded all tests * Ops!
  * std.zig.parser: changed block exprs from primary expr to expr
  * std.zig.parser now parses toplevel use
  * std.zig.tokinizer now treats string identifiers as identifiers
  * std.zig.parser now parses the `var` type * I parse it as a type in all contexts. This is not how the   C++ compiler does it, but I think typechecking should catch this
  * std.zig.ast: fixed none compiling code
  * std.zig.parser: removed dublicate "zig fmt: coroutines" test

  [ Andrew Kelley ]
  * add missing call in zig fmt to commit results to disk

  [ Jimmi Holst Christensen ]
  * std.zig.parser fixed segfault when parsing cc for fn decl

  [ Andrew Kelley ]
  * cmake defaults stage1 to install in build directory
  * fix another undefined deref
  * add memmove to builtin.o

  [ Josh Wolfe ]
  * zig fmt while-else with no blocks

  [ Andrew Kelley ]
  * add more linux syscalls and constants
  * simplify and fix BufMap logic

  [ Andrea Orru ]
  * Update zen library

  [ Jimmi Holst Christensen ]
  * std.zig: Major refactor * There now exists a few function to allocate all nodes in parser.zig * ast.zig now have a table of Ids and their corrisponding type
  * std.zig.parser: * Renamed eatToken to expectToken * A new eatToken fn, which only eats the token, if the id match * Inlined initNode, as it is not suppose to be used outside createNode
  * std.zig.parser: Fixed parsing of field access rhs related: #909
  * std.zig.parser: Redid parsing of error set delc related: #909
  * std.zig.parser can now parse `std/heap.zig`: related: #909 * Struct fields can now be pub * Parsing of double deref now works * Block expressions now have the right precedence
  * std.zig.parser now allows assignment expr in switch cases. This makes `std/os/index.zig` parse related: #909
  * std.zig.parser now handle `try`'s precedence correctly This allows parsing of `std/zig/parser.zig`. Related: #909
  * std.zig.parser now accept both string and multiline string for strings Related #909 Allows it to parse `std/special/compiler_rt/aullrem.zig`, `std/special/compiler_rt/aulldiv.zig` and `std/math/x86_64/sqrt.zig`
  * std.zig.parser now parses inline fn proto Related #909 Allows parsing of `std/os/zen.zig`.
  * std.zig.parser: requireSemiColon now matches the C++ behavior Related #909 Allowes parsing of `std/os/child_process.zig`

  [ Andrew Kelley ]
  * allow integer and float literals to be passed to var params

  [ Jimmi Holst Christensen ]
  * std.zig.parser special cased error in return. Related #909 This allows parsing of `std/special/build_runner.zig`

  [ Andrew Kelley ]
  * LLD patch: Do not keep shared symbols to garbage...

  [ Andrea Orru ]
  * outb syscall

  [ Jimmi Holst Christensen ]
  * std.zig.parser now parses alignment of functions Related #909 This allows it to parse `std/special/compiler_rt/index.zig`

  [ Marc Tiehuis ]
  * Revise self-hosted command line interface

  [ Jimmi Holst Christensen ]
  * std.zig.parser: Refactor, round 1: * Removed the Optional state   * We now have an OptionalCtx instead of DestPtr   * OptionalCtx simulated return, instead of reverting states   * OptionalCtx is a lot less hacky, but is still a small footgun * Trying to avoid consuming more than one token per state   * This is required, because of comments   * The C++ compiler allows comments between all tokens   * We therefor have to consume comment tokens between each state * Reordered states so they are grouped in some logical fasion

  [ Andrew Kelley ]
  * fix invalid implicit cast on macos
  * remove --zig-install-prefix arg now that we find std at runtime

  [ Jimmi Holst Christensen ]
  * std.zig.parser: Refactored `commaOrEnd` to `expectCommaOrEnd` * Now it returns end when found, or null if comma was found. * State should now be appended outside the function
  * std.zig.ast: Fixed build failures

  [ Andrew Kelley ]
  * inline functions must be stored in const or comptime var
  * zig fmt: container init fields each on own line
  * zig fmt includes trailing commas
  * zig fmt: switch cases on new lines

  [ Andrea Orru ]
  * Pass up to 5 arguments in Zen IPC

  [ Marc Tiehuis ]
  * Remove cc command
  * Use builtin Arch/Os/Environ

  [ Jimmi Holst Christensen ]
  * std.zig.parser: Refactor round 2 * More work on ensuring that each state only eat one token * VarDecl parsing now constructs its node * Handling all fn parsing in the same case * Using eatToken instead of getNextToken where possible * All tokenIdTo* now takes  @TagType(Token.Id) * Added a createToCtxLiteral function

  [ Marc Tiehuis ]
  * Replace File.exists with File.access
  * Fix windows access check

  [ Andrew Kelley ]
  * fix undefined behavior triggered by fn inline test
  * fix regression with zig install dir
  * travis: put cache-control header for ziglang.org/download

  [ Andrea Orru ]
  * FIXME note

  [ Andrew Kelley ]
  * add std.os.createThread
  * fix linux implementation of self exe path
  * add @sqrt built-in function
  * exit with error code instead of panic for file not found
  * std.math.ln and std.math.exp use float strict mode
  * add @atomicLoad builtin

  [ Alexandros Naskos ]
  * Added ReleaseSmall mode
  * Set SizeLevel to 2 in ReleaseSmall mode
  * Fixed test build code
  * Added ReleaseSmall mode to docgen

  [ Andrew Kelley ]
  * std.debug: dumpStackTrace & friends use DirectAllocator

  [ Marc Tiehuis ]
  * Add exp/norm distributed random float generation

  [ Andrew Kelley ]
  * fix windows not respecting --msvc-lib-dir, --kernel32-lib-dir
  * improve cmpxchg

  [ tgschultz ]
  * Added timestamp, high-perf. timer functions.
  * Added unstaged changes.
  * Fixed compiler errors around darwin code.

  [ Andrew Kelley ]
  * add --no-rosegment cli option

  [ tgschultz ]
  * fixed typos.
  * Fixed incorrect sign on epoch.clr
  * Added notes regarding CLOCK_MONOTONIC_RAW and made it easy to change our mind in the future. Updated std.os imported tests' block with lazy declaration workaround and added time.zig. Corrected some incorrect comments.
  * Fixed another incorrect comment

  [ Andrew Kelley ]
  * support break in suspend blocks

  [ tgschultz ]
  * Style cleanups, u64 casts, Timer.start returns error instead of unreachable on unexpected errno.

  [ Jimmi Holst Christensen ]
  * Added field builtin function
  * Optimized field ptr ir for hot path and fix assignment bug
  * Added builtin field to docs

  [ tgschultz ]
  * Use std.os.errorUnexpectedPosix if timer initialization encounters unexpected error

  [ Andrew Kelley ]
  * zig fmt: preserve comments in front of test blocks

  [ Harry Eakins ]
  * Readability improvements and bug-fix to std/crypto/throughput_test.zig
  * Changed all MB to MiB

  [ Andrew Kelley ]
  * std.zig.parser: remove unused field
  * add test case for #936

  [ tgschultz ]
  * Added DirectAllocator support for alignments > os.page_size on posix systems

  [ Andrew Kelley ]
  * travis: use encrypted env vars for s3 credentials
  * add alignment docs
  * fixups
  * linux: support VDSO for clock_gettime
  * add alignment docs
  * better error reporting for missing libc on windows
  * fix windows build broken by previous commit
  * exit(1) instead of abort() for file not found
  * add compile error for invalid deref on switch target

  [ Marc Tiehuis ]
  * Improve fmt float-printing
  * Fix release float printing errors

  [ Andrew Kelley ]
  * fix bigint twos complement implementation
  * fix interaction between defer and labeled break

  [ Alexandros Naskos ]
  * One step towards @typeInfo

  [ Marc Tiehuis ]
  * Add initial complex-number support

  [ Alexandros Naskos ]
  * @typeInfo with void payloads now works!

  [ Marc Tiehuis ]
  * crypto throughput test now uses os.time module

  [ Alexandros Naskos ]
  * Attempt at adding comptime union field access
  * Fixed IntInfo generation.
  * Added (broken) pointer info, float info
  * PointerInfo child is a pointer to a TypeInfo union, still not working correctly
  * Fixed PointerInfo generation
  * PointerInfo child is known at comptime
  * Added ArrayInfo, NullableInfo, PromiseInfo generation
  * Fixed comptime union void field access

  [ Andrew Kelley ]
  * std.mem: add more slice manipulation functions
  * clean up complex math tests
  * convert NOTE to TODO so we catch it later

  [ Braedon ]
  * Utf8 Encode
  * Changed to use shifting and masking

  [ Alexandros Naskos ]
  * Added checks for field name/index mapping in TypeInfo generation. Abstracted the parent setting out.
  * Fixed ir_type_info_struct_set_parent for struct parents.
  * Changed TypeInfo layout.
  * Cleanup
  * Added TypeInfo cache
  * Reset parent on cached TypeInfo values if we need to.
  * Added Enum TypeInfo except for methods
  * Added ErrorSet TypeInfo generation.
  * Switched to shallow TypeInfo.

  [ Andrew Kelley ]
  * translate-c: add missing decl type from LLVM 7

  [ Alexandros Naskos ]
  * Added ErrorUnion, Union TypeInfo generation
  * Fixed enum tag type detection in TypeInfo generation.
  * Added struct TypeInfo generation.
  * Added Fn TypeInfo generation.
  * Added BoundFn TypeInfo generation.

  [ Jimmi Holst Christensen ]
  * Removed zero sized error set optimization fixes #762 fixes #818

  [ Alexandros Naskos ]
  * Added definition TypeInfo generation, except for function definitions.

  [ Jimmi Holst Christensen ]
  * Functions with infered error set can now return literals fixes #852
  * .ReturnType and @ArgType now emits errors on unresolved types related: #846

  [ Alexandros Naskos ]
  * Generating TypeInfo's now forces definitions to be resolved.

  [ Jimmi Holst Christensen ]
  * Fixed wrong formatting for arg_index when reporting @ArgType error

  [ Alexandros Naskos ]
  * Started work on function definition TypeInfo generation.

  [ Jimmi Holst Christensen ]
  * Trying to fix osx build failing by setting param_info.type to nullptr
  * Fixed build error
  * Using allocate instead of allocate_nonzero so we don't have to memset

  [ Andrew Kelley ]
  * add std.atomic.Stack and std.atomic.Queue
  * add fuzz tests for std.atomic.Stack
  * add tests for std.atomic Queue and Stack
  * disable atomic stack and queue tests for non-linux
  * fix compiler-rt ABI for x86_64 windows
  * *WIP* use pthreads when linking libc
  * pthread support working
  * make pthreads threads work on darwin
  * enable atomic queue and stack tests for macos
  * linux uses pthreads when linking against libc
  * support kernel threads for windows
  * fix std threads for macos
  * fix std threads for linux

  [ Alexandros Naskos ]
  * More FnDef TypeInfo generation.
  * Finished FnDef TypeInfo generation (warning: may be buggy).

  [ Andrew Kelley ]
  * zig fmt: respect comments before statements
  * fix bootstrap_lib for windows
  * fix bootstrap_lib for windows, take 2
  * zig fmt: preserve comments before global variables

  [ Josh Wolfe ]
  * move some checks around in utf8Encode logic to be more zig idiomatic

  [ Andrew Kelley ]
  * zig fmt: preserve same-line comment after statement

  [ Josh Wolfe ]
  * use explicit error sets for utf8Decode functions

  [ Andrew Kelley ]
  * zig fmt: array literal with 1 item on 1 line
  * zig fmt: preserve same line comment after struct field
  * zig fmt: comments before var decl in struct
  * zig fmt: same-line comment after switch prong
  * zig fmt: comments before switch prong
  * zig fmt: comments before error set decl
  * update comment in std/os/index.zig
  * zig fmt: support line comments and doc comments
  * std.zig.tokenizer: fix handling of line comment / doc comment
  * std.zig.tokenizer: 3 slashes is doc comment, 4 is line comment
  * run zig fmt on std/os/index.zig
  * support foo.* for ptr deref
  * zig fmt: better multiline string handling
  * zig fmt: support promise->T
  * zig fmt: support labeled suspend
  * zig fmt: support union(enum(tag)) and enum init values
  * zig fmt: aggregate type init with only 1 field
  * zig fmt: consistent spacing for container inits
  * zig fmt: error set decls
  * zig fmt: comments in field decls
  * zig fmt: only some docs have doc comments
  * [breaking] delete ptr deref prefix op
  * zig fmt: line comments in struct initializer
  * behavior tests passing with new pointer deref syntax

  [ Alexandros Naskos ]
  * Added tests.
  * Added typeInfo tests
  * Added type info tests to behavior test listing
  * Fixed type info test, added documentation.
  * Added typeInfo to langref built_ins
  * Small fix.

  [ Andrew Kelley ]
  * translate-c: update to llvm7
  * windows threading: add missing call to CloseHandle

  [ Jimmi Holst Christensen ]
  * Added better support for none pure enums in tranlate C

  [ Andrew Kelley ]
  * std.atomic - use AtomicOrder.SeqCst for everything
  * fix compiler-rt tests accidentally running std tests

  [ Alexandros Naskos ]
  * Fixed inlining determination test (#972)

  [ Andrew Kelley ]
  * add ReleaseSmall mode in zig tests
  * fix behavior tests for ReleaseSmall

  [ Braedon ]
  * Unified API

  [ Jimmi Holst Christensen ]
  * Fixed extern enums having the wrong size (#970)

  [ Marc Tiehuis ]
  * Add json decoder
  * Fix review comments for json decoder
  * Use allocator backed array for json value decoder

  [ Andrew Kelley ]
  * zig fmt: fix tokenization of float literal with exponent
  * zig fmt: same-line comment on comptime expression
  * zig fmt: switch with empty body

  [ Jimmi Holst Christensen ]
  * Made container methods that can be const, const

  [ Andrew Kelley ]
  * zig fmt: same-line comment after non-block if expression

  [ Marc Tiehuis ]
  * Fix bigint multi-limb shift and masks

  [ Andrew Kelley ]
  * std.SegmentedList implementation
  * zig fmt: same-line comment after non-block if expression
  * SegmentedList: fixups from review comments
  * std.SegmentedList: cleaner separation of capacity functions
  * tagged union field access prioritizes members over enum tags
  * add std.SegmentedList.Iterator
  * add std.SegmentedList.Iterator.prev
  * rework std.zig.parser
  * separate std.zig.parse and std.zig.render
  * std.zig.parser supports same-line comments on any token
  * add benchmark for measuring parser performance

  [ Jimmi HC ]
  * Added Slice as it's own type info in userland
  * Freeing ptr_field_name after use

  [ Andrew Kelley ]
  * translate-c: fix typedef duplicate definition of variable
  * all tests passing again
  * fix parser performance regression
  * fix self hosted compiler
  * partial conversion to post-fix pointer deref using zig fmt
  * zig fmt: fix not writing results

  [ Marc Tiehuis ]
  * Fix bigint shift-right partial shift

  [ Andrew Kelley ]
  * update std.Buffer API
  * fix comptime code modification of global const
  * fix windows build system
  * add @newStackCall builtin function
  * recursive render top level decl
  * refactor std.zig.render to be recursive
  * fix AST dumping code in self hosted compiler
  * self hosted compiler: remove unused flag
  * README: https links
  * std.zig.parse cleanup
  * zig fmt: preserve same line doc comments on var decls
  * fix @typeInfo not setting a field to comptime
  * build: add flag to LLD to fix gcc 8 build (#1013)
  * std.fmt.format: support {B} for human readable bytes
  * zig fmt: add comma on last switch prong
  * convert more std lib files to postfix pointer deref
  * std.fmt: use SI prefixes for printing bytes
  * OpenBSD has the same C integer sizes as Linux
  * zig fmt: same line comments after tokens in expression
  * zig fmt: line comment between if block and else keyword
  * zig fmt: fix comment after if before another if
  * fix std.SegmentedList.Iterator.set
  * more std lib to postfix deref with zig fmt
  * all tests passing with postfix deref syntax
  * zig fmt: add pointer deref syntax

  [ Marc Tiehuis ]
  * Make StreamingJsonParser public
  * Make JsonParser public

  [ Andrew Kelley ]
  * std.zig.parse ignores comments
  * std.zig.tokenizer: fix tokenization of hex floats

  [ braedonww@gmail.com ]
  * Added argtype and error inferring info

  [ Andrew Kelley ]
  * doc fixups
  * update github.com/zig-lang to github.com/ziglang
  * std.zig.tokenizer: support hex escape in char literals
  * zig fmt: support aligned ptr with bit fields
  * struct fields with no explicit type are not supported
  * zig fmt: fix handling of comments at top of file
  * enum fields with a type are not supported
  * zig fmt: handle missing trailing comma in array literals
  * handle more cases of inserting trailing commas
  * update json_test to be compliant with zig source encoding
  * zig fmt: fix rendering of align keyword of slice type
  * zig fmt: support trailing comma on switch case items
  * trailing comma after var args is not supported
  * update to latest LLVM API
  * add strict float mode to some math functions
  * zig fmt: put nested struct inits on newlines
  * zig fmt: parse extra comma in asm expressions
  * zig fmt: fix rendering of struct with no trailing comma on last field
  * zig fmt: no space on switch range operator
  * zig fmt: handle empty block with comment inside
  * zig fmt: fn calls with trailing comma with params on new lines
  * zig fmt: better multiline string formatting
  * zig fmt: support array literal row size hint
  * run zig fmt on some of the codebase
  * zig fmt: delete empty comments that do nothing
  * zig fmt: array literals with no trailing comma all on one line
  * zig fmt: use simple newlines rather than empty comments to hint
  * zig fmt: allow same line struct literal with no trailing comma
  * zig fmt: fix switch body indent
  * zig fmt: fix enum decl with no trailing comma
  * zig fmt: render fn decl with trailing comma 1 line per param
  * zig fmt: respect line breaks after infix operators
  * zig fmt: respect line breaks in if-else
  * zig fmt: if-else with comment before else
  * zig fmt: fix spacing when moving doc comment on var decls
  * zig fmt: handle if and while indentation better
  * zig fmt: fix extra space after comma before multi line string
  * zig fmt: fix implementation of firstToken() for fn call
  * run zig fmt on the codebase
  * fix AtomicFile for relative paths
  * fix syntax of std/json_test.zig

  [ Jimmi HC ]
  * fixed #1009 ir_make_type_info_defs already calls resolve_top_level_decl on all Tld when building the def array. This means, that there is no reason that analyze_fn_body is nessesary, as the fn type should have already been resolved completly. The only thing analyze_fn_body does here, is cause problems with generic functions.
  * Removed copy-pasted resolve_inferred_error_set both ir.cpp and analyze.cpp have a function resolve_inferred_error_set, which is a nearly exact copy-paste. This commit removes the one in ir.cpp and exposes then one in analyze.cpp. This also allows us to make analyze_fn_body local to analyze.cpp, as it is not used anywhere in ir.cpp after this change
  * Adding workaround for when the user tries to unwrap 'type' closes #1011

  [ tgschultz ]
  * Added custom formatter support, refactored fmt.format
  * Minor typo
  * Formatting
  * Fixed character handling
  * Fix MacOS CI Timer test failing...?

  [ Andrew Kelley ]
  * std.zig.render returns bool of whether anything changed
  * spaces around slice operator if operands are infix
  * zig fmt: space after fn in fn prototypes
  * zig fmt: field access does not cause spaces for slicing
  * run zig fmt on the codebase
  * zig fmt: don't compute a sha-256 for no reason
  * Add --color CLI option to zig fmt
  * zig fmt: add --color option to CLI help text
  * use * for pointer type instead of &
  * ir: rip out special logic for using addr-of instruction for types
  * fix regressions
  * add test case for pointer to type and slice of type
  * std.zig: update to new pointer syntax
  * run zig fmt
  * fix incorrect address-of syntax on windows

  [ Arthur Elliott ]
  * fix typo (#1034)

  [ Andrew Kelley ]
  * docs: add missing builtin to langref syntax coloring
  * appveyor: remove llvm 5.0.1 from cache
  * fix build file template
  * introduce [*] for unknown length pointers

  [ Marc Tiehuis ]
  * Make zig fmt exit with error on any parse errors

  [ Andrew Kelley ]
  * better compile error for error sets behind nullable

  [ Marc Tiehuis ]
  * Add context to zig_unreachable calls (#1039)

  [ Andrew Kelley ]
  * disallow single-item pointer indexing
  * support `zig fmt: off` and `zig fmt: on` between top level decls
  * never call malloc with size 0
  * Pointer Reform: proper slicing and indexing (#1053)

  [ Jimmi HC ]
  * Renamed "(int/float literal)" to "comptime_int/float"
  * Removed NullLiteral to Null
  * Renamed UndefinedLiteral to Undefined

  [ Andrew Kelley ]
  * fix crash when evaluating return type has compile error
  * update to latest libclang
  * disallow unknown-length pointer to opaque
  * README: update support table
  * disable field access for unknown length pointers
  * disable deref syntax for unknown length pointers
  * add test for not allowing implicit cast from T to [*]const T
  * Pointer Reform: update @typeInfo

  [ Marc Tiehuis ]
  * Fix Log2Int type construction

  [ Braedon ]
  * Add newline to zig fmt error (#1064)

  [ Marc Tiehuis ]
  * Add json.TokenStream (#1062)

  [ isaachier ]
  * Fix const-ness of buffer in replaceContents method (#1065)

  [ Andrew Kelley ]
  * fix std.os.windows.PathFileExists specified in the wrong DLL (#1066)
  * fix structs that contain types which require comptime
  * langref: automatic update of builtin.zig
  * remove @canImplicitCast builtin
  * add implicit casts from `*[N]T`

  [ Marc Tiehuis ]
  * Fix json parser comma after empty object case

  [ Jimmi HC ]
  * Allow access of array.len through a pointer

  [ Andrew Kelley ]
  * disable some implicit casts for unknown length pointers

  [ isaachier ]
  * Fix error handling in Buffer::fromOwnedSlice (#1082)

  [ Andrew Kelley ]
  * nullable pointers follow const-casting rules
  * fix assertion failure when debug printing comptime values

  [ Arthur Elliott ]
  * add set function to arraylist

  [ Andrew Kelley ]
  * clean up std.ArrayList

  [ marleck55 ]
  * std/fmt: Use lowercase k for kilo in base 1000 (#1090)

  [ Ben Noordhuis ]
  * support `--target-arch wasm32` (#1094)

  [ Andrew Kelley ]
  * breaking syntax change: ??x  to  x.? (#1095)
  * breaking syntax change: orelse keyword instead of ?? (#1096)
  * std.zig: update syntax for orelse keyword

  [ Marc Tiehuis ]
  * Add arbitrary-precision integer to std

  [ tgschultz ]
  * Added C string support to fmt by using "{s}". The format string requirement is for saftey. (#1092)

  [ Andrew Kelley ]
  * implement @tagName as a switch instead of table lookup
  * langref: add coroutines documentation
  * langref: add orelse keyword to syntax highlighting
  * implement std.os.Dir for windows
  * zig fmt
  * fix ability to call mutating methods on zero size structs
  * better debugging for CI failures of std.atomic
  * docgen: don't leave garbage .h files lying around
  * add docs and missing test case for merging error sets

  [ Marc Tiehuis ]
  * Add i128 compiler-rt div/mul support

  [ Andrew Kelley ]
  * disallow implicit casts that break rules for optionals
  * langref: add merge error sets operator to operator table
  * std.zig.ast: add test for iterate
  * fix race condition bug in test harness of std.atomic

  [ Marc Tiehuis ]
  * Add windows x86_64 i128 abi workaround

  [ Alexandros Naskos ]
  * Enabled optional types of zero bit types with no LLVM DI type. (#1110)

  [ Andrew Kelley ]
  * std.os.path.dirname: return null instead of empty slice
  * fix build on windows, broken by previous commit
  * langref: docs for error return traces
  * llvm7: find external liblldWasm and update for newest lld macho API

  [ Jay Weisskopf ]
  * Make `zig version` compliant with SemVer (#1113)

  [ Andrew Kelley ]
  * add basic std lib code for loading dynamic libraries
  * std.DynLib: open the fd with CLOEXEC

  [ Sahnvour ]
  * pointer reform: missed change in windows specific code.

  [ Andrew Kelley ]
  * load_dynamic_library test: no need to link libc
  * disable load dynamic library test
  * allow passing by non-copying value
  * don't automatically take pointer when passing by non-copying value
  * disable byval
  * langref: be clear that float types are always IEEE 754
  * posix read can return error.IsDir
  * std.Complex: use better arg passing convention and fix a TODO
  * remove integer and float casting syntax
  * update test cases
  * update more tests
  * add target C int type information for msp430 target
  * update std.DynLib to use @intCast
  * msp430 target: c_long is always 32 bits
  * disable failing macos test. see #1126
  * remove bool to int syntax. add @boolToInt

  [ Bodie Solomon ]
  * Fix 1117: Use realpath in stage1 Darwin os_self_exe_path
  * Fix 1117: Tweak realpath logic to use out_path as scratch space
  * Fix 1117: Revise realpath scratch logic

  [ Andrew Kelley ]
  * fix compiler crash when using @intToFloat with float literal
  * disallow opaque as a return type of fn type syntax
  * langref: add docs for void
  * adjust logic for finding the path to zig executable on darwin
  * stage1: update darwin code to workaround old libc bug
  * zig fmt: support directories
  * remove error set casting syntax. add `@errSetCast`
  * remove []u8 casting syntax. add `@bytesToSlice` and `@sliceToBytes`
  * standard library fixes
  * remove error to/from int casting syntax; add `@errorToInt`/`@intToError`
  * translate-c: add new libclang c types
  * remove enum to/from int casting syntax; add `@enumToInt`/`@intToEnum`

  [ Alexandros Naskos ]
  * @typeInfo now uses optional types instead of @typeOf(undefined)
  * Added missing ?type in docs.

  [ Andrew Kelley ]
  * update langref
  * `@floatToInt` now has safety-checked undefined behavior
  * langref: organize docs for inline loops and add note about when to use it
  * remove redundant implicit casting code
  * fix calling method with comptime pass-by-non-copyign-value self arg
  * fix runtime fn ptr equality codegen

  [ kristopher tate ]
  * std.mem: remove allocator create in favor of construct; ref #733
  * std: update stdlib to match updated allocator create signature; ref #733
  * std.mem.Allocator.construct: remove deprecation warning;
  * std.mem.Allocator.construct: improve formatting;

  [ Andrew Kelley ]
  * zig fmt
  * remove std.mem.Allocator.construct and other fixups

  [ Ben Noordhuis ]
  * fix f128 remainder division bug

  [ Marc Tiehuis ]
  * Add float repr bit extraction functions

  [ Isaac Hier ]
  * Fix increment operation for bigint -1
  * Fix logic
  * Add test case

  [ Andrew Kelley ]
  * add casting docs, __extenddftf2, and __extendsftf2
  * fix compiler crash for invalid enum
  * clean up self hosted main. delete unsupported commands
  * std.zig.ast: fix incorrect impl of FnProto.firstToken

  [ Isaac Hier ]
  * Fix os_path_join for case where dirname is empty

  [ Andrew Kelley ]
  * rename get_maybe_type to get_optional_type
  * fix crash for optional pointer to empty struct
  * langref: explicit cast section

  [ Ben Noordhuis ]
  * scope variables in floating point cast tests
  * dry floating-point type definitions
  * add f16 type
  * simplify comptime floating-point @divTrunc

  [ tgschultz ]
  * Fix up some std.rand syntax #1161 (#1162)

  [ Andrew Kelley ]
  * add f16 to langref
  * fix comptime @tagName crashing sometimes
  * fix coroutine accessing freed memory

  [ Marc Tiehuis ]
  * Correct hex-float parsing

  [ Jimmi HC ]
  * Implement const_values_equal for array type * This allows arrays to be passed by value at comptime
  * Assert that array is not ConstArraySpecialUndef in const_values_equal
  * ir_resolve_const now checks recursivly for undef values
  * contains_comptime_undefined_value should not follow pointers

  [ Andrew Kelley ]
  * std.atomic.queue - document limitation and add MPSC queue

  [ isaachier ]
  * Clarify reason implicit cast does not work for large RHS (#1168)

  [ Ben Noordhuis ]
  * support --emit in 'test' command
  * add std.math f16 constants
  * add std.math f16 nan support
  * add std.math f16 inf support
  * add std.math f16 isfinite support
  * add std.math f16 isnormal support
  * add std.math f16 fabs support
  * add std.math f16 floor support
  * add std.math f16 copysign support
  * add std.math f16 signbit support
  * test std.math f16 sqrt support

  [ Jay Weisskopf ]
  * Fix version detection for out-of-source builds

  [ Marc Tiehuis ]
  * compiler_rt: Add trunc f128 narrowing functions
  * compiler_rt: Add floatuntisf
  * compiler_rt: Add floatunditf and floatunsitf
  * compiler_rt: Add floatuntitf
  * compiler_rt: Add missing exports
  * compiler_rt: Add missing install targets
  * compiler_rt: Add floattitf/floattidf/floattisf
  * compiler_rt: Remove wrapping add/sub operators where unneeded
  * compiler_rt: Add CMake entries
  * Alignment fix and allow rudimentary f128 float printing

  [ Jimmi Holst Christensen ]
  * Revert "contains_comptime_undefined_value should not follow pointers"
  * Revert "ir_resolve_const now checks recursivly for undef values"
  * Expanded the list of operators that catch undefined values at comptime
  * Avoid resolve_const in cmp when instr are not comptime
  * Fixed line numbers for tests

  [ Josh Wolfe ]
  * gitignore docgen test artifacts
  * syntax in build.zig example doc

  [ Andrew Kelley ]
  * always link against compiler_rt.o even when linking libc
  * add event loop Channel abstraction
  * modify std.event.Loop to work for windows and macos
  * add another BuildError code
  * add runtime safety for `@intToEnum`; add docs for runtime safety
  * fix stage2 macos build

  [ Marc Tiehuis ]
  * Clean up outstanding compiler_rt todos

  [ Andrew Kelley ]
  * update for latest llvm
  * langref: improve docs for while and undefined
  * fix runtime libc detection depending on locale

  [ Jimmi HC ]
  * Allow allocation of any 0 sized type (not just void)
  * Fixed last commit compiler error

  [ Marc Tiehuis ]
  * Do not normalize langref.html.in line endings

  [ Andrew Kelley ]
  * fix await on early return when return type is struct

  [ Isaac Hier ]
  * Debug enum issue
  * Fix assertion crash on enum switch values

  [ Andrew Kelley ]
  * alternate implementation of previous commit
  * langref: add more internal links
  * add compile error notes for where struct definitions are
  * fix iterating over a void slice
  * remove outdated semantic analysis documentation
  * add @popCount intrinsic
  * M:N threading
  * std.event.Loop: use EPOLLONESHOT to save 1 syscall
  * add std.os.cpuCount and have std.event.Loop use it for thread pool size
  * cleaner output from zig build when there are compile errors

  [ Josh Wolfe ]
  * builder.addBuildOption

  [ Andrew Kelley ]
  * tests passing with kqueue on macos
  * std.os.cpuCount implementation for macos

  [ Marc Tiehuis ]
  * Update zig.parser benchmark program

  [ Andrew Kelley ]
  * fix regressions on linux
  * zig fmt
  * std.Hashmap - don't use catch unreachable in tests
  * fix crash on @ptrToInt of a *void
  * langref: docs for invalid error set cast and incorrect pointer alignment
  * ZIG_DEBUG_COLOR=1 overrides tty detection for runtime stack traces
  * implement std.os.cpuCount for windows
  * std.event.Loop multithreading for windows using IOCP
  * fix non-portable format specifier
  * fix regression on macos

  [ wilsonk ]
  * Update throughput_test.zig. (#1211)

  [ Andrew Kelley ]
  * better workaround for guaranteeing memory in coroutine frame
  * define c macros before importing llvm h files
  * organize std.event into directories
  * enable basic event loop test
  * fix regression from b6eb4048
  * fix crash when calling comptime-known undefined function ptr
  * langref: docs for union safety
  * allow var args calls to async functions
  * introduce std.event.Group for making parallel async calls
  * self-hosted: first passing test
  * self-hosted test: use C allocator since we depend on libc
  * update vendor list for newest llvm version
  * self-hosted: add compile error test for missing fn name

  [ Marc Tiehuis ]
  * Add generic comparator generator functions for sorting

  [ Andrew Kelley ]
  * add compile error for disallowed types in extern structs
  * build system: add -Dskip-release option to test faster
  * add std.event.Future
  * std.atomic: use spinlocks
  * std.event.Future: workaround in tests for llvm coro memory
  * ir: refactor lvalues
  * self-hosted: generate zig IR for simple function
  * self-hosted: better IR for empty fn
  * zig fmt
  * allow == for comparing optional pointers
  * ir: remove dead code
  * ir: remove unnecessary and probably buggy code
  * ir_get_ref: delete unnecessary and probably buggy code

  [ Bas van den Berg ]
  * Improve ArrayList insert unit tests.
  * Add a copyBackwards to fix the broken insert methods for ArrayList.

  [ Andrew Kelley ]
  * self-hosted: basic IR pass2
  * docs: clarify mem.Allocator.reallocFn

  [ tgschultz ]
  * Added `remove` to ArrayList

  [ Andrew Kelley ]
  * std.ArrayList - rename remove to swapRemove

  [ Eduardo Sánchez Muñoz ]
  * codegen: Store returned value if type is 'handle_is_ptr' and function is not 'first_arg_ret'.

  [ Andrew Kelley ]
  * add an assertion to the test

  [ Marc Tiehuis ]
  * Add --stdin option to zig fmt

  [ Andrew Kelley ]
  * docs: correct some misinformation

  [ Bas van den Berg ]
  * Create unit test that tests aligned reallocation.
  * Fix aligned reallocation from zero size.

  [ Andrew Kelley ]
  * self-hosted: adding a fn to an llvm module

  [ Bas van den Berg ]
  * Improve realloc on fixed buffer allocator (#1238)

  [ Andrew Kelley ]
  * rename Module to Compilation
  * update for latest clang API
  * self-hosted: generate LLVM IR for simple function
  * all integer sizes are available as primitives
  * codegen: remove unused variable
  * remove std.ArrayList.removeOrError function
  * allow implicit cast of undefined to optional
  * self-hosted: create tmp dir for .o files and emit .o file for fn
  * self-hosted: implement getAppDataDir for windows

  [ kristopher tate ]
  * revert commit 860d3da9156a0b1f4a1e3e644b423da3e768bb86 ; please see #1249 for more information; (#1255)

  [ Wink Saville ]
  * Give ArrayList tests consistent names (#1253)
  * Add swapRemoveOrError (#1254)

  [ Andrew Kelley ]
  * port 69e3b4e to self-hosted compiler
  * self-hosted: linking
  * std.event.Loop.onNextTick dispatches work to waiting threads

  [ Jay Weisskopf ]
  * Fixed minor documentation errors (#1256)

  [ Andrew Kelley ]
  * fix @setEvalBranchQuota not respected in generic fn calls

  [ Josh Wolfe ]
  * implement proper utf16leToUtf8

  [ Jimmi HC ]
  * -Dskip-release now also skips build example tests

  [ Andrew Kelley ]
  * fix build on windows
  * fix std.os.getAppDataDir test on linux
  * fix invalid character test on windows

  [ Jimmi Holst Christensen ]
  * Allow pointers to anything in extern/exported declarations (#1258)

  [ Andrew Kelley ]
  * self-hosted: find libc on linux
  * self-hosted: linking against libc
  * self-hosted: compile errors for return in wrong place
  * std.zig.parse: fix treating integer literals as string literals
  * self-hosted: progress on IR for supporting libc hello world
  * prevent non-export symbols from clobbering builtins
  * std.os.File: add missing pub modifiers
  * self-hosted: refactor ParsedFile out of existence
  * fix generation of error defers for fns inside fns
  * relative path to cwd in compile errors
  * self-hosted: convert some stuff to async/await
  * self-hosted: implicit cast comptime ints to other ints

  [ Jimmi HC ]
  * Fixed windows getPos

  [ Andrew Kelley ]
  * self-hosted: share C++ code for finding libc on windows

  [ kristopher tate ]
  * std.os.posix: Add AF_* for darwin;
  * std.os.posix: Add SYSPROTO_* for darwin;
  * std.os.posix: Add SOCK_* for darwin;
  * CMakeLists.txt: add darwin_socket.zig;
  * std.special.test_runner.zig: make tests skippable;
  * std.event.tcp: SKIP test instead of OKing test;
  * std.event.tcp: add switch statement in preparation for building-out abstractions;

  [ Sahnvour ]
  * Very much WIP base implementation for #721. Currently does: - read COFF executable file - locate and load corresponding .pdb file - expose .pdb content as streams (PDB format)

  [ kristopher tate ]
  * README: include link to channel logs (#1278)

  [ Andrew Kelley ]
  * rename error.skip to error.SkipZigTest
  * re-organize std lib darwin files

  [ Marc Tiehuis ]
  * Tighten Int.to bounds and add twos-complement bitcount
  * Add big int fits function (#1279)

  [ Andrew Kelley ]
  * add std.math.big.Int.fitsInTwosComp
  * self-hosted can compile libc hello world
  * self-hosted: add first compare-output test
  * self-hosted: fix error messages not cleaning up correctly
  * macho backtraces - use std.sort.sort instead of insertion sort
  * self-hosted: basic linker code for macos
  * self-hosted: find all libc paths; windows linker code

  [ Nathan Sharp ]
  * std.io: PeekStream and SliceStream

  [ Andrew Kelley ]
  * fix logic for determining whether param requires comptime
  * remove old section from readme
  * self-hosted: function types use table lookup
  * self-hosted: function calling another function
  * fix race conditions in self-hosted compiler; add test
  * patch LLD to fix COFF crashing when linking twice in same process
  * fix assertion failure when some compile errors happen
  * add compile error for non-inline for loop on comptime type
  * add compile error for missing parameter name of generic function
  * add compile error for ignoring return value of while loop bodies
  * coroutines have 3 more bits of atomic state
  * update coroutine return codegen with new status bits
  * resume clears suspend bit
  * suspend sets suspend bit
  * remove ability to break from suspend blocks
  * cancel sets the cancel bit
  * await sets the await bit
  * resume detects resuming when not suspended
  * suspend checks the cancel bit
  * detect double await
  * cancel detects if the target handle has already returned
  * cancel detects suspend bit
  * suspend cancels awaiter when it gets canceled
  * await checks the cancel bit
  * await cancels the await target when it is canceled
  * make some functions in std.event.Loop public
  * canceling an await also cancels things awaiting it

  [ dbandstra ]
  * add int writing functions to OutStream
  * add skipBytes function to InStream
  * add SliceOutStream, rename SliceStream to SliceInStream (#1301)

  [ Andrew Kelley ]
  * fix cancel and await semantics
  * await sets suspend bit; return clears suspend bit
  * add behavior tests for cancel semantics
  * fix docs for break from suspend
  * introduce std.event.fs for async file system functions
  * self-hosted: use std.event.fs.readFile
  * std: file system watching for linux

  [ Matthew D. Steele ]
  * Add "Comments" section to language reference (#1309)

  [ Andrew Kelley ]
  * std.fmt.format: add '*' for formatting things as pointers
  * simpler std.event.Lock implementation

  [ Marc Tiehuis ]
  * Add integer binary output format (#1313)

  [ Andrew Kelley ]
  * add std.event.RwLock and a few more std changes

  [ kristopher tate ]
  * src/all_types.hpp: add enums for Handle Builtin;
  * src/ir.cpp: wire-up IR for handle builtin;
  * src/codegen.cpp: base handle builtin on `@frameAddress()`;
  * src/ir_print.cpp: support `@handle()`;
  * test/cases/couroutines.zig: test @handle();
  * src/codegen.cpp: return null if calling convention is not async;
  * src/codegen.cpp: add/throw error for @handle() in a non async context;
  * src/codegen.cpp: remove `add_node_error` from `ir_render_handle`;
  * src/codegen.cpp: reassert that there are no generated errors in codegen;
  * src/ir.cpp: add/throw error for @handle() in a non async context;
  * test/cases/coroutines.zig: remove dummy assert used for testing;
  * src/ir.cpp: return promise->T instead of promise;
  * src/ir.cpp: don't allow `@handle()` outside of a function;
  * src/codegen.cpp: return promise instead of null promise;
  * test/compile_errors.zig: @handle() called outside of function definition;
  * test/compile_errors.zig: @handle() in non-async function
  * src/codegen.cpp: @handle(): replace hacky ref chain with llvm intrinsic;
  * src/all_types.hpp: remove promise_symbol from suspend;
  * src/ast_render.cpp: remove promise_symbol from suspend;
  * src/ir.cpp: remove promise_symbol from suspend;
  * src/parser.cpp: remove promise_symbol from suspend;
  * std/event/channel.zig: remove promise_symbol from suspend and use @handle();
  * std/event/future.zig: remove promise_symbol from suspend and use @handle();
  * std/event/group.zig: remove promise_symbol from suspend and use @handle();
  * std/event/lock.zig: remove promise_symbol from suspend and use @handle();
  * std/event/loop.zig: remove promise_symbol from suspend and use @handle();
  * std/event/tcp.zig: remove promise_symbol from suspend and use @handle();
  * std/zig/parser_test.zig: update test to reflect that the promise symbol is no in scope with suspend;
  * test/cases/coroutine_await_struct.zig: update test to reflect that the promise symbol is no in scope with suspend;
  * test/cases/coroutines.zig: update test to reflect that the promise symbol is no in scope with suspend;
  * test/cases/coroutines.zig: test for immediate resume inside of suspend with @handle();
  * test/compile_errors.zig: update test to reflect that the promise symbol is no in scope with suspend;
  * doc/langref.html.in: update docs to reflect that the promise symbol is no in scope with suspend;
  * src/parser.cpp: fix typo from rebase;
  * doc/langref.html.in: update suspend example with @handle();
  * test/cases/coroutines.zig: update suspend to use @handle();
  * test/cases/cancel.zig: update suspend to use @handle();
  * doc/langref.html.in: add builtin @handle() to docs;
  * std/event: directly return @handle();
  * std/os/index.zig: use "hw.logicalcpu" instead of "hw.ncpu" in macOS; (#1317)
  * std/os/windows/advapi32.zig: add SystemFunction036;
  * std/os/index.zig: swap CryptGetRandom() with RtlGenRandom();
  * std/os/index.zig: call getRandomBytes() twice and compare;
  * std/os/windows/util.zig: SKIP instead of PASS on non-windows systems;

  [ Andrew Kelley ]
  * fix API of RtlGenRandom
  * pull request fixups
  * WIP: Channel.getOrNull
  * evented I/O zig fmt
  * fixups from the merge

  [ kristopher tate ]
  * better support for `_` identifier

  [ Matthew D. Steele ]
  * Fix the start-less-than-end assertion in std.rand.Random.range (#1325)
  * Fix a type error in std.os.linux.getpid() (#1326)

  [ Andrew Kelley ]
  * add a friendly note in .gitignore
  * fix tagged union initialization with a runtime void
  * self-hosted: watch files and trigger a rebuild
  * when decls don't change, don't regenerate them

  [ Matthew D. Steele ]
  * Add thread ID support to std.os.Thread (fixes #1316)

  [ kristopher tate ]
  * zig/std/os/index.zig: clean-up thread id; (#1)

  [ Andrew Kelley ]
  * update embedded LLD to 7.0.0rc1
  * build: update embedded LLD build files
  * LLD patch: workaround for buggy MACH-O code

  [ Matthew D. Steele ]
  * Don't compare ?Thread.Id == Thread.Id in the test

  [ Andrew Kelley ]
  * update c_headers/* to LLVM 7.0.0rc1
  * translate-c: fix while loop with no body
  * translate-c: handle for loop with empty body
  * translate-c: fix do while with empty body
  * translate-c: fix for loops with var init and empty body

  [ Andrea Orru ]
  * Fix casts
  * More type cast fixes

  [ Andrew Kelley ]
  * fix std.os.Thread.getCurrentId for linux
  * separate os.Thread.Id and os.Thread.Handle because of windows
  * fix Thread impl on Linux and add docs
  * std.HashMap.autoHash: use xor instead of wrapping mult
  * merge @kristate's std lib changes to darwin
  * std.event.fs support for macos
  * fix hash map test

  [ Shawn Landden ]
  * doc: @addWithOverflow also returns if overflow occured
  * std: add red-black tree implementation
  * mem: move enum Compare from rb to mem
  * mem: add mem.compare(), and use it for mem.lessThan()
  * mem: use pub on Compare (#1352)

  [ Andrew Kelley ]
  * implement std.event.fs.Watch for macos
  * std.event.fs.Watch distinguishes between Delete and CloseWrite on darwin
  * fix linux regressions

  [ Wink Saville ]
  * Fix ir_analyze_instruction_atomic_rmw (#1351)

  [ Andrew Kelley ]
  * std.event.fs.pwritev windows implementation
  * std.event.fs.preadv windows implementation
  * initial windows implementation of std.event.fs.Watch
  * windows: only create io completion port once
  * windows fs watching: fix not initializing table value
  * docgen: fix usage of std.HashMap
  * self-hosted: reorganize creation and destruction of Compilation
  * windows: call CancelIo when canceling an fs watch

  [ Shawn Landden ]
  * rb: some style fixes

  [ prazzb ]
  * Find local llvm-config first

  [ tgschultz ]
  * fixed handling of [*]u8 when no format specifier is set

  [ Marc Tiehuis ]
  * docs: correct @memcpy, @memset function signatures
  * Add secureZero function

  [ Shawn Landden ]
  * do not use an allocator when we don't need to because of the existance of PATH_MAX

  [ Andrew Kelley ]
  * langref: add docs for peer type resolution

  [ Michael Noronha ]
  * translate-c: Correctly translate enum init values, addressing #1360 (#1377)

  [ Andrew Kelley ]
  * std.fmt.format: handle non-pointer struct/union/enum
  * refactor std.os.makePath to use a switch instead of if
  * Revert "translate-c: Correctly translate enum init values, addressing #1360 (#1377)"

  [ Michael Noronha ]
  * translate-c: Correctly translate enum init values, addressing #1360

  [ kristopher tate ]
  * src/translate_c.cpp: correctly bridge llvm::APSInt with Zig BigInt;

  [ Andrew Kelley ]
  * *WIP* std.os assumes comptime-known max path size
  * fix windows
  * fix linux
  * Revert "Merge branch 'mtn-translate-c-enum-vals'"
  * fix selfExePath on macosx
  * fix docs on windows

  [ Raul Leal ]
  * allow implicit cast from *[N]T to ?[*]T (#1398)

  [ Andrew Kelley ]
  * fixup for previous commit
  * fix incorrectly generating an unused const fn global

  [ kristopher tate ]
  * std/mem.zig: test writing u64 integers;

  [ Andrew Kelley ]
  * rename std.debug.ElfStackTrace to std.debug.DebugInfo

  [ Marc Tiehuis ]
  * Default to strict IEEE floating point

  [ Andrew Kelley ]
  * MacOS stack traces use the already mmapped executable

  [ Shawn Landden ]
  * missing PATH_MAX change

  [ Andrew Kelley ]
  * macos stack traces: read debug info sections from .o files
  * fix error message for incorrect panic handler fn signature

  [ Marc Tiehuis ]
  * Fix builtin alignment type

  [ Andrew Kelley ]
  * macos stack traces have the compilation unit in them
  * fix regression from 2f7f7d815d0c9c4e620c7a529837b5
  * std.debug: remove workaround for fixed bug
  * macos stack traces have address-to-line translation
  * compilation unit cwd dir appears to be unnecessary on macos
  * fix stack traces on linux
  * fix regressions
  * fix handling multiple extern vars with the same name
  * add workaround on macos for shared libraries

  [ tgschultz ]
  * Fixed compile error when passing enum to fmt

  [ Andrew Kelley ]
  * add test for previous commit
  * document fixed-width integer types
  * update LLD fork to 7.0.0rc2
  * LLD patch: workaround for buggy MACH-O code
  * update clang headers to 7.0.0rc2
  * fix llvm assertion failure when building std lib tests for macos

  [ kristopher tate ]
  * src/ir.cpp: check return value of `const_ptr_pointee` to protect against dereferencing null pointers;

  [ Andrew Kelley ]
  * Revert "src/ir.cpp: check return value of `const_ptr_pointee` to protect against dereferencing null pointers;"
  * ir: const_ptr_pointee asserts that its return value is non-null
  * fix false negative determining if function is generic
  * this was intended to be included in the previous commit
  * fix @typeInfo unable to distinguish compile error vs no-payload

  [ tgschultz ]
  * Handle unions differently in std.fmt (#1432)

  [ Andrew Kelley ]
  * langref: document exporting a library

  [ raulgrell ]
  * Allow implicit cast from *T and [*]T to ?*c_void

  [ Andrew Kelley ]
  * minor fixups
  * std.zig.parse: fix parsing of doc comments after fields
  * zig fmt
  * langref: document labeled blocks, labeled for, labeled while

  [ Shawn Landden ]
  * std.crypto: add chaCha20

  [ Marc Tiehuis ]
  * speed up chacha20

  [ Andrew Kelley ]
  * fix crash when var in inline loop has different types
  * add compile error for function prototype with no body
  * add test coverage for invalid switch expression parameter
  * fix unresolved path preventing PDB loading
  * use RtlCaptureStackBackTrace on windows
  * printing info from the ModuleInfo substream of DebugInfo

  [ Marc Tiehuis ]
  * Add poly1305 and x25519 crypto primitives

  [ Andrew Kelley ]
  * reading the module information substream
  * figuring out which module an address belongs in
  * finding the function that an address is in
  * finding source file, line, and column info

  [ Marc Tiehuis ]
  * Make poly1305 and x25519 more idiomatic zig
  * std/crypto: Update throughput_test.zig to include all hash functions
  * std/crypto: zig fmt

  [ Andrew Kelley ]
  * awareness of debug subsections

  [ Jimmi Holst Christensen ]
  * Translate-c: Check for error before working on while loop body (#1445)

  [ Andrew Kelley ]
  * figuring out where /names stream is

  [ kristopher tate ]
  * i#1438: src/windows_sdk.cpp: fix version guard in `find_10_version`;
  * i#1438: src/windows_sdk.cpp: fix version guard in `find_81_version`;
  * std/fmt/index.zig: #1358 allow bytes to be printed-out as hex;
  * std/fmt/index.zig: #1358: test bytes printed-out as hex;

  [ Shawn Landden ]
  * std/rb.zig: fix comment

  [ kristopher tate ]
  * std/fmt/index.zig: set width from 0 to 2;
  * std/fmt/index.zig: test for printing double width hex bytes with zeros;

  [ Shawn Landden ]
  * these all use futex() (inaccurate comments)

  [ kristopher tate ]
  * std/fmt/index.zig: add hexToBytes function under std.fmt;

  [ Andrew Kelley ]
  * rework code to avoid duplicate operations
  * fix source file lookup
  * fix regressions
  * fixups
  * use the sret attribute at the callsite when appropriate
  * switch most windows calls to use W versions instead of A
  * ability to @ptrCast to *void
  * better anonymous struct naming
  * clarify const variables in docs
  * compile error instead of segfault for unimplemented feature
  * fix incorrect value for inline loop
  * compile errors for unimplemented minValue/maxValue builtins

  [ Marc Tiehuis ]
  * std/crypto: Clean up poly1305/x25519

  [ Andrew Kelley ]
  * fix llvm assertion when adding callsite sret attr
  * fix incorrect variable ref count
  * add compile error for comptime control flow inside runtime block
  * update throughput test to new File API
  * ir: consistent error checking for br and cond_br instructions
  * compile error for @noInlineCall on an inline fn
  * port std.os.path.resolve to stage1
  * stage1: use os_path_resolve instead of os_path_real

  [ Marc Tiehuis ]
  * Downgrade new g++-8.0 error to warning

  [ Andrew Kelley ]
  * fix compile error on gcc 7.3.0
  * stage1: fix emit asm with explicit output file
  * stage1: fix crash when invalid type used in array type
  * stage1: fix build on macos
  * stage1 compile error instead of crashing for unsupported comptime ptr cast
  * stage1: fix tagged union with no payloads

  [ hfcc ]
  * Added compilation error when a non-float is given to @floatToInt()

  [ Andrew Kelley ]
  * allow comptime_int to @floatToInt
  * add test case for #726
  * stage1: rename TypeTableEntry to ZigType
  * stage1: rename FnTableEntry to ZigFn
  * stage1: rename VariableTableEntry to ZigVar
  * stage1: rename more TypeTableEntry types to ZigType
  * add compile error for using outer scoped runtime variables
  * stage1: improve handling of generic fn proto type expr
  * stage1: import blake2b implementation

  [ kristopher tate ]
  * std/crypto/x25519.zig: fix signature for `createPublicKey`;

  [ Andrew Kelley ]
  * start creating a hash of input parameters

  [ kristopher tate ]
  * std/crypto/x25519.zig: add test for `createPublicKey`;

  [ Andrew Kelley ]
  * assume evenly divided base64
  * stage1: compile error instead of incorrect code
  * add C ABI tests
  * stage1: c abi for big struct works
  * stage1: refactor fn type analysis to use C ABI walk fn
  * stage1: refactor param vars for C ABI
  * stage1: refactor variable inits to use c abi fn walk
  * add C ABI test for big unions
  * fix crash when var init has compile error

  [ raulgrell ]
  * builtin functions: @byteOffsetOf and @bitOffsetOf

  [ Raul Leal ]
  * Update langref.html.in

  [ Andrew Kelley ]
  * stage1: function to classify x86_64 abi types
  * C ABI: support medium size structs & unions for x86_64 params
  * C ABI: support returning large structs on x86_64
  * improve panic message from previous commit

  [ Shawn Landden ]
  * this is not arch-specific
  * os: use less syscalls
  * initial arm64 support
  * simplify f64_min to equivilent value
  * clone() on arm64
  * use vfork in stage1 compiler to avoid OOM
  * NaNs do not have signedness.
  * fix elf auxv handling

  [ Sahnvour ]
  * Fixes a path corruption when compiling on windows.

  [ Bas van den Berg ]
  * Add capacity and appendAssumeCapacity to ArrayList

  [ Andrew Kelley ]
  * basic compiler id hash working
  * `zig id` command
  * stage1: always optimize blake and softfloat even in debug mode
  * caching is working
  * update embedded LLD to 7.0.0rc3
  * LLD patch: workaround for buggy MACH-O code
  * drop patches on top of clang's C headers
  * stage1 caching: zig no longer uses zig-cache
  * fix llvm assertion and missing compile error
  * ability to disable cache. off by default except for...
  * disable stage2 tests on all targets
  * fix incorrect union const value generation
  * fix incorrect error union const value generation
  * fix docgen tests
  * zig build: better placement of test exe artifact
  * stage1: build blake code with -std=c99
  * darwin fixups
  * zig build: make the cache root dir before building
  * ci: build zig in release mode
  * stage1: clean up timing report in test mode
  * bring back zig-cache
  * rename --enable-timing-info to -ftime-report to match clang
  * error messages for attempted cache when zig cannot perfectly do it

  [ emekoi ]
  * fixed WriteFile segfault

  [ Andrew Kelley ]
  * windows os.cpp implementations
  * fix zig build cache dir path
  * windows: std.fs functions support concurrent ops
  * fix zig fmt on windows
  * ci: skip release-small tests to save time
  * docs: langref is now javascript-free
  * appveyor: skip release-safe to save time

  [ Marc Tiehuis ]
  * math/complex: cexp test correction and ldexp usage fix

  [ kristopher tate ]
  * src/cache_hash.cpp: support file paths that contain spaces;

  [ Andrew Kelley ]
  * alternate fix using the rest() function
  * appveyor: skip all release tests to save time
  * fix tagged union with only 1 field tripping assertion
  * add compile error for merging non- error sets
  * stage1: put test output artifact back in zig-cache folder
  * remove the scope parameter of setFloatMode
  * remove `this`. add `@This()`.
  * fix assertion failure on compile-time `@intToPtr` of function
  * fix tagged union with all void payloads but meaningful tag
  * docs: more syntax highlighting

  [ Wink Saville ]
  * Fix additional regressions calling FileOutStream/FileInStream init()

  [ Andrew Kelley ]
  * fix coroutine alignment

  [ Wink Saville ]
  * Add test for Queue.dump

  [ Andrew Kelley ]
  * fix alignment of structs
  * add docs for `@This()`
  * fix crash when pointer casting a runtime extern function
  * allow extern structs to have stdcallcc function pointers
  * remove `zig build --init`. add `zig init-lib` and `zig init-exe`
  * dereferencing a *u0 is comptime-known to be 0
  * fix crash when bit shifting a u1
  * add compile error for non-optional types compared against null
  * add compile error for @ptrCast 0 bit type to non-0 bit type
  * remove deprecated, unused windows functions
  * fix codegen for @intCast to u0

  [ Josh Wolfe ]
  * somewhat realistic usecase test for shifting strange integer sizes
  * link to #1544

  [ emekoi ]
  * compiling on mingw is now supported (#1542)

  [ Andrew Kelley ]
  * fix @bytesToSlice on a packed struct
  * minor cleanups from 68c1d05917
  * fix @embedFile reading garbage memory
  * fix implicit cast of packed struct field to const ptr
  * implementation for bitcasting extern enum type to c_int
  * remove unnecessary setFloatMode calls
  * stage1 caching: don't write manifest until cache release
  * add compile error for slice.*.len
  * appveyor: use MSVC 2017
  * fix optional pointer to empty struct incorrectly being non-null
  * zig fmt: handle shebang lines
  * fix regression from previous commit

  [ Christian Wesselhoeft ]
  * std/index.zig: Fix import

  [ Andrew Kelley ]
  * appveyor: remove old cache file
  * travis: update apt repo url
  * travis: fix package names
  * fix typo from previous commit
  * travis: fix llvm apt package names
  * build: fix finding llvm and clang 7
  * travis: build zig with gcc to match what llvm was built with
  * update to llvm 8
  * add HermitCore target
  * add workaround for `llvm-config --system-libs`
  * better string literal caching implementation
  * add compile error for casting const array to mutable slice
  * fix formatInt to handle upcasting to base int size
  * fix comptime slice of pointer to array
  * fixups
  * fix comptime string concatenation ignoring slice bounds
  * stage1: unify 2 implementations of pointer deref
  * add compile error for slice of undefined slice
  * doc: add note about reproducible builds
  * fix @compileLog having unintended side effects

  [ Jeff Fowler ]
  * rm extraneous macro

  [ Andrew Kelley ]
  * include LICENSE in windows static builds

  [ Wink Saville ]
  * Fix typo in argsAlloc comment

  [ Andrew Kelley ]
  * add test to cover the CLI API that godbolt is using
  * add panic function to godbolt CLI API test
  * fix godbolt cli test on non-linux-x86_64 hosts
  * fix translate-c incorrectly translating negative enum init values

  [ Wink Saville ]
  * Ignore class-memaccess error for gcc 8 and above

  [ Andrew Kelley ]
  * minor langref improvements
  * fix comptime bitwise operations with negative values
  * fix translate-c test expecting incorrect C ABI on windows
  * fix more bigint code paths and add tests

  [ Wink Saville ]
  * Remove StrLitKind enum

  [ Andrew Kelley ]
  * fix self reference through fn ptr field crash
  * fix not syntax highlighting builtin module
  * fix crash on runtime index into slice of comptime type

  [ Jay Weisskopf ]
  * stage1: Added `zig help` to show usage on stdout

  [ Andrew Kelley ]
  * fix implicit casting to *c_void

  [ Wink Saville ]
  * Tweak SYMBOL_CHAR define in tokenizer.cpp

  [ Andrew Kelley ]
  * the last number in a packed ptr is host int bytes
  * fix variables which are pointers to packed struct fields
  * fix crash when compile error evaluating return...

  [ Josh Wolfe ]
  * overhaul api for getting random integers (#1578)

  [ Andrew Kelley ]
  * add dll export storage class where appropriate
  * update @typeInfo docs
  * build: add support for ZIG_STATIC on MacOS
  * rely on gcc for static builds on macos
  * Release 0.3.0
  * zig build: use os_self_exe_path to determine exe path not arg0

  [ Jimmi Holst Christensen ]
  * Expose failing_allocator as *Allocator instead of const FailingAllocator

  [ emekoi ]
  * added dynamic library loading for windows
  * fixed compilation on mingw
  * merged windows dll apis
  * fixed native target detection

  [ Andrew Kelley ]
  * rename std.event.tcp to std.event.net
  * build: omit finding libxml2, zlib since no direct dependency

  [ Sahnvour ]
  * Fixes --emit asm on windows and makes C header file generation explicit. (#1612)

  [ Andrew Kelley ]
  * update std lib API for I/O
  * std lib: flesh out the async I/O streaming API a bit
  * std lib (breaking): posixRead can return less than buffer size
  * increase stack size on windows for all executables

  [ Jimmi Holst Christensen ]
  * Fixed StackTrace not being resolved when panic is invalid (#1615)

  [ Wink Saville ]
  * Add doc comment for tokenLocationPtr (#1618)

  [ Ben Noordhuis ]
  * fix build-exe for --target-arch wasm32 (#1570)

  [ Andrew Kelley ]
  * add std.os.linux.vfork and std.os.linux.exit_group
  * std.Mutex: implement blocking mutexes on linux
  * better mutex implementation

  [ emekoi ]
  * removed unneeded dll extension

  [ Andrew Kelley ]
  * refactor ir.cpp
  * fix missing .h files
  * improve pointer documentation
  * docs: fix double escaping html entities
  * docs: add comment about operator overloading
  * on linux, link statically if not linking any shared libs

  [ Shawn Landden ]
  * arm64: respond to code review

  [ Andrew Kelley ]
  * disable C ABI tests on macos due to LLD deficiency
  * build: try to find llvm-config-7 before llvm-config
  * support building static libraries
  * more efficient builtin library code generation
  * std/special/bootstrap: inline some functions to improve stack traces
  * fix error limit linker arg on windows
  * stage1 link: compiler_rt and builtin libs know ...
  * stage1 os: workaround for macos not having environ variable
  * add workaround for bad LLD macos code

  [ emekoi ]
  * added math.pow support for integer types. resolves #1637 (#1642)

  [ Marc Tiehuis ]
  * Improve time.sleep api

  [ Andrew Kelley ]
  * C ABI and compiler rt improvements for ARM
  * fix compiler crash

  [ Jimmi Holst Christensen ]
  * Solve the return type ambiguity (#1628)

  [ Andrew Kelley ]
  * remove implicit cast from T to *const T
  * fix windows
  * std.io: fix compile error when InStream has empty error set
  * travis: upload langref on successful test run

  [ tgschultz ]
  * Add std.meta (#1662)

  [ Jimmi Holst Christensen ]
  * Ran fmt on last PR

  [ Greg V ]
  * Fix CMake finding LLVM/clang/lld on FreeBSD
  * Add FreeBSD support to os.cpp

  [ Marc Tiehuis ]
  * Add initial freebsd stdlib functionality
  * Set FreeBSD ELF OS/ABI when targeting
  * Get freebsd std compiling again
  * freebsd: Fix argc resolution in _start

  [ Greg V ]
  * Fix os/freebsd files
  * Add freebsd to more things
  * System call numbers on FreeBSD are machine-independent
  * Various fcntl flags are also machine-independent on FreeBSD
  * Add /usr/local/lib path for libxml2 and link libc++ on FreeBSD
  * Set up libc/rtld paths for FreeBSD
  * Support more of std on FreeBSD
  * Split at zero byte in SplitIterator
  * Specify 16-byte stack alignment in _start on FreeBSD

  [ tgschultz ]
  * Add std.meta to deployment (#1670)

  [ Jimmi Holst Christensen ]
  * Fixed code still using old ptr syntax

  [ Josh Wolfe ]
  * that's not a keyword

  [ Andrew Kelley ]
  * travis: add missing http headers for docs
  * travis: don't use newer cli args of s3cmd

  [ emekoi ]
  * fixes #1667

  [ Andrew Kelley ]
  * langref: dark style. easier on the eyes

  [ tgschultz ]
  * fix error where "std" isn't found in meta/trait
  * fix "std" not found error in meta/trait

  [ Ryan Saunderson ]
  * Bug fixes in WinSDK detection (#1665)

  [ Andrew Kelley ]
  * remove 3 more implicit casts to const pointers
  * fix stack pointer register name on i386
  * remove @minValue,@maxValue; add std.math.minInt,maxInt

  [ emekoi ]
  * fixed mingw compilation
  * fixed comments

  [ Andrew Kelley ]
  * remove another implicit cast to const pointer
  * remove implicit cast from number literal to enum
  * simplify logic of pass1 ir for while on error unions
  * cleanups
  * readme: MSVC 2017 is the supported one now
  * support building static self hosted compiler on macos
  * azure: build static macos

  [ kristopher tate ]
  * os.crypto: support for HmacBlake2s256 variety;

  [ Andrew Kelley ]
  * ci: use azure for all CI
  * ci: add missing steps field
  * ci: fix shasum commands
  * ci: upload a src tarball too
  * ci: fix paths
  * ci: display environment variables
  * ci: full test suite
  * update ci scripts for llvm 8
  * update to build against llvm trunk
  * update self-hosted compiler for new targets
  * update type info behavior test

  [ kristopher tate ]
  * ci/azure: set wget to non-verbose mode to make logs easier to read;

  [ Andrew Kelley ]
  * ci: 7-zip instead of info-zip for windows
  * ci: remove accidental .lib files from windows zip
  * fix broken cli test and translate-c: support no-op cast
  * README: update CI badges
  * limit integer types to maximum bit width of 65535
  * macos: use the same code as linux to determine libc include path
  * std.build.Builder: mutable env_map

  [ emekoi ]
  * made colored output more consistent (#1706)

  [ Andrew Kelley ]
  * array type syntax implies comptime
  * ir: remove redundant casting code

  [ Jimmi Holst Christensen ]
  * New Zig formal grammar (#1685)
  * Fixed error where we didn't expect the return type of a function
  * Manual update to new grammar. TODO: Figure out how we can auto update this, when the grammar changes in the zig-spec repo

  [ Andrew Kelley ]
  * ** and ++ operators force comptime on operands

  [ Josh Wolfe ]
  * address port getter
  * implement mem.writeIntLE, mem.writeIntBE
  * io read/write int be/le optimizations
  * test for readIntBE/LE

  [ Andrew Kelley ]
  * zig fmt: add --check flag
  * disable windows test until coroutines rewrite lands

  [ Jimmi Holst Christensen ]
  * Added NullOutStream and CountingOutStream (#1722)

  [ Jimmi HC ]
  * Have readStruct in stream return a value instead of taking a pointer
  * Fixed failure using readStruct and gave async readStruct the same sig

  [ Andrew Kelley ]
  * more fixes related to readStruct API

  [ Matthew O'Connor ]
  * Change rb functions to use snakeCase.

  [ Andrew Kelley ]
  * update readme

  [ Jimmi Holst Christensen ]
  * Fixed #1663 and removed IrInstructionArrayLen

  [ kristopher tate ]
  * std/fmt/index.zig: support printing hex bytes on slices;

  [ Matthew O'Connor ]
  * camelCase std.rb.set_child to std.rb.setChild

  [ Vallentin ]
  * Fixed typos

  [ Andrew Kelley ]
  * delete rogue file
  * rename `section` keyword to `linksection`

  [ Jimmi HC ]
  * Updated docs to newest grammar
  * Updated comments in parser.cpp

  [ Andrew Kelley ]
  * aarch64 improvements

  [ kristopher tate ]
  * src/os.cpp: os_file_read: return ErrorIsDir on case EISDIR;

  [ Duncan ]
  * Fix setsockopt syscall on linux

  [ Wink Saville ]
  * Fix pushToParent to work for arrays of Objects

  [ Andrew Kelley ]
  * all numbers with comptime known values implicitly cast

  [ Josh Wolfe ]
  * atomic.Int.set

  [ Andrew Kelley ]
  * fix assertion failure related to @intToEnum
  * add std.meta.intToEnum

  [ Marc Tiehuis ]
  * std/rand: fix ziggurat next_f64 call

  [ Wink Saville ]
  * Add SegmentedList.shrink

  [ Andrew Kelley ]
  * improve error message when wrong type returned
  * docs: fix some incorrect error documentation
  * fix incorrect --help text

  [ Sahnvour ]
  * Crash fixes and small improvements to inline asm. (#1756)

  [ Andrew Kelley ]
  * zig fmt

  [ Wink Saville ]
  * Allow json tests to be easily filtered

  [ kristopher tate ]
  * std/mem: writeIntLE: buf.* to buf;

  [ Andrew Kelley ]
  * fix incorrect buf len
  * std.os.path.realC: make overflow more clearly impossible
  * fix @intCast not catching negative numbers to unsigned
  * refactor type_requires_comptime to have possible error
  * update zen os std lib for latest zig changes

  [ Josh Wolfe ]
  * better debiased random range implementation
  * add biased random range api
  * test lots of types
  * factor out and expose biased range limiting function

  [ daurnimator ]
  * add std.meta.stringToEnum

  [ kristopher tate ]
  * std.mem: add new separate method and rework SplitIterator;

  [ Andrew Kelley ]
  * stage1: better file path handling
  * fix regression from d5648d26

  [ daurnimator ]
  * add std.math.IntFittingRange

  [ Andrew Kelley ]
  * readme: update support table

  [ Sahnvour ]
  * stack traces: fix for windows

  [ Andrew Kelley ]
  * tier 2 support for freebsd

  [ Josh Wolfe ]
  * fix child_process piped streams not getting closed

  [ Andrew Kelley ]
  * work around to support debian's fork of llvm 7.0.1

  [ Wink Saville ]
  * Add math min/max for Float and Value

  [ Jimmi Holst Christensen ]
  * Implemented getOrPutValue which wraps getOrPut

  [ Andrew Kelley ]
  * Revert "Add math min/max for Float and Value"

  [ daurnimator ]
  * Add std.LinkedList.concat

  [ dbandstra ]
  * make parseUnsigned handle types <8 bits wide

  [ kristopher tate ]
  * std.mem: remove varargs on join to stop excessive inlined code;

  [ Andrew Kelley ]
  * ci: workaround azure quirk with set -x

  [ kristopher tate ]
  * std.mem: split: test for multiple seperator bytes;
  * std.os.path: remove dependance on std.mem.join;
  * stage2: update std.os.path.join method signature;

  [ Andrew Kelley ]
  * ci: workaround azure quirk for windows too

  [ Jimmi Holst Christensen ]
  * Implemented new more flexible readLineFrom (#1801)

  [ Suirad ]
  * Update windows imports
  * Platform specific tests
  * Add more padding to parse buffer
  * Simplify implementation
  * Find CI env variables
  * Update tests

  [ tgschultz ]
  * Added serialization, bitstreams, traits for integer sign, TagPayloadType
  * Increased range of bitwidths tested by "serialize/deserialize Int" tests. Added tests for float inf and NaN.
  * Fixed readBits to cast errors to the correct errorset. See #1810 for why this wasn't caught earlier.
  * Added explicit test for #1810 issue to io_test.zig.

  [ Andrew Kelley ]
  * zig build: addStaticExecutable
  * make std.unicode.Utf8Iterator public
  * introduce std.io.SeekableStream
  * std.debug.StackIterator
  * std.debug.printSourceAtAddressDwarf
  * expose std.debug.DwarfInfo and delete unused function
  * std.debug: fix some issues with freestanding debug info
  * LLD patch: allow non-allocated sections to go into allocated sections

  [ Jimmi Holst Christensen ]
  * Allow packages in TestStep

  [ Andrew Kelley ]
  * implement compile error note for function parameter type mismatch

  [ tgschultz ]
  * Minor change to custom (de)serializer to allow them to be defined outside of the struct and aliased inside it. This will enable alternate generic serializers (i.e. one that follows pointers) on a struct-by-struct basis.
  * Minor doc-comment fix.

  [ Henry Nelson ]
  * Document explicitly ignoring expression values

  [ Jay Weisskopf ]
  * docs: Prefer system-ui font-family
  * font-family fallbacks for unsupported system-ui

  [ Wink Saville ]
  * Add add compiler_rt routines for float to signed integer conversion

  [ Andrew Kelley ]
  * breaking API changes to all readInt/writeInt functions & more
  * freebsd: fix os_self_exe_path function and update std lib
  * freebsd: fix issues with syscalls
  * fix mistakes introduced in b883bc8
  * add mem.readVarInt, fix InStream.readVarInt, fix stack traces
  * fixups
  * docs: fix alphabetical sorting of builtin functions
  * ci: install openssl on windows

  [ Josh Wolfe ]
  * mem foreign functions call the native ones

  [ Andrew Kelley ]
  * implement comptime pointer cast
  * ci: update msys packages before installing
  * fix comptime pointer reinterpretation array index offset
  * ir: delete dead code
  * README: clarify self-hosted status

  [ Jimmi Holst Christensen ]
  * formatType can now format comptime_int
  * Fixed intToPtr to fn type when the address is hardcoded (#1842)
  * Added formatting of function pointers (#1843)

  [ Marcio Giaxa ]
  * freebsd: remove syscall files
  * freebsd: add getdirentries
  * freebsd: add access
  * freebsd: link against libc
  * freebsd: link against libc++
  * freebsd: use libc interface instead system calls
  * freebsd: remove getrandom dependency from libc
  * freebsd: use sysctl to get the current executable path
  * freebsd: initial stack trace

  [ Andrew Kelley ]
  * std.io: call the idiomatic std.mem.readInt functions

  [ kristopher tate ]
  * src/analyze.cpp: support alignOf(struct T) aligned member inside struct T;
  * tests: re: 79db394;

  [ Andrew Kelley ]
  * fixups

  [ Marcio Giaxa ]
  * ci: add sr.ht build manifest for FreeBSD

  [ Andrew Kelley ]
  * ci: only run the debug behavior tests for FreeBSD

  [ tgschultz ]
  * Removed allocator from Linux version DynLib. Added dynamic_library.zig to std test list.

  [ myfreeweb ]
  * Use Ninja in .builds/freebsd.yml

  [ Greg V ]
  * Fix stat/timespec definitions for FreeBSD
  * Add preadv/pwritev on FreeBSD

  [ Marcio Giaxa ]
  * freebsd: use realpath() to resolve symbolic links
  * freebsd: add realpath to freebsd/index.zig
  * freebsd: remove system linker hack

  [ Andrew Kelley ]
  * translate-c: --verbose-cimport prints clang command

  [ Marcio Giaxa ]
  * freebsd: fix Stat mode type

  [ Andrew Kelley ]
  * I observed open() return EBUSY on linux
  * self-hosted: add DeviceBusy as a BuildError
  * comptime: ability to @ptrCast to an extern struct and read fields
  * hello world example can use `const` instead of `var`
  * llvm8: fix build errors
  * test: remove type info test dependency on builtin.Os enum
  * tests: make type info tests not depend on builtin.Os enum
  * llvm8: fix ZigLLVMCreateFunction
  * self-hosted: add hurd os to switch

  [ Marcio Giaxa ]
  * freebsd: remove syscall and use libc

  [ nebulaeonline ]
  * Altered SUBSYSTEM option handling when linking in msvc mode; Added preliminary UEFI support.
  * msvc subsystem option handling; added uefi os type
  * git user error fix
  * Yet another git user error remnant fixed
  * fixed stricmp/strcasecmp between windows/posix

  [ Marcio Giaxa ]
  * freebsd: implement std.os.time.sleep

  [ nebulaeonline ]
  * fixed formatting in options display

  [ Marcio Giaxa ]
  * freebsd: fix flags for opening files

  [ nebulaeonline ]
  * tabs to space fix. thanks visual studio.

  [ alexander ]
  * Switching on bools with duplicate and missing value detection: Issue 1768

  [ Andrew Kelley ]
  * fixups

  [ Marcio Giaxa ]
  * tests: add FreeBSD to the test matrix

  [ Andrew Kelley ]
  * allow not having libc include paths and doing @cImport

  [ alexander ]
  * Test cases for compiler error and working behavior for switching on booleans

  [ Marcio Giaxa ]
  * tests: remove freebsd from the test matrix
  * ci: update freebsd manifest

  [ alexander ]
  * Add DIFlagStaticMember flag to functions.

  [ vegecode ]
  * @bitreverse intrinsic, part of #767 (#1865)

  [ Marcio Giaxa ]
  * freebsd: add clock const definitions
  * freebsd: implement clock related functions
  * freebsd: add sockaddr structs

  [ vegecode ]
  * Mark comptime int hardcoded address pointee as a run time variable #1171 (#1868)

  [ Marcio ]
  * freebsd: fix wrong call to clock_getres (#1871)

  [ Jimmi HC ]
  * Respect the type system instead of ConstExprValue when getting field
  * Implemented buf_read_value_bytes for ZigTypeIdArray * Only for x_array.special == ConstArraySpecialNone
  * Fixed issue where TypeInfo would use types from a prev CodeGen instance When doing multible codegen passes (such as building compiler_rt and then something else) the TypeInfo cache code would point to types from the prev code gen (such as the prev 'bool' type), giving us errors like "expected type 'bool', but found type 'bool'" This disabling of caching might have a performance hit, but correctness is better than speed, so let's have this for now, until someone optimizes this correctly (probably in stage2)
  * Added test case
  * Removed oops comments

  [ Andrew Kelley ]
  * fix debug info for function pointers
  * `@typeInfo`: more correct return type info
  * translate-c: update to llvm8
  * when rendering llvm const values, ensure the types align

  [ emekoi ]
  * added mutex for windows
  * updated structs
  * switching from EnterCriticalSection to TryEnterCriticalSection
  * switching back to EnterCriticalSection
  * moved to InitializeCriticalSection to init
  * fixed mutex on windows
  * changed pointer types
  * removed nullables
  * fixed initializer and typos
  * fixed type signature

  [ Andrew Kelley ]
  * fix incorrect parameter names for std.math.atan2

  [ Sahnvour ]
  * removed unnecessary cast
  * Hopefully fixed #1503 (at least improved) line accuracy of stack traces on windows.

  [ kristopher tate ]
  * src/analyze.cpp: return type entry for `ZigTypeIdPointer` if it points to `ZigTypeIdOpaque`

  [ Andrew Kelley ]
  * add test case for previous commit

  [ tharvik ]
  * llvm-config sanity check

  [ Andrew Kelley ]
  * update to llvm8 trunk. all tests passing

  [ kristopher tate ]
  * Hint at use of and/or when &&/|| is improperly used (#1886)

  [ Sahnvour ]
  * translate-c: get real child type of array type for incomplete initializers and/or multi-dimensional arrays.
  * translate-c: correct array concatenation for incomplete C array initializers.
  * translate-c: only detect ints as negative if they are signed.
  * translate-c: avoid array concatenation if the init node is empty, for clarity.

  [ Andrew Kelley ]
  * simpler implementation of `&&` and `||` hints
  * backport copy elision changes
  * fix freebsd ci from previous commit
  * darwin time code: don't cast to int until the end

  [ Matthew McAllister ]
  * Move tokenizer error location to offending char

  [ Andrew Kelley ]
  * collapse os_file_mtime into os_file_open_r and check for directory
  * fix test after merging ad8381e0d2936f
  * introduce vector type for SIMD
  * os.cpp: fix regression on Windows from 59c050e7
  * darwin: fix incorrect timeval struct type
  * fixups
  * add compile errror for @bitCast when bit counts mismatch

  [ Matthew McAllister ]
  * Fix runtime assignment to comptime aggregate field

  [ Andrew Kelley ]
  * introduce --single-threaded build option

  [ Matthew McAllister ]
  * Fix slice concatenation

  [ Andrew Kelley ]
  * `std.mem.Allocator.create` replaced with better API
  * adjustments to std.mem split / separate
  * SIMD: array to vector, vector to array, wrapping int add
  * fix vector debug info tripping LLVM assertion
  * fix vector debug info tripping LLVM assertion

  [ Jimmi Holst Christensen ]
  * Added support for vector wrapping mult and sub * I also merged the code that generates ir for add, sub, and mult

  [ Andrew Kelley ]
  * docs: clarify passing aggregate types as parameters

  [ Sahnvour ]
  * translate-c: add tests. Commented for now as the output is currently empty until #646 is fixed.
  * Notify failure to create a process when the executable is not found even in PATH.
  * Typo: use the joined path to try executables available from PATH.

  [ tgschultz ]
  * Fixed Serializer and BitOutStream when used with streams that have empty error sets.

  [ Andrew Kelley ]
  * doc/targets.md has moved to the github wiki
  * thread local storage working for linux x86_64
  * require running std lib tests coherently
  * implement Thread Local Storage on Windows
  * fixups, and modify std.mem.join and std.os.path.resolve API
  * fixups
  * better error message when LLVM does not understand a triple
  * build: make sure LLVM is exactly correct
  * build: make sure LLVM is exactly correct
  * build: update Findllvm.cmake for llvm 8
  * fix using the result of @intCast to u0
  * update embedded LLD to 8.0.0rc2
  * LLD patch: workaround for buggy MACH-O code
  * update clang headers to 8.0.0rc2

  [ John Schmidt ]
  * Make ThreadSafeFixedBufferAllocator alias FixedBufferAllocator when --single-threaded

  [ Andrew Kelley ]
  * std.debug.assert: remove special case for test builds
  * fix compiler assertion failure when returning value from test
  * fix docs
  * zig fmt: support threadlocal
  * docgen: update for threadlocal keyword
  * implement vector addition with safety checking
  * implement vector math safety with ext and trunc
  * fix not updating debug info type of optional error sets
  * docs: add threadlocal keyword to grammar
  * `@truncate`: comptime 0 when target type is 0 bits
  * added C pointer type and implicit int-to-ptr for this type
  * casting between C pointers and normal pointers

  [ Jimmi HC ]
  * testing.expectEqual use expected type as the type of actual This allows for impl casts

  [ Andrew Kelley ]
  * avoid needlessly creating global constants
  * avoid needlessly creating global constants
  * langref: update grammar with c pointers
  * README: move i386-macosx to Tier 4
  * zig fmt: support C pointers
  * translate-c: use C pointer type everywhere
  * C pointer comparison and arithmetic
  * add C pointer type to @typeInfo
  * comptime support for pointer arithmetic with hard coded addresses
  * peer type resolution with C pointers
  * C pointers: delete dead code in ir_num_lit_fits_in_other_type
  * disallow C pointers to non-C-ABI-compatible element types
  * implicit casting between C pointer and optional non-C pointer
  * compile error test for casting integer to c pointer
  * C pointers: errors for nested pointer casting regarding null

  [ Matthew McAllister ]
  * Enable compileLog to display slices

  [ Marc Tiehuis ]
  * compiler-rt: Add __addtf3, __subtf3 and __truncdfhf2
  * Add f128 support for fabs, isinf, isnan, inf and nan functions

  [ Jimmi Holst Christensen ]
  * We already support vector on floats, so let's test it
  * We already support vector bit operators, so let's test it

  [ Marc Tiehuis ]
  * Add parseFloat to std.fmt
  * Add parseFloat support to json.zig

  [ Jimmi Holst Christensen ]
  * Added error for nesting vectors

  [ Andrew Kelley ]
  * comptime detection of casting null to pointer
  * runtime safety check for casting null to pointer
  * ci: freebsd: remove '.git' from URL as per upstream suggestion
  * remove the "top of the comptime stack" compile error
  * compile error tests for implicit C pointer casting
  * add missing compile error for OpaqueType inside structs/unions
  * fix implicit cast error unions with non-optional to optional pointer
  * omit nonnull attribute for C pointers
  * add docs for C pointers
  * compile error for C pointer with align attribute
  * allow C pointers to have alignment
  * translate-c: back to *c_void for opaque types
  * stage2: fix llvm.zig with opaque types back to single-item pointer

  [ Marc Tiehuis ]
  * Make parseFloat stricter in what it accepts as input
  * Use official llvm mirror for compiler-rt commit ref

  [ Andrew Kelley ]
  * darwin: fix pointer cast in mmap
  * stage2: fix windows regressions
  * add test for truncate on comptime integers
  * breaking: fix @sizeOf to be alloc size rather than store size
  * typecheck the panic function

  [ emekoi ]
  * removed hidden union tag in release modes

  [ Andrew Kelley ]
  * bring zig fmt to stage1
  * fmt_runner: remove redundant check
  * refactor translate-c - no more using namespace clang
  * README: direct link to Download & Documentation at the top
  * translate-c: proof of concept for transitioning to userland
  * fix regressions from previous commit when building with clang
  * translate-c: 4 more functions using C decls

  [ Matthew McAllister ]
  * Fix lvalue dereference type checking

  [ sjdh02 ]
  * fix BufferedInStream not reading delayed input

  [ Andrew Kelley ]
  * fixups

  [ Maya Rashish ]
  * Add NetBSD support
  * freebsd: fix pointer cast in mmap
  * Undo local, unneeded patch

  [ LemonBoy ]
  * Silence gcc8 class-memaccess warnings

  [ Benoit Jauvin-Girard ]
  * Fix std.math.powi so powi(x, +-0) = 1 for any x.

  [ Maya Rashish ]
  * Don't provide a bogus definition of EVFILT_USER

  [ Matthew McAllister ]
  * Deduplicate compile log statement warnings
  * Check for duped error messages in compile tests

  [ Quetzal Bradley ]
  * fix openWriteNoClobber and add test

  [ Andrew Kelley ]
  * README: add NetBSD to support table

  [ LemonBoy ]
  * Add align attribute for params pointers
  * Translate parameterless C functions (#1978)

  [ Jimmi HC ]
  * Fixed std.testing.expectEqual

  [ emekoi ]
  * make @enumToInt work on union(enum)

  [ Andrew Kelley ]
  * pull request fixups
  * export _mh_execute_header with weak linkage
  * docs: note top level declarations are order-independent
  * docs: shadowing

  [ John Schmidt ]
  * Some function doc tweaks (#1961)

  [ kristopher tate ]
  * src/analyze.cpp: default to using `param_node` upon callconv error;

  [ Andrew Kelley ]
  * zig fmt: fix infix operator before multiline string literal
  * add test for 74bdc1d1f898705
  * remove --no-rosegment workaround now that valgrind bug is fixed
  * valgrind client requests for undefined values

  [ LemonBoy ]
  * Prevent crash in tagged enums rendering (#1986)

  [ Andrew Kelley ]
  * pull request fixups

  [ daurnimator ]
  * std: Add valgrind module
  * std: when a FixedBufferAllocator is initialised, set the buffer to undefined

  [ Andrew Kelley ]
  * deduplicate compile errors for undeclared identifiers

  [ daurnimator ]
  * Use valgrind marks from Allocator

  [ Andrew Kelley ]
  * packed structs support comptime bitcasting
  * extern structs support comptime bitcasting
  * `@sliceToBytes` works at comptime
  * better handling of arrays in packed structs
  * better field access of types which have one possible value
  * fix `@bitCast` when src/dest types have mismatched handle_is_ptr
  * docs for packed structs
  * add regression test for bitcast to array
  * implement vector negation
  * better libc detection (#1996)
  * introduce std.debug.captureStackTrace
  * fix `zig fmt` arg0 handled incorrectly
  * add `zig cc` command to act like a C compiler
  * zig cc: remove "polly" which was an undefined symbol on macos
  * zig cc: work around clang calling GetCommandLine on Windows
  * first class support for compiling C code
  * building DLLs on Windows works better
  * `@cImport` works with `--cache on`
  * zig build: 2 improvements
  * fix infinite recursion in type_has_one_possible_value
  * delete incorrect TODO comment
  * add docs for zero bit types and pointers to zero bit types
  * fix not finding libgcc_s when looking for native libc
  * add a compile error note when C import fails and not linking libc
  * better error message when forgetting to link against libc
  * add a regression test for #704
  * fix incorrectly trying to memset at comptime
  * fix the libc compile error tests to only run on linux
  * use -nobuiltininc when compiling c code
  * use -nostdinc++ when compiling C code

  [ John Schmidt ]
  * Add priority queue

  [ Andrew Kelley ]
  * use -nostdinc and sometimes -nolibc when compiling C code
  * breaking changes to the way targets work in zig
  * fix regressions on Windows
  * introduce sys_include_dir for when sys/* files are not with stdlib.h
  * add builder.addFmt API and use it to test stage1 zig fmt
  * fix .gitignore file and add commit missing std lib file
  * add test coverage for binary OR on error sets
  * add test coverage for type used as switch case
  * fix handling when there are multiple externs and
  * fix stage1 zig fmt on macos
  * improve docs for unions and switching on tagged unions
  * windows returns EINVAL for fopen when there is an asterisk in the name
  * stage1: fix unused function error on freebsd and netbsd
  * uefi os: better auto detection of subsystem
  * print the command that failed when C source code fails to build
  * fix incorrect use of printf in previous commit
  * update clang driver code to 8.0.0rc3
  * updates to build with llvm 8.0.0rc3
  * remove namespace type; files are empty structs
  * update embedded LLD to 8.0.0rc3
  * LLD patch: workaround for buggy MACH-O code
  * update clang C headers to 8.0.0rc3
  * stage2: update for changes regarding sub-architecture
  * web assembly is a tier 3 target now
  * struct types get fully qualified names
  * fix "use" decls
  * add mprotect syscall

  [ Marc Tiehuis ]
  * Use bitwise-and instead of modulo in __zig_return_error

  [ Andrew Kelley ]
  * fix dependency loops, pub, tests, use decls, root source
  * fix type names
  * @typeInfo for structs and opaque types is the bare name
  * fix docs typo
  * gen-h: use the bare type names for now
  * remove unused function
  * gen-h: respect @export
  * better error message for `-target windows` CLI
  * disable tests which are tripping an llvm assertion
  * compile error for import outside package path

  [ Sahnvour ]
  * all integers returned by @typeInfo are now comptime_int

  [ Andrew Kelley ]
  * fix @typeName on slices
  * @returnAddress and @frameAddress return usize now
  * rename std lib files to new convention

  [ sjdh02 ]
  * fix check for 64-bit arm platforms with new targets

  [ Andrew Kelley ]
  * fix const initialization of optional C pointer to null
  * fix build.zig not respecting --static
  * fix slice of C pointer
  * initial glibc support
  * building glibc from source
  * support crtbegin.o and crtend.o when using explicit libc
  * stop linking against gcc files
  * dynamic linker path is independent from libc installation
  * fix translate-c
  * support glibc dl, m, pthread, rt
  * std.os.changeCurDir no longer needs an allocator
  * libunwind 8.0.0rc3
  * libcxx headers 8.0.0rc3
  * build libunwind.a from source and link it
  * add popcountdi2 to compiler_rt
  * support other architectures for glibc startup files
  * cross compile glibc startup files

  [ Sahnvour ]
  * missed change when switching TypeInfo to use comptime_int

  [ Andrew Kelley ]
  * process headers tool
  * multi-arch glibc headers
  * dynamic_linker_path can be null on some targets
  * fix regressions on macos
  * better behavior when cache dir unavailable
  * windows and uefi don't have dynamic linkers
  * fix windows build
  * fix .d file processing and use -MV to quote spaces
  * fix linking glibc: caching static libs and
  * fix -mllvm command line option regression
  * disable some tests until coroutine rewrite is finished
  * fix passing invalid argument -NDEBUG

  [ Jay Weisskopf ]
  * Remove glibc compat shim with restrictive license

  [ John Schmidt ]
  * PriorityQueue: add bulk insertion methods

  [ Andrew Kelley ]
  * breaking changes to zig build API and improved caching
  * fix .d file parsing and string literal ast rendering
  * fix running things with zig build on Windows
  * fix docgen and fix unnecessarily adding .root suffix to objects
  * disable flaky event test until post coroutine rewrite
  * glibc: add missing linux header
  * use unique test source names for test-gen-h
  * docgen: --cache off for tests

  [ Sahnvour ]
  * translate-c: add support for integer suffixes on 0 (zero) litteral inside macro definitions

  [ Matt Whiteside ]
  * Add elf riscv32 and elf riscv64 as options in getLDMOption during construction of link job.

  [ Andrew Kelley ]
  * std.zig: `this` is no longer a keyword
  * fix inconsistent type information of optional C pointers

  [ Marc Tiehuis ]
  * Mark third-party dependencies as vendored

  [ Andrew Kelley ]
  * stage1 caching system: detect problematic mtimes
  * fix build on windows
  * Revert "use unique test source names for test-gen-h"
  * Revert "docgen: --cache off for tests"

  [ Jimmi Holst Christensen ]
  * fixed #1600
  * removed wild tab
  * use cached const_void_val
  * fixed enum to union code
  * added tests

  [ Jimmi HC ]
  * check for type_has_one_possible_value and added correct caching to TypeInfo

  [ Andrew Kelley ]
  * ir: fix handling of OnePossibleValueInvalid
  * add test for spawning child process with empty environment
  * enable C ABI tests on macOS
  * remove the valgrind integration with std.mem.Allocator
  * zig build: do a better job of detecting system paths

  [ Sahnvour ]
  * translate-c: additional test case for integer suffixes on 0

  [ Andrew Kelley ]
  * docs: finish initial documentation for implicit casts
  * add test cases to cover switching on u0 values
  * add musl headers
  * building musl start files from source
  * ability to build musl from source
  * remove accidental swap file
  * avoid a string that is too long for msvc
  * don't resolve dynamic linker for static executables
  * fix gitattributes
  * musl: remove files that have case conflicts

  [ emekoi ]
  * added z3 and fixed dynamic linker on mingw

  [ LemonBoy ]
  * Fix generation of comptime slices

  [ Andrew Kelley ]
  * add documentation for @"" syntax
  * zig test respects --output-dir parameter
  * add documentation for `pub`
  * remove nios2 from list of libc targets
  * this empty import workaround no longer necessary
  * fix @setRuntimeSafety not able to override release modes
  * breaking: remove --static; add -dynamic
  * fix target_requires_pic and reloc_mode
  * force windows to link against dynamic msvcrt
  * ignore -lm on darwin because it's handled by libSystem
  * macho linking: always -dynamic for non-static-libs
  * breaking: fix @typeInfo handling of global error set type

  [ Akuli ]
  * Add /lib/x86_64-linux-gnu or similar to default system library search paths

  [ Jimmi Holst Christensen ]
  * workaround for #2043
  * Implemented enough of translate-c to translate assert

  [ Jimmi HC ]
  * fixed void cast and added the last tests

  [ Andrew Kelley ]
  * breaking changes to std.mem.Allocator interface API
  * fix regressions on Windows from previous commit
  * fix while continue block not checking for ignored expression
  * add compile error for wrong type with `use`
  * add regression test for invalid multiple dereferences
  * enable issue_339 test on macos

  [ Sahnvour ]
  * correct padding handling between std.pdb.ModInfo entries in DbiStream
  * allow pdb modules to have no C13 data, this happens if the module is stripped
  * avoid reading LineBlockFragmentHeader at all if the address is not in range, thus simplifying code and improving speed of execution
  * print a message instead of returning an error when debug info comes from a source file not found (for example compiled on another computer)

  [ Andrew Kelley ]
  * add missing std lib file rb.zig to cmakelists.txt
  * when linking msvcrt, also link ntdll.lib

  [ Jimmi Holst Christensen ]
  * More work on ignoring values correctly

  [ Andrew Kelley ]
  * libc: separate linux headers from musl/glibc
  * pass explicit frame pointer args when compiling C code
  * update macos static build for llvm8
  * fix translate-c regression
  * workaround for Ubuntu/Debian bug
  * add documentation for Memory
  * start producing freebsd binaries
  * freebsd ci: install wget and set -x -e
  * ci: freebsd tests docs
  * freebsd ci: disable not working stuff

  [ Jimmi Holst Christensen ]
  * Updated parser to newest grammar

  [ Andrew Kelley ]
  * better buffer length for formatIntUnsigned
  * zig targets prints the available libcs
  * disable all C warnings when building musl

  [ Sahnvour ]
  * c_abi: when compiling for x86_64, differenciate between system V and windows ABI

  [ Andrew Kelley ]
  * build.zig: allow run() on non-native target artifacts

  [ Sahnvour ]
  * c_abi: add some tests for int and float parameter passing potentially using both registers and stack
  * c_abi: activate tests on windows

  [ Andrew Kelley ]
  * add docs for assembly and fix global assembly parsing
  * ci: apt-get update before install as a workaround
  * ci: add FreeBSD to download page
  * add documentation for zig test
  * ci: more quoting
  * fix parsing of large hex float literals
  * hex float parsing: solve another case

  [ Marc Tiehuis ]
  * Simplify hex-float parsing code

  [ Jimmi Holst Christensen ]
  * Updated langref to newest grammar

  [ Marc Tiehuis ]
  * Fix bigint_append_buf
  * Fix compile-error test case for large integer type

  [ Matt Stancliff ]
  * Fix typos around pointer usage

  [ Andrew Kelley ]
  * float literals now parse using musl's 128 bit float code
  * avoid quad float literal syntax for MSVC
  * get rid of restrict; it's not supported by MSVC

  [ Shawn Landden ]
  * std: add ascii with C ASCII character classes

  [ Andrew Kelley ]
  * fix macos build instructions in readme and fix warning
  * stage1: implement get_dynamic_linker for riscv
  * add mulXf3 to compiler-rt
  * parse_f128.c: fix whitespace
  * remove octal and hex floats from the language
  * docs: clarify NaN, inf, -inf
  * character literals: allow unicode escapes
  * add peer type resolution for `*const T` and `?*T`
  * add regression tests for a bug fixed by an older commit
  * add compile error for ignoring error
  * introduce the enum literal type
  * implement implicit cast from enum literal to enum
  * make switch expressions allow enum literal types
  * implement peer type resolution for enum literals
  * add compile error test for invalid enum literal implicit cast
  * implement allowzero pointer attribute
  * munmap allows address 0

  [ Shawn Landden ]
  * std.ascii: respond to review

  [ Shritesh Bhattarai ]
  * fmt: check for extra newline at end of file
  * Use linux.exit_group if not single threaded

  [ Shawn Landden ]
  * fix build on arm64
  * use __ARM_EABI__, not __arm__

  [ emekoi ]
  * removed static build flags on mingw

  [ Andrew Kelley ]
  * implement target_c_type_size_in_bits for WASI

  [ Shawn Landden ]
  * std.mulWide() whose return is twice as wide
  * stage1: better error message when comparing against null (Closes: #2104)
  * fix tests for math.mulWide

  [ Rohlem ]
  * add std.ascii to std.std test "std"
  * fix std.ascii type error and inverted logic

  [ emekoi ]
  * fixed libc command on mingw

  [ Shritesh Bhattarai ]
  * Add doc_comments to param decl
  * fmt: Fix param decl test

  [ MateuszOkulus ]
  * Remove binary and octal float literals from documentation.

  [ Andrew Kelley ]
  * fix anon enum literal used with switch on union(enum)

  [ hryx ]
  * Veritcally align array literal columns

  [ vegecode ]
  * Add memcmp to builtins
  * Add __aeabi_mem{cmp,clr,set,cpy,move} to compiler-rt
  * Add __aeabi_{f,d}{add,sub} and __{add,sub}{s,d}f3 to compiler-rt
  * Add __aeabi_{f,d}neg and __neg{s,d,X}f2 to compiler-rt
  * Add all __aeabi functions (C versions) who alias currently existing functions to compiler-rt

  [ Michael Dusan ]
  * fix zig run to accept executable args

  [ emekoi ]
  * added error for implicit cast from *const T to *[1]T. credit: @kristate
  * fixed broken casts in std

  [ hryx ]
  * Always write a multiline struct literal if a field expr is multiline

  [ vegecode ]
  * Remove inline keywords in addXf3.zig pending #2154

  [ Shritesh Bhattarai ]
  * fmt: fix first line comment indent in struct init

  [ hryx ]
  * zig fmt: Allow one-line for loops

  [ Shawn Landden ]
  * fix fd leak in stage1 cacheing code

  [ Andrew Kelley ]
  * better error message when os_file_overwrite fails
  * fix cache hash regression
  * decouple llvm types from zig types
  * introduce lazy values
  * remove the lazy value stuff
  * put the hack from master branch back in
  * bug fixes
  * more regression fixes
  * regression fixes and fix packed struct abi size
  * more regression fixes. empty test passes again
  * behavior tests passing again
  * put the alignment hack in for unions too. fixes std tests
  * passing all tests
  * avoid tripping assertion for setting struct body twice
  * fix setting union body twice
  * fix LLVM assertion failures
  * emit better debug info for enums

  [ tgschultz ]
  * (De)serializer now uses enum instead of bool to determine packing mode (byte/bit). Optional is initialized in a more straight-forward way by deserializer.

  [ Andrew Kelley ]
  * ci: add missing cache control headers and update download/index.json

  [ tgschultz ]
  * Changes as suggested by andrewrk

  [ Andrew Kelley ]
  * langref: rework the theming and layout

  [ Ruslan Prokopchuk ]
  * handle LibExeObjStep.disable_gen_h

  [ Andrew Kelley ]
  * fix thread local variables for non- position independent code
  * docs: complete the documentation for extern struct

  [ hryx ]
  * zig fmt: Fix regression in for-else (#2178)
  * zig fmt: Prevent for-else on same line when body is interrupted by LF

  [ Andrew Kelley ]
  * threads: fix using unmapped memory in some cases
  * add regression test for #1025
  * docs: add Variables section

  [ vegecode ]
  * Add divsf3 to compiler rt

  [ Andrew Kelley ]
  * fix `@divFloor` returning incorrect value and add `__modti3`

  [ Shritesh Bhattarai ]
  * fmt: format multi line only on trailing comma (#2184)

  [ emekoi ]
  * made lld flags on windows consistent
  * added code for linking libc on mingw
  * fixed linking of system libraries on mingw

  [ Andrew Kelley ]
  * fix NaN comparing equal to itself

  [ Shawn Landden ]
  * Simplify math.isnan

  [ vegecode ]
  * Fixes to divsf3 (#2186)

  [ Jay Weisskopf ]
  * docs: Use section symbol §, not paragraph symbol ¶

  [ Shritesh Bhattarai ]
  * support comptime_int in formatInt{,Value}
  * fmt: support trailing comma after var_args

  [ Andrew Kelley ]
  * docs: update `@typeInfo` definition and clarify field order
  * zig build: support single-threaded builds
  * stage1: fix debug builds on macOS
  * fix incorrect Thread.getCurrentId test
  * docgen: allow urls to have numbers
  * ci: stop doing the branch redirect thing

  [ vegecode ]
  * Add divdf3 to compiler_rt

  [ Shritesh Bhattarai ]
  * Fix getCurrentId test for pthreads (#2197)
  * build: usageAndErr clean exit (#2194)
  * wasm: Pass --allow-undefined and --export-all to the linker

  [ Andrew Kelley ]
  * fix dereferencing a zero bit type
  * docgen: add a space between the header and the section symbol
  * ir: avoid dependency on isnan

  [ Jimmi Holst Christensen ]
  * fixed 1726
  * removed todo comment and added test
  * Added regression test for #1607. fixes #1607

  [ kristopher tate ]
  * src/ir.cpp: don't call-out to analyze_type_expr;
  * test/compile_errors.zig: add regression test for ziglang/zig#532 ;

  [ Ryan Liptak ]
  * Fix std.HashMap.remove returning incorrect KV

  [ Jimmi Holst Christensen ]
  * Import 1607.zig to behavior.zig

  [ Andrew Kelley ]
  * Release 0.4.0

  [ Jay Weisskopf ]
  * docs: Underline link when hovering over it
  * Update README headline to match website

  [ Andrew Kelley ]
  * doc comments for parameters in std.mem.Allocator

  [ vegecode ]
  * compiler-rt: correct use_thumb_1 flag

  [ Andrew Kelley ]
  * compiler_rt: `@divTrunc` rather than `@divFloor` in muloti4

  [ LemonBoy ]
  * Correct parsing of DWARF line_info section

  [ Andrew Kelley ]
  * compiler-rt: better way to do the ABI required on Windows

  [ Shritesh Bhattarai ]
  * Build compiler_rt for WASM exe
  * pass exec_path to zig run

  [ Andrew Kelley ]
  * __muloti4 does not need the ABI workaround on Windows
  * fix outdated/incorrect docs for `@truncate`

  [ Marc Tiehuis ]
  * Add read-only, non-allocating Int for internal constants
  * Add initial big.Rational type
  * Fix big.Int toString maybe-null allocator
  * Small fixes for big.Rational and corrections for gcdLehmer
  * Handle zero-limb trailing div case in big.Int
  * Fix math.big.Int divN/gcdLehmer and fuzz-test failures
  * Pack big.Int sign and length fields

  [ LemonBoy ]
  * Fix normalization of right-shifted BigInt at CT

  [ Andrew Kelley ]
  * translate-c: move some code to the C API

  [ LemonBoy ]
  * Fix reading of udata/sdata encoded attributes
  * Add definition for DW_AT_alignment
  * Fix reading of reference attributes
  * Distinguish between absolute/relative addresses

  [ Matthew Iannucci ]
  * Add initial support for iOS targets (#2237)

  [ Andrew Kelley ]
  * delete unused function
  * readme: separate powerpc 32 and 64 bit in the support table
  * translate-c: move some code to the C API

  [ Shritesh Bhattarai ]
  * wasm: disable error ret tracing

  [ Andrew Kelley ]
  * translate-c: move some code to the C API
  * translate-c: move some code to the C API
  * translate-c: move some code to the C API

  [ Shritesh Bhattarai ]
  * wasm: use .wasm ext for exe

  [ Andrew Kelley ]
  * translate-c: move some code to the C API

  [ Ben Noordhuis ]
  * make os_file_close poison file handle after close
  * don't close cache manifest file prematurely

  [ Shritesh Bhattarai ]
  * WIP: hello world

  [ Duncan ]
  * Add favicon to langref.html

  [ Andrew Kelley ]
  * better handle quota of setEvalBranchQuota

  [ Shritesh Bhattarai ]
  * wasi: use __wasi_proc_exit instead of posix.exit
  * wasi: sigabrt at panic
  * support extern "wasi" functions
  * wasi: better comments
  * wasi: add std/os/wasi{,/core}.zig to CMakeLists.txt
  * wasi: better extern wasi logic
  * wasi: don't pass --no-entry to linker
  * wasm: force single threaded

  [ Andrew Kelley ]
  * organize how the single threaded option is passed around

  [ Shritesh Bhattarai ]
  * Update wasm tiers (#2272)

  [ Andrew Kelley ]
  * translate-c: move some code to the C API

  [ Shritesh Bhattarai ]
  * link: exemption for wasm instead of wasi
  * wasm: add wasm-import-module attr to extern
  * wasi: switch to "standard" wasi_unstable module fn

  [ Andrew Kelley ]
  * fix Debug mode when error return tracing is off
  * disable threads when linking WebAssembly to work around an LLD bug
  * update std.os.page_size for WebAssembly

  [ Shritesh Bhattarai ]
  * wasm: WasmAllocator that uses fixed 64kb pages
  * wasm: add WasmAllocator
  * fmt wasm_allocator

  [ Andrew Kelley ]
  * add patch to LLD to fix deadlock race condition in wasm linker
  * remove workaround for LLD bug
  * translate-c: move some code to the C API
  * freestanding target adds -ffrestanding to cc parameters

  [ Sahnvour ]
  * DirectAllocator: on windows, use HeapFree instead of HeapReAlloc to free memory.

  [ Shritesh Bhattarai ]
  * WasmAllocator: cleanup

  [ Michael Dusan ]
  * stage1: const_values_equal support tagged union

  [ Andrew Kelley ]
  * docs: update intro text
  * Revert "DirectAllocator: on windows, use HeapFree instead of HeapReAlloc to free memory."
  * stage1 is now a hybrid of C++ and Zig
  * build.zig: libuserland expects to against libc
  * build: rename zig1 to zig0 to avoid confusion with stage1
  * stage1 assertions always on, and have stack traces
  * ci: fix accidentally shipping zig0.exe

  [ Matt Stancliff ]
  * Fix test in langref to assert against modified var

  [ LemonBoy ]
  * translate-c: support conversion to/from fp types
  * translate-c: Parse float/double literals
  * translate-c: Convert char literals
  * Fix parseFormValueConstant

  [ Raul Leal ]
  * zig-fmt: allow comptime blocks in containers (#2308)

  [ emekoi ]
  * renamed add_gnu_link_args

  [ Ryan Liptak ]
  * fix DirectAllocator not unmapping unused pages on large alignments

  [ LemonBoy ]
  * Recover symbol infos from DWARF sections

  [ Andrew Kelley ]
  * fixup and zig fmt

  [ tgschultz ]
  * Fixes DirectAllocator Windows implementation to call HeapFree when new_size == 0

  [ vegecode ]
  * compiler-rt: add aeabi_fcmp, comparesf2

  [ Ryan Liptak ]
  * fix heap allocators when shrinking an object but growing its alignment

  [ daurnimator ]
  * std: improve msghdr definition
  * std: add msghdr_const
  * std: Add mem.nativeIntToBig and mem.nativeIntToLittle

  [ emekoi ]
  * fixed stack protector issues

  [ Ryan Liptak ]
  * readme: Add instructions for making changes to the standard library
  * readme: Simplify instructions for making changes to the standard library

  [ hryx ]
  * Allow tag expr for enum but not struct

  [ Ryan Liptak ]
  * std.heap.DirectAllocator: Fix aligned reallocs on Windows
  * Bump up FixedBufferAllocator test memory to account for new tests

  [ LemonBoy ]
  * translate-c: Support for integer to boolean conversions
  * translate-c: Pointer to/from integral conversion
  * translate-c: Add test for implicit casts
  * More precise translation of char literals
  * Correct rendering of AST Char literals
  * Add some zig_panic for 80-bit float codepaths
  * Add translation from pointer to boolean
  * Fix reading of signed leb128 values
  * Fix silly typo
  * Go one instruction before the return address

  [ Jimmi HC ]
  * fixed #2356

  [ Andrew Kelley ]
  * build libuserland in cross compilation mode

  [ Michael Dusan ]
  * add -fvisibility-inlines-hidden

  [ hryx ]
  * Sync grammar with spec

  [ Wink Saville ]
  * Fix alignment of macro FIND_AND_ADD_CLANG_LIB

  [ LemonBoy ]
  * Implementation of dl_phdr_info
  * Expose Elf32_Dyn and Elf64_Dyn
  * Other

  [ vegecode ]
  * compiler-rt: add aeabi_dcmp, comparedf2
  * compiler-rt: Add missing import of test for comparesf2

  [ Andrew Kelley ]
  * `@sizeOf` returns 0 for comptime types

  [ Shawn Landden ]
  * remove Shebang (#!) support (Closes: #2165)

  [ Andrew Kelley ]
  * translate-c: a little closer to self-hosted implementation
  * translate-c: unify API for self-hosted and C++ translate-c
  * translate-c: self-hosted implementation can detect C errors
  * translate-c: put -x c back in there, it's necessary
  * add preliminary windows support to std.io.COutStream

  [ Ryan Liptak ]
  * std.heap.DirectAllocator: reduce the amount of redundant memcpy calls on Windows
  * heap: fixup style of realloc memory copies

  [ rylmovuk ]
  * Change symbol name of tests in codegen

  [ LemonBoy ]
  * Do not invoke UB in BigInt shr operations

  [ Andrew Kelley ]
  * Fix path canonicalization when $HOME has a trailing slash
  * clean up test output
  * self-hosted translate-c emits a hello world AST

  [ Ryan Liptak ]
  * readme: Fix filepath to test file when testing std lib changes

  [ Shritesh Bhattarai ]
  * docgen: properly close tags for skipped execs

  [ Andrew Kelley ]
  * zig fmt is built directly into stage1 rather than child process

  [ Shritesh Bhattarai ]
  * fix missing semicolon

  [ emekoi ]
  * added static_crt_dir to libc file

  [ daurnimator ]
  * std: add LoggingAllocator prototype

  [ emekoi ]
  * fixed syntax error

  [ daurnimator ]
  * Revert "std: Add mem.nativeIntToBig and mem.nativeIntToLittle"

  [ Ryan Liptak ]
  * std.fmt: add max_depth to avoid infinite recursion from self-references

  [ emekoi ]
  * fixed visibility of zig_libc_cc_print_file_name

  [ LemonBoy ]
  * Make io offsets/sizes u64 instead of usize
  * Fix generation of container initializers
  * compiler-rt: Add __divsi3, __aeabi_idiv
  * compiler-rt: Add __divmodsi4, __aeabi_idivmod

  [ Andrew Kelley ]
  * fix build (unused function warning)

  [ Shawn Landden ]
  * std.heap: do not excessively call mmap, and munmap in direct allocator

  [ Andrew Kelley ]
  * DirectAllocator: move if > 0 condition above @memcpy
  * enable more json tests
  * json tests do not need this prefix anymore

  [ Matt Stancliff ]
  * Fix crash due to command line argument parsing

  [ Andrew Kelley ]
  * readme: expand Developing Zig section into Contributing section

  [ LemonBoy ]
  * compiler-rt: Add __mulodi4
  * translate-c: Emit @ptrCast + @alignPtr sequence

  [ Shritesh Bhattarai ]
  * WASI: implement argsAlloc and argsFree (#2364)

  [ Andrew Kelley ]
  * self-hosted translate-c: iterate over top level decls

  [ daurnimator ]
  * std: add sendmmsg on linux

  [ Andrew Kelley ]
  * translate-c: fix using wrong enum

  [ Marc Tiehuis ]
  * Don't install stage2 artifacts

  [ Andrew Kelley ]
  * add test case to cover solved bug

  [ Shritesh Bhattarai ]
  * wasi: import environ_get and environ_sizes_get
  * wasi: add getEnvMap
  * wasi: use mem.separate instead
  * wasi: implement getRandomBytes
  * wasi: import clock and timestamp function/types
  * wasi: implement timestamp
  * wasi: import all constants and their types
  * wasi: import all core exports

  [ Marc Tiehuis ]
  * std.math: Add upstream changes/fixes and simplify go derived code
  * std.math: Add documentation for all functions and algorithm sources
  * Don't install zig_cpp lib for stage2 target

  [ Andrew Kelley ]
  * docs: add note to @setRuntimeSafety
  * docgen: add exe_build_err tag

  [ Dong-hee Na ]
  * main: change --enable-pic and --disable-pic to -fPIC and -fno-PIC

  [ Ryan Liptak ]
  * std.HashMap: add public ensureCapacity fn

  [ Marc Tiehuis ]
  * std.math: Correct math.nan usage in cos

  [ Ryan Liptak ]
  * make std.HashMap.ensureCapacity round up to the nearest power of two

  [ Andrew Kelley ]
  * docs: update for shared libraries

  [ Shritesh Bhattarai ]
  * wasi: native os.abort
  * wasi: implement os.exit
  * wasi: remove posix-y exit

  [ Ryan Liptak ]
  * std.HashMap: make ensureCapacity optimize for the expected count, add ensureCapacityExact
  * std.HashMap: add putAssumeCapacity fn
  * std.HashMap: make ensureCapacityExact private

  [ Andrew Kelley ]
  * optimize `@memset` with `undefined`

  [ daurnimator ]
  * std: add std.ArrayList.orderedRemove

  [ Benjamin Feng ]
  * Switch wasm export-all to only values marked exports

  [ Andrew Kelley ]
  * docs: remove `@setGlobalLinkage` section
  * always respect threadlocal for variables with external linkage
  * remove redundant information from README

  [ Shritesh Bhattarai ]
  * docgen: support wasm and wasi
  * docgen: show -target command line argument
  * WasmAllocator: compileError on non-wasm arch

  [ LemonBoy ]
  * Address the comments of the first review round
  * compiler-rt: Add __moddi3, __divdi3
  * compiler-rt: Add __modsi3, __umodsi3

  [ Shritesh Bhattarai ]
  * wasi: Implement read and write with err checking

  [ tgschultz ]
  * Added PackedIntArray, PackedIntSlice to std
  * Fixed some comments
  * and again
  * Ugh. I updated these but forgot to git add.

  [ Ryan Liptak ]
  * std.HashMap: cleanup ensureCapacity + add test

  [ LemonBoy ]
  * std: Remove some assumptions about the host platform
  * Implement failsafe logic for posixSleep

  [ tgschultz ]
  * zig fmt
  * Added ability to specify endianess of PackedInt(Array/Slice)
  * zig fmt

  [ Andrew Kelley ]
  * std lib sleep APIs: add doc comments and no @intCast

  [ LemonBoy ]
  * Review
  * Add a test case

  [ Shawn Landden ]
  * stage1: add @hasField() built-in (Closes: #1439)
  * docs for @hasField

  [ LemonBoy ]
  * Fix definition of epoll_* struct on non x86_64 arches
  * Fix edge case in addXf3
  * Add missing cast to usize
  * Fix float comparison result in __aeabi_{f,d}cmp*
  * Avoid endless recursion in __extendhfsf2
  * std: Implement TLS support for Linux
  * std: Implement on-demand TLS allocation
  * Always initialize the TLS
  * Less error messages
  * Add ARCH_SET_* definitions for x86_64

  [ markfirmware ]
  * Update README.md

  [ Sahnvour ]
  * Duplicate windows's DirectAllocator as HeapAllocator, which it is in reality.

  [ LemonBoy ]
  * Implement stack probes for x86/x86_64

  [ Andrew Kelley ]
  * C pointers support `null`

  [ LemonBoy ]
  * compiler-rt: Add __floatsidf & __floatsisf
  * compiler-rt: More division intrinsics

  [ Andrew Kelley ]
  * C pointers support .? operator

  [ LemonBoy ]
  * compiler-rt: Add __truncdfsf2
  * compiler-rt: Add __floatundidf & __floatunsidf
  * compiler-rt: Add __floatdidf
  * compiler-rt: Add __extendsfdf2
  * compiler-rt: Add __aeabi_unwind_cpp_pr{0,1,2}
  * compiler-rt: add __floatsitf

  [ Andrew Kelley ]
  * C pointers support if and orelse
  * std.debug: fix stack trace iteration code
  * translate-c: NULL pointers translate to `null`
  * stage1: remove unneeded extern function
  * add --bundle-compiler-rt function to link options
  * self-hosted translate-c progress on function decls
  * fix build on macOS
  * translate-c: handle int to ptr and ptr to int casting
  * translate-c: enough C tokenization/parsing to handle shifting in macros
  * fix std.os.copyFile
  * compile error for attempt to cast enum literal to error
  * stage1: make some asserts print source location
  * translate-c: use C API for builtin types
  * translate-c: progress on self-hosted function prototypes

  [ LemonBoy ]
  * Fix minor bug in LEB128 parsing
  * Use matching types when parsing fields

  [ Andrew Kelley ]
  * fix translate-c regression
  * translate-c: progress on self-hosted function prototypes

  [ LemonBoy ]
  * compiler-rt: Add __ashlti3
  * compiler-rt: Add __lshrti3
  * compiler-rt: Add __ashrti3
  * Fix erroneous test case

  [ Jimmi HC ]
  * Fixes and simplifications for stage 1 parser

  [ Michael Dusan ]
  * stage1: compile error for loop expr val ignored

  [ Andrew Kelley ]
  * translate-c: we have our first test of self-hosted
  * fix hang for some compile errors
  * add test case for previous commit
  * translate-c: better handling of restore points
  * stage2 translate-c: builtin types and pub
  * stage2 translate-c: simple function definitions

  [ LemonBoy ]
  * linux: Fix clock_gettime on systems w/o VDSO
  * linux: Minor `zig fmt` induced reformatting
  * Fix more corner cases in LEB128 parsing

  [ daurnimator ]
  * std: the failing allocator didn't actually count allocations

  [ Sahnvour ]
  * Implement Windows' DirectAllocator on top of VirtualAlloc and VirtualFree.
  * Use unprotected heap when in single_threaded mode.

  [ Andrew Kelley ]
  * stage2 translate-c: implement functions with no prototype

  [ Jimmi Holst Christensen ]
  * Fixed parser for extern threadlocal variables
  * added tests for global variable declaration syntax
  * added grammar rule for enum literal to docs
  * fixes #2235

  [ LemonBoy ]
  * Validate enum tag for extern enum
  * Support signed types as enum tags
  * amend type_is_valid_extern_enum_tag
  * Change the enum value allocation strategy
  * Amend the error messages

  [ hryx ]
  * Recursive rewrite of stage2 parser, part 1

  [ Tyler Philbrick ]
  * Fix memory leak in parser tests

  [ hryx ]
  * Recursive rewrite of stage2 parser, part 3
  * Recursive rewrite of stage2 parser, final sync
  * Undo parse2 import

  [ Andrew Kelley ]
  * zig fmt on the standard library

  [ Marc Tiehuis ]
  * Mmap debug info on linux

  [ LemonBoy ]
  * Assemble asm files using CC

  [ Andrew Kelley ]
  * cache_add_dep_file: handle ErrorFileNotFound specially

  [ LemonBoy ]
  * Fix formatting for multiline asm expressions
  * Don't emit DW_TAG_lexical_block for VarDecls

  [ Andrew Kelley ]
  * else value when switching on error set has
  * fix regression on switch capture value for multiple cases
  * switching on error sets makes new error set for capture values
  * clean up code now that #769 is implemented
  * slice types no longer have field access

  [ LemonBoy ]
  * Fix off-by-one error in LEB128 parsing

  [ Andrew Kelley ]
  * update libclang C API wrapper
  * improvements to zig's implementation of libc and WebAssembly

  [ Shritesh Bhattarai ]
  * change wasm obj ext to .wasm

  [ Andrew Kelley ]
  * fix static builds of zig from requiring c compiler

  [ daurnimator ]
  * std: update linux syscalls to 5.1

  [ Andrew Kelley ]
  * clang C API wrapper: small progress
  * improvements to build-lib use case of WebAssembly
  * the wasm freestanding _start function is return value void

  [ Shritesh Bhattarai ]
  * docgen: add lib codeblock type and use it for wasm32-freestanding

  [ Shawn Landden ]
  * breaking changes to all bit manipulation intrinsics

  [ Andrew Kelley ]
  * fixups to the previous commit

  [ SamTebbs33 ]
  * Add break after digit_value check in TokenizeStateCharCode

  [ Andrew Kelley ]
  * stage1 tokenizer: add more missing break statements

  [ LemonBoy ]
  * VDSO calls must use the C CC
  * Fix some test cases to run on 32bit systems
  * Remove more 64bit-centric assumptions from stdlib
  * Fix load/store of non-integer fields in packed struct
  * Use the correct scope for `use`
  * Fix too eager comptime evaluation of error ptr

  [ emekoi ]
  * ran zig fmt on stdlib

  [ Shritesh Bhattarai ]
  * docs: wasm

  [ Marc Tiehuis ]
  * std.fmt.parse_float: Fix exponent calculation

  [ LemonBoy ]
  * Build archives using the K_DARWIN format when targeting osx
  * Remove macos-specific linking hacks
  * Fix signedness mismatch in comparison
  * Make use work with arbitrary structs

  [ Shritesh Bhattarai ]
  * docs: clarify why wasm_allocator should be used
  * doc: wasm: embedded->host

  [ Robert Scott ]
  * Implement @unionInit

  [ LemonBoy ]
  * Reject slices in use expressions

  [ Sahnvour ]
  * test: slightly better output for failure of tests based on text comparison
  * gen-h: do not output visibility macros when the build is static

  [ Andrew Kelley ]
  * support enum literals implicit casting to tagged unions
  * introduce @hasDecl builtin function
  * allow implicit optional pointer to optional c_void pointer
  * extract posix functions from std/os.zig to std/os/posix.zig
  * more progress on posix API layer
  * more progress. moving windows API layer to its own file
  * do Jay's suggestion with posix/os API naming & layout
  * rename "posix" to "bits"
  * starting to fix the regressions
  * clean up references to posix
  * clean up references to os
  * more cleanup. down to just the `@hasDecl` builtin

  [ hryx ]
  * WIP translate var decl
  * var decl: mut_token, create child scope

  [ Andrew Kelley ]
  * behavior tests passing on Linux

  [ hryx ]
  * var decl: threadlocal
  * var decl: init node
  * var decl: ImplicitCastExpr

  [ Andrew Kelley ]
  * tests passing on linux
  * fixes for Windows and WASI
  * more fixes for windows and wasi

  [ Shawn Landden ]
  * allow const to be passed to @hasField()

  [ Andrew Kelley ]
  * std lib fixes for zig build on windows
  * fix debug builds of WASI
  * nanosleep: move windows logic to std.time
  * fixes for darwin
  * std.fs: fix error set regressions on linux
  * use close$NOCANCEL on darwin
  * darwin: add missing error handling
  * revert hello world examples. macos tests passing
  * fixes for windows to build self hosted compiler
  * windows does not integrate cleanly with libc
  * freebsd fixes

  [ hryx ]
  * expr: BitCast for ImplicitCastExpr

  [ LemonBoy ]
  * Trigger rebuild on sr.ht

  [ hryx ]
  * Remove unused local struct type

  [ Michael Dusan ]
  * new .d file parser for C compilation

  [ Andrew Kelley ]
  * self-hosted translate-c: fix bad memory arena references

  [ hryx ]
  * Prevent infinite recursion

  [ Andrew Kelley ]
  * improve the stack check CLI options

  [ hryx ]
  * expr: FunctionToPointerDecay & ArrayToPointerDecay for ImplicitCastExpr

  [ emekoi ]
  * respect subsystem flag in all cases

  [ hryx ]
  * expr: DeclRefExpr
  * (broken) port a bunch of stuff from stage1 translate-c

  [ LemonBoy ]
  * Add sigaltstack syscall

  [ emekoi ]
  * remove unneed allocator from DynLib

  [ Gonzalo Diethelm ]
  * Add declarations missing from clang.zig
  * clang.zig cleanup #1: move block around
  * clang.zig cleanup #2: move block around
  * clang.zig cleanup #3: move block around
  * clang.zig cleanup #4: move block around
  * clang.zig cleanup #5: add missing enums
  * clang.zig cleanup #6: move block around
  * clang.zig cleanup #7: add missing struct
  * clang.zig cleanup #8: add missing consts
  * clang.zig cleanup #9: rename arg0 to self

  [ emekoi ]
  * updated dynamic libraries to new std

  [ LemonBoy ]
  * Fix os.mprotect signature
  * Add a guard page for each thread

  [ Andrew Kelley ]
  * thread.spawn: bubble up mprotect error.OutOfMemory

  [ LemonBoy ]
  * Move __zig_fail_unwrap locals on stack

  [ Andrew Kelley ]
  * Create FUNDING.yml
  * extract CONTRIBUTING.md from README.md
  * link to contributing in readme
  * fix invalid LLVM IR generated for ?*void const casts

  [ LemonBoy ]
  * Avoid a crash when there are no namespace components
  * Warn the user if run/test is paired with emit options
  * Reject undefined as type

  [ Andrew Kelley ]
  * no "use of undeclared identifer" in dead comptime branches

  [ Michael Dusan ]
  * add review changes

  [ Andrew Kelley ]
  * `use` works on unions and enums in addition to structs

  [ LemonBoy ]
  * Add sigaltstack wrapper in os.zig
  * Add missing sigaltstack definition for darwin

  [ emekoi ]
  * added subsystem to builtin.zig
  * try to resolve TargetSubSystemAuto to actual subsystem
  * set subsystem to null if not on windows or uefi

  [ Andrew Kelley ]
  * cleanups for windows subsystem in builtin.zig
  * codegen: initialize subsystem
  * main: set subsystem in `zig builtin` when explicitly provided

  [ hryx ]
  * Implement missing clang functions from last commit

  [ Andrew Kelley ]
  * change `use` to `usingnamespace`
  * zig fmt: fix 2 bugs of mangling source files
  * run zig fmt to update `use` to `usingnamespace`

  [ NBonaparte ]
  * LinuxDynLib: remove MAP_LOCKED flag
  * build_examples: reenable load_dynamic_library

  [ Timon Kruiper ]
  * Correct formatting for multiline string in arrays

  [ Shawn Landden ]
  * stage1: AstNodes cannot be casted, but are rather accessed via a union.

  [ Andrew Kelley ]
  * improve the libc of wasm32-freestanding target

  [ tgschultz ]
  * std.meta/trait: def/definition => decl/declaration TypeInfo: defs/Definition => decls/Declarations
  * Fix fmt.zig handling of slices of slices

  [ Andrew Kelley ]
  * update load dynamic library test for std lib changes

  [ LemonBoy ]
  * Fix some syscalls on arm64
  * Correct flag definitions for arm64

  [ Andrew Kelley ]
  * dep tokenizer: run zig fmt and move exports to canonical location
  * default struct field initialization expressions
  * no-copy semantics for basic runtime function call variable init
  * no-copy semantics for if expr
  * no-copy semantics for nested if
  * local consts with comptime init exprs
  * peer result locations with mixed runtime/comptime
  * no-copy semantics for function call init var and literal
  * no-copy semantics for function forwarding

  [ Shritesh Bhattarai ]
  * doc: recommend optional pointers for nullptrs instead of allowzero

  [ LemonBoy ]
  * Remove length restriction in mmap wrapper
  * Move dl_iterate_phdr to os.zig

  [ tgschultz ]
  * fixed Deserializer.alignToByte() and added test coverage

  [ Ryan Liptak ]
  * std.math: Add ceilPowerOfTwo and ceilPowerOfTwoPromote

  [ Andrew Kelley ]
  * add missing ir_expr_wrap calls
  * var types, alignment, and comptime
  * fix alignment of consts
  * while loops
  * no-copy semantics for for loops
  * no-copy semantics for if optional and if error union
  * fix the rest of the ir_build_alloca_src callsites

  [ LemonBoy ]
  * Make `void` a signed type
  * Propagate DIFlags to LLVM

  [ Andrew Kelley ]
  * std.os.mmap: update doc comments for previous commits

  [ Timon Kruiper ]
  * Added LineComment support when MultiLines are used in ArrayInit also added the corresponding testcase

  [ LemonBoy ]
  * Stop the musl builder from skipping necessary files

  [ Nick Erdmann ]
  * src/ast_render.cpp: fix rendering of character literals <= 0x0f

  [ Andrew Kelley ]
  * no-copy semantics for switch expressions

  [ Ryan Liptak ]
  * std.math: Clarify ceilPowerOfTwo inputs and disallow zero as an input

  [ mrkishi ]
  * add cache-control headers to tarballs on ci

  [ emekoi ]
  * windows.unexpectedError prints a human friendly string
  * removed duplicate definitions
  * updated std.c.{freebsd, netbsd} to usingnamespace
  * fixed mismatched types
  * switched to fixed-length buffer for error messages

  [ Ryan Liptak ]
  * std.HashMap: optimize indexing by avoiding modulo operator
  * std.HashMap: use std.math.ceilPowerOfTwo

  [ Andrew Kelley ]
  * no-copy semantics for peer result function calls
  * fix behavior for non sret fn calls
  * ci: let's try a new build of llvm+clang on 10.14
  * update the default macos version min to 10.14
  * fix behavior for peer result locs with one prong unreachable
  * hook up peer result locs to if optional and if err
  * hook up while on error unions with result locations
  * hook up peer result locs to while bool and optional
  * hook up result locs to for loops
  * hook up peer result locs to catch
  * hook up peer result locs to orelse keyword
  * hook up result locs for `try`

  [ Shritesh Bhattarai ]
  * docs: add comment about for else and break

  [ Shawn Landden ]
  * add bcmp implementation as LLVM 9 now emits those

  [ Andrew Kelley ]
  * result location mechanism for struct initialization

  [ hryx ]
  * transCStyleCastExpr
  * transImplictCastExpr: LValueToRValue
  * (broken) translate Paren type
  * Restore fn decls removed during conflict

  [ Jonathan Pentecost ]
  * docs: update for else example

  [ markfirmware ]
  * grammar

  [ Sahnvour ]
  * allow comptime_int in math.shl and math.shr
  * implementation of the Sfc64 RNG from PractRand

  [ Andrew Kelley ]
  * remove ResultLocField dead code
  * result loc semantics for array initialization
  * different array literal syntax when inferring the size
  * inferred array size of array literals works
  * fix build on macos

  [ daurnimator ]
  * std: add math.isPowerOfTwo

  [ Andrew Kelley ]
  * fix array literal syntax

  [ daurnimator ]
  * std: testing.expectEqual on structs now works
  * std: add linux kernel_rwf type and preadv2+pwritev2
  * std: add linux kernel definitions for io_uring

  [ SamTebbs33 ]
  * Add check for null body in if, for and while

  [ Andrew Kelley ]
  * whitespace cleanup

  [ daurnimator ]
  * std: existing LinkedList is actually a TailQueue
  * std: Add singly linked list
  * std.heap.ArenaAllocator: use singly linked list

  [ hryx ]
  * (broken) local var decls, integer literals (part)

  [ Andrew Kelley ]
  * hook up result locations for union initializations
  * result location semantics for `@bitCast`
  * result location semantics for slices
  * result location semantics for optional wrap

  [ Ryan Liptak ]
  * Use std.math.isPowerOfTwo across std lib

  [ Andrew Kelley ]
  * result location semantics for error union wrapping a payload

  [ tgschultz ]
  * altered all instances of readInt* in std.io (and std.debug) to consume the minimum byte size required instead of @sizeOf().

  [ Andrew Kelley ]
  * result location semantics for error union wrapping an error
  * result location semantics for cmpxchg
  * result loc semantics for `@sliceToBytes` and `@bytesToSlice`
  * result loc semantics for loading packed struct pointer to packed struct
  * result location semantics for vector to array
  * fix peer result locations in the face of unreachable
  * use result loc for ref instruction
  * remove the final legacy stack allocation
  * fix comptime function calls
  * fix comptime variables
  * fixes for crashes and compile errors

  [ hryx ]
  * transReturnStmt

  [ daurnimator ]
  * std: add std.http.Headers field

  [ Andrew Kelley ]
  * fix implicit casting return value struct/arary init to optional
  * fix struct and array init when result casted to anyerror!?T
  * fix struct and array init when result casted to anyerror!?T
  * fix not checking return value of resolving result
  * fix for loop index variable not in scope

  [ Nicholas Walton ]
  * Update langref.html.in

  [ Andrew Kelley ]
  * temporarily simplify test_runner.zig
  * fix `@bitCast` semantics when there is no parent result loc
  * fix returning scalar values

  [ emekoi ]
  * made root package available to all other packages
  * made root package available to itself

  [ Andrew Kelley ]
  * fix runtime if nested inside comptime if

  [ emekoi ]
  * fixed infinite loop when caching packages

  [ Andrew Kelley ]
  * fix `@bitCast` regressions
  * fix alignment problem with `@bitCast` result location
  * fix `@bitCast` with runtime scalar and dest result loc var
  * fix nested peer result locs with no memory loc
  * fix declref not writing to result loc
  * fix double nested peer result locations
  * fix result loc implicit casting optionals and error unions
  * comment out the behavior tests that are failing

  [ Josh Wolfe ]
  * Add HashMap apis that assert the common case

  [ Jonathan Marler ]
  * Handle putNoClobber errors

  [ Josh Wolfe ]
  * HashMap.getValue()

  [ Jonathan Marler ]
  * Remove const on argsAlloc

  [ Andrew Kelley ]
  * fix runtime initialize array elem and then implicit cast to slice
  * fix behavior for nested array literals
  * allow comptime array literals casted to slices
  * fix atomic builtin functions
  * fix bitcast packed struct to integer and back
  * fix a couple more test regressions
  * fix peer result location with error code and payload
  * fix peer result locs with switch
  * uncomment more passing tests
  * fix `@export` for arrays and allow sections on extern variables
  * fix `@export` for arrays not respecting the symbol name
  * expose builtin.strip_debug_info
  * standard library integrates with knowledge of stripped debug info
  * better result location semantics with optionals and return locations
  * better result location handling of inline loops

  [ Jimmi HC ]
  * fixes resolving aligment of child type in slice

  [ Andrew Kelley ]
  * fix type info crash on extern lib name

  [ Shawn Landden ]
  * stage1: check for null in buf_len and buf_ptr

  [ Timon Kruiper ]
  * Added HashInt to function calls AutoHash\nFixes issue 2669

  [ daurnimator ]
  * std: add gimli permutation to crypto

  [ Josh Wolfe ]
  * mem.concat

  [ Marc Tiehuis ]
  * Small cleanup of fmt.zig

  [ Andrew Kelley ]
  * inferred comptime values rather than elided scopes

  [ Jonathan Marler ]
  * Remove duplicate exe name with zig run

  [ Andrew Kelley ]
  * inferred comptime union inits
  * fix function calls
  * inferred comptime array inits
  * misc fixes

  [ Boris ]
  * fix tiny typo in langref.html.in

  [ Andrew Kelley ]
  * fix zero length array literal casted to slice
  * Revert "fixes resolving aligment of child type in slice"
  * when resolving slice types, might need to...

  [ Jonathan Marler ]
  * Fix windows create process retry/path search

  [ Andrew Kelley ]
  * more miscellaneous fixes
  * fix bitcast
  * fix problem with inferred error set return result

  [ joachimschmidt557 ]
  * Correct the isEmpty function

  [ Andrew Kelley ]
  * back to many behavioral tests passing
  * fix inline loop behavior with variable result loc

  [ Shawn Landden ]
  * c: add fma and fmaf
  * stage1: add support for @mulAdd fused-multiply-add for floats and vectors of floats
  * test: include muladd.zig in behavior tests

  [ Andrew Kelley ]
  * fix comptime modification of const struct field
  * fix detection of unable to evaluate constant expression
  * fix extraneous nested union field instruction
  * fix comptime test error for empty error set
  * fix `try` not setting error code on result location
  * fix optional pointer to size zero struct
  * fix double getelementptr of runtime global
  * fix labeled break inside comptime if inside runtime if
  * fix peer result loc fn call with comptime condition
  * one more test passing
  * fix coroutines

  [ Michael Dusan ]
  * fix macOS stack trace regression

  [ Matthew Murray ]
  * Fix absFloat

  [ Andrew Kelley ]
  * fix loops with multiple break statements
  * BRANCH_TODO file moved to the pull request comments
  * fix regression with zero sized array

  [ Marc Tiehuis ]
  * breaking: Add positional, precision and width support to std.fmt
  * Link formatting workaround to issue

  [ Shawn Landden ]
  * stage1: update fn_key_eql() for @mulAdd() on vectors

  [ Andrew Kelley ]
  * blocks have result location semantics
  * fix nested orelse and nested catch
  * fix extern functions returning byval structs
  * fix implicit cast bitcast result to error union by returning
  * fix implicit cast to optional to error union to return result loc
  * fix return result loc and then switch with range...
  * uncomment passing std lib tests
  * fix ArenaAllocator

  [ Gray Olson ]
  * Update langref.html.in

  [ Andrew Kelley ]
  * fix implicit cast fn call result to optional in field result

  [ Sahnvour ]
  * heap: make one global instance of DirectAllocator

  [ Shawn Landden ]
  * stage1: add @sin @cos @exp @exp2 @ln @log2 @log10 @fabs @floor @ceil @trunc @round

  [ Andrew Kelley ]
  * elide redundant safety check when switching on tagged unions
  * fix std.json regression
  * fix another crash

  [ hryx ]
  * Assign undefined literal (instead of null) when no init value
  * Translate assignment BinaryOperator statements

  [ emekoi ]
  * make string literal const on windows
  * supress warnings for format strings on msys64

  [ Andrew Kelley ]
  * fix some legacy coroutine stuff
  * uncomment passing std lib tests

  [ hryx ]
  * Fix recursive self-referential block

  [ Andrew Kelley ]
  * compile error tests only for debug mode

  [ hryx ]
  * Fix order of tokens; omit 'pub' for fn types
  * stage1: always render space after `fn` like stage2

  [ emekoi ]
  * increase stack size for mingw

  [ Andrew Kelley ]
  * remove stray abort

  [ hryx ]
  * Observe translate mode in stage2
  * transStringLiteral
  * transBinaryOperator: Add, Sub

  [ Michael Dusan ]
  * align (vector -> array) store to result location
  * fix compile error when building zig w/ clang

  [ Vexu ]
  * fixed comment formatting in arrays and fn params

  [ Marc Tiehuis ]
  * Add parsing of fill and alignment in std.format

  [ Carter Sande ]
  * compiler-rt: Support thumb versions older than armv6

  [ hryx ]
  * Escape C string literals

  [ Andrew Kelley ]
  * fix union init with void payload
  * fix implicit cast vector to array
  * fix infinite loop when error in peer resolution
  * fix several compile error test regressions
  * all compile error tests passing
  * fix peer type resolution with null

  [ Carter Sande ]
  * compiler-rt: use more idiomatic switch syntax

  [ Vexu ]
  * fixed IfTypeExpr parsing

  [ Andrew Kelley ]
  * fix peer type resolution: unreachable, error set, unreachable
  * disable building self hosted compiler in test suite

  [ Vexu ]
  * improved comment indentation in arrays

  [ Luna ]
  * net: quickfix on non-existing Address.family

  [ Andrew Kelley ]
  * all tests passing on linux
  * add missing error code for DeleteFileW
  * fix incorrectly omitting variable declarations

  [ Vexu ]
  * added better test cases
  * fix comments getting removed after empty comments

  [ Andrew Kelley ]
  * add test case for defer modifying return value before returned

  [ Marc Tiehuis ]
  * Remove #2725 workaround

  [ Andrew Kelley ]
  * better CLI error message for missing sub-architecture
  * fixups
  * compile error for using slice as array init expr type
  * update format function for new std fmt changes
  * avoid std.debug.global_allocator in http headers tests
  * fix switch with null and T peer types and inferred result location type

  [ SamTebbs33 ]
  * Add doc comments to alignment functions

  [ Andrew Kelley ]
  * fix for with null and T peer types and inferred result location type

  [ SamTebbs33 ]
  * Add check for power of 2 to std.mem.alignBackward

  [ Andrew Kelley ]
  * fixups

  [ hryx ]
  * Create and render big.Int from IntegerLiteral; group BinaryOperator
  * Separate with space instead of LF to prevent rendering excessive indentation
  * Use new width format option

  [ Andrew Kelley ]
  * rename std/special/bootstrap.zig to std/special/start.zig

  [ hryx ]
  * Translate IntegralCast; add stage2 test coverage

  [ emekoi ]
  * fixed debug info on windows
  * initialize sections in openSelfDebugInfoWindows

  [ hryx ]
  * Fix string literal: not null-terminated (thanks @mikdusan)
  * Don't return a slice pointing to a deceased stack address

  [ Michael Dusan ]
  * fix stack escape in add_source_file()

  [ emekoi ]
  * fix syntax highlighting
  * fix formatting
  * added init function for `Coff`

  [ hryx ]
  * Define different struct size for APValue on Windows (thanks @Sahnvour)

  [ Marc Tiehuis ]
  * Update for new fmt.zig formatting

  [ emekoi ]
  * added invalid switch prong error

  [ Timon Kruiper ]
  * Added function-section functionality

  [ Andrew Kelley ]
  * stack traces on segfault by default for linux-x86_64
  * enable segfault stack traces in stage1 compiler

  [ Timon Kruiper ]
  * Added ZigLLVMCreateTargetMachine and pass function-sections flag Also added extra cache line

  [ Andrew Kelley ]
  * improved logic on whether to include start files

  [ emekoi ]
  * return `FileNotFound` for PATH_NOT_FOUND in DeleteFileW

  [ Andrew Kelley ]
  * docs: mention the standard library documentation
  * print dir name on failure to write to cache dir
  * fixups
  * update the default panic handler on freestanding
  * add missing compile error for comptime continue inside runtime catch
  * update `@unionInit` to integrate with result location semantics

  [ emekoi ]
  * added segfault handler support for windows
  * added tests for #1107 and a note in the reference

  [ Andrew Kelley ]
  * add -ffunction-sections arg when building C objects
  * workaround for no equality operator for enum literal and tagged union
  * add docs for enum literals
  * improve the error message and test coverage

  [ emekoi ]
  * forward error code build.zig
  * forward error code on non-exits

  [ SamTebbs33 ]
  * Support returning !u8 from main

  [ Andrew Kelley ]
  * zig build: install is now the default step; default prefix is zig-cache

  [ Michael Dusan ]
  * stage1: add missing help for `--override-lib-dir`

  [ Andrew Kelley ]
  * zig build: search upwards for build.zig file

  [ hryx ]
  * Unicode escapes: stage2 tokenizer and parser test
  * Unicode escapes: stage1 tokenizer and behavior tests
  * Unicode escapes: documentation and grammar

  [ Andrew Kelley ]
  * std.os.abort no longer calls msvcrt abort() when linking libc
  * add std.os.windows.subsystem
  * docs: mention `@unionInit` in the union section
  * code formatting
  * zig fmt: fix whitespace
  * zig fmt ignores "zig fmt: off" directive for whitespace fixes

  [ hryx ]
  * Prevent unreachable when file ends with struct field

  [ SamTebbs33 ]
  * Add implicit cast for *[N]T to [*c]T

  [ hryx ]
  * Make anyerror not a keyword
  * Remove reference to Keyword_anyerror in docgen

  [ daurnimator ]
  * std: Linux AT_ constants are the same across architectures
  * std: Make linux MAP_ definitions match kernel
  * std: MAP_FAILED is a libc concept on linux

  [ Andrew Kelley ]
  * zig build: add setLibCFile API
  * add an update_glibc tool, delete dummy libc files
  * ability to target any glibc version
  * add -target-glibc to cli help and zig build
  * remove debug log
  * expose glibc version in builtin
  * fix not setting a target glibc version on non-linux
  * zero initialize target
  * avoid dependency on linux/limits.h header
  * std.os.getrandom does a libc version check
  * cap getdents length argument to INT_MAX
  * zig build: install .pdb files along with binaries

  [ Ian Lilley ]
  * fixed path with spaces in llvm-config (#2854)

  [ Andrew Kelley ]
  * Revert "fixed path with spaces in llvm-config (#2854)"
  * zig build: add standardTargetOptions and deprecate setTarget
  * ship with mingw-w64 v6.0.0

  [ dimenus ]
  * resolved #2064 & fixed hello_world libc build

  [ Andrew Kelley ]
  * mingw: building and linking mingw32.lib
  * mingw: building and linking msvcrt-os.lib

  [ dimenus ]
  * fixing non system library linking

  [ Andrew Kelley ]
  * mingw: build and link mingwex.lib
  * add some more windows defs
  * fix windows not able to build mingw
  * the msvc target abi will have to be solved a different way
  * funding: I've been accepted into the GitHub Sponsors program

  [ Michael Dusan ]
  * doc clarify struct size and ABI-alignment

  [ Andrew Kelley ]
  * add -Wno-pragma-pack when targeting windows-gnu

  [ thomas ]
  * fix typo in help text for bundle-compiler-rt

  [ daurnimator ]
  * std: add new linux 5.2 constants

  [ Andrew Kelley ]
  * translate-c: better detection of pointer to struct demoted to opaque
  * mingw libc: solve the segfault having to do with destructors
  * update zig build system for mingw static lib conventions
  * fix build.zig
  * handle mingw libc defs better
  * mingw libc: delete dead linker code regarding using system libc

  [ emekoi ]
  * fixed compilation on mingw-w64

  [ andersfr ]
  * Ported CityHash and Murmur hashing algorithms to native zig
  * Better testing and bugfix in hashUint* functions
  * Proper use of @truncate instead of @intCast
  * Intentional wraparound used +

  [ Andrew Kelley ]
  * translate-c: fix incorrectly translated double function pointer
  * ir: add an assertion in phi analysis

  [ emekoi ]
  * fixed static linking on mingw-w64

  [ Andrew Kelley ]
  * move some of the installation from cmake to zig build
  * cmake: fix incorrect dependencies
  * std.fs.updateFile: make path if necessary
  * implement std.fs.File.updateTimes for windows
  * fix the build on windows
  * fix the build on linux
  * move install_files.h to not be generated code
  * fix the build on macos
  * move lib dirs to lib subdir
  * mingw libc can link against ntdll
  * std.unicode.utf8ToUtf16Le: improve performance
  * fix build on windows

  [ Nick Erdmann ]
  * fix documentation of assert

  [ Andrew Kelley ]
  * avoid shipping junk files
  * fix result location alignment in ir_render_call
  * fix gitattributes

  [ emekoi ]
  * fixed size of ZigClangAPValue on mingw-w64

  [ Andrew Kelley ]
  * cleanups
  * fix documentation regarding mixing object files
  * retire the example/ folder, rename test-build-examples to "standalone"

  [ daurnimator ]
  * cmake: allow user to select static vs dynamic LLVM

  [ JohnathanFL ]
  * Add multidimensional array example

  [ Andrew Kelley ]
  * organize the docs and some rewording
  * rename internal names regarding `usingnamespace`
  * update musl headers to musl v1.1.23
  * update bundled musl source to 1.1.23
  * libc headers before C language headers, and disable libunwind on arm32
  * update to llvm9 trunk

  [ dimenus ]
  * fixed slice length in getEnvVarOwned

  [ Andrew Kelley ]
  * back to msvc as the default C ABI on Windows
  * WIN32 -> _WIN32
  * update zig codebase to llvm 9
  * msvc libc: provide _fltused symbol
  * carry some upstream patches to musl to fix riscv inline asm
  * improvements to riscv support
  * riscv musl: only add the +a feature
  * compiler-rt: add __muldi3
  * basic riscv support
  * riscv workarounds for llvm not having good asm integration

  [ Michael Dusan ]
  * closes #2916

  [ Andrew Kelley ]
  * better riscv syscalls
  * zig build: add valgrind cli options
  * update C headers to llvm9
  * update libunwind to llvm9
  * update libcxx to llvm9
  * fix usingnamespace

  [ Benjamin Feng ]
  * Tokenize '&&' as AmpersandAmpersand
  * Generate parse error from &&
  * Switch old switch / @TagType() to use inferred enums
  * Docgen invalid for &&

  [ Andrew Kelley ]
  * slightly simpler implementation
  * update clang driver code to llvm9
  * remove coroutines implementation and promise type
  * always give the type to byval attribute
  * docs: don't try to run the undefined behavior example test
  * simple async function call working
  * remove errors for async calling convention
  * fix not jumping to entry
  * returning from async fn adds bad resume safety
  * zig build: support DESTDIR environment variable
  * simple async function passing test
  * implement coroutine resume
  * implement async function parameters
  * fix wrong calling convention on async resume
  * zig build: adjust DESTDIR logic
  * disable segfault handler when panicking
  * fix usingnamespace analyzing the expression multiple times
  * disable segfault handler when panicking
  * compiler-rt: add __muldi3
  * fix suspend at end of function
  * fix multiple coroutines existing clobbering each other

  [ Vexu ]
  * fix escape sequence rendering

  [ Timon Kruiper ]
  * Fixed an integer overflow in zig fmt and added testcase

  [ Andrew Kelley ]
  * inferring async from async calls
  * add error for function with ccc indirectly calling async function
  * implement local variables in async functions

  [ Michael Dusan ]
  * align src for IrInstructionArrayToVector

  [ Andrew Kelley ]
  * add test for previous commit
  * calling an inferred async function
  * implement `@frame` and `@Frame`
  * implement `@frameSize`
  * `@frameSize` works via PrefixData
  * async functions return void, no more GetSize resume block

  [ Joachim Henke ]
  * avoid a register copy when fetching the stack pointer in _start

  [ emekoi ]
  * improved CMake file for MinGW

  [ Andrew Kelley ]
  * add the `anyframe` and `anyframe->T` types

  [ emekoi ]
  * fixed backtraces when linking libc on mingw
  * avoid passing -static to msvc when static linking

  [ Nick Erdmann ]
  * src/target.cpp: UEFI improvements
  * std/build.zig: add checks for UEFI

  [ Evan Krause ]
  * support zero-sized structs in zig.fmt.format

  [ Michael Dusan ]
  * fix std.rb.Node.getParent to return optional

  [ Nick Erdmann ]
  * std/build.zig: fix stack checking option

  [ Michael Dusan ]
  * fix std.fmt to handle std.SegmentedList

  [ Sahnvour ]
  * os: missing accessW since recent refactoring
  * coff & pdb: improved correctness of our implementation, it is now able to handle stage1's pdb and print its stack traces
  * pdb: improved stream reading performance, printing stack trace from a stage1 crash is now 10x faster

  [ Andrew Kelley ]
  * improve support for anyframe and anyframe->T

  [ Benjamin Feng ]
  * Add builder.findProgram test and fix references
  * More current style for error handling
  * Default wasm-lib prefix to empty

  [ Andrew Kelley ]
  * allow 128 bit cmpxchg on x86_64
  * disable behavior test for 128-bit cmpxchg
  * reimplement async with function splitting instead of switch
  * fix calling an inferred async function
  * more passing coroutine tests
  * implement async await and return

  [ Euan Torano ]
  * Check if /dev/urandom is a character device
  * Fix call to S_ISCHR and implement for Mac
  * Add S_* values for freebsd.

  [ Andrew Kelley ]
  * assignment participates in result location
  * fix cmpxchg with discarded result
  * fix discarding function call results
  * fix regressions regarding writing through const pointers
  * add heap allocated async function frame test
  * docs: add atomicrmw operations list
  * implement async functions returning structs

  [ emekoi ]
  * implemented runtime abi detetction for windows
  * accept unix style paths on windows-gnu

  [ Christoffer Rasmussen ]
  * Fix public function lookup

  [ Andrew Kelley ]
  * add compile error for async call of function pointer

  [ daurnimator ]
  * std: return Elf object from constructors instead of filling in pointer

  [ Andrew Kelley ]
  * add runtime safety for resuming an awaiting function
  * add compile error for calling async function pointer

  [ Euan T ]
  * Update returned error return when not a character device.
  * Omit system namespace.

  [ Andrew Kelley ]
  * update embedded LLD to 9.0.0rc1
  * LLD patch: workaround for buggy MACH-O code
  * implement `@asyncCall` which supports async function pointers

  [ emekoi ]
  * move windows abi detection to `get_native_target`

  [ Andrew Kelley ]
  * fix regression in calling extern functions

  [ daurnimator ]
  * std: remove elf.auto_close_stream and elf.prealloc_file

  [ Sahnvour ]
  * direct port of wyhash v2 also inspired by https://github.com/ManDeJan/zig-wyhash
  * use wyhash in std's hashmap, and improve autoHash to handle more types and behave more correctly
  * fix hashmap using strings as keys

  [ Marc Tiehuis ]
  * Add iterative wyhash api
  * Add throughput test program for hash functions

  [ Sahnvour ]
  * adapt http/headers.zig to wyhash's new interface
  * make use of hashing streaming interface in autoHash
  * move autoHash into its own module since it can be used with any hash function implementing a streaming interface
  * wyhash: stateless is faster for both iterative hashing and small keys.
  * autohash: force inlining of integer hashing so that the optimizer can see the fast path based on key's size which is known at comptime

  [ Andrew Kelley ]
  * update CONTRIBUTING.md

  [ Nick Erdmann ]
  * initial work torwards std lib support for uefi

  [ Andrew Kelley ]
  * suspension points inside branching control flow
  * move state from ZigFn to CodeGen to save memory
  * simpler, less memory intensive suspend/resume implementation
  * refactor logic for determining if there is a frame pointer
  * support async functions with inferred error sets
  * delete IrInstructionMarkErrRetTracePtr
  * add a src() method to AstNode to aid debugging
  * async functions have error return traces where appropriate

  [ Euan Torano ]
  * Add missing S_IS* for NetBSD

  [ Euan T ]
  * Add misisng newline

  [ Nick Erdmann ]
  * std/os/uefi: replace integer bit fields with packed structs

  [ Euan Torano ]
  * Fix #2993 - use getrandom on freebsd

  [ Andrew Kelley ]
  * update readme

  [ Benjamin Feng ]
  * Humanize tokenized symbol names
  * Output token symbols similar to stage1

  [ Nick Erdmann ]
  * std/os/uefi: replace init() with default values

  [ Euan Torano ]
  * Fix function signature and use a loop to ensure buffer is filled.

  [ Andrew Kelley ]
  * improve async function semantics
  * passing the error return trace async function test
  * error return trace across suspend points
  * fix awaiting when result type is a struct
  * implement cancel
  * clean up the bitcasting of awaiter fn ptr
  * cancel works on non-pointers

  [ Ryan Saunderson ]
  * modify header precedence for zig cc, resolves intrinsics issues (#3027)

  [ Andrew Kelley ]
  * std.math.min: return a more restrictive type sometimes

  [ Sam Tebbs ]
  * Don't emit clang error if source or filename pointer is null

  [ Euan Torano ]
  * Remove unneeded casts.

  [ Andrew Kelley ]
  * cancel, defer, errdefer all working as intended now
  * more debuggable safety for awaiting twice
  * async functions in single threaded mode do not use atomic ops
  * add compile error for unable to determine async fn frame
  * better compile errors when frame depends on itself
  * fix segfault with var args
  * fix var args call on non-generic function
  * closer to std lib event stuff working
  * fix passing string literals to async functions
  * fix regression in std.math.min
  * add a little compile error to make Future Andy's life easier
  * fix cancel inside an errdefer
  * fix combining try with errdefer cancel

  [ Nick Erdmann ]
  * std/os/uefi: change type of Handle from @OpaqueType to *@OpaqueType
  * std/os/uefi: add basic Event support

  [ Andrew Kelley ]
  * fix try in an async function with error union and non-zero-bit payload
  * fix returning a const error from async function
  * add test case for typical async/await usage

  [ Nick Erdmann ]
  * src/codegen: configure stack probes explicitly
  * std/os/uefi: some more events

  [ data-man ]
  * Fixed tiny typo in the math module (shr's description)

  [ Andrew Kelley ]
  * allow comptime_int to implicit cast to comptime_float
  * fix enum with one member and custom tag type
  * fix canceling async functions which have error return tracing
  * README: link to community projects
  * all tests passing
  * fix cancel invoking branch on undefined memory
  * fix no-longer-correct `nonnull` attribute on merge err ret traces fn
  * fix async function frames not aligned enough
  * flip the order of fields in error unions
  * alignment of structs no longer depends on LLVM
  * organize TODOs
  * avoid the word "coroutine", they're "async functions"
  * get_struct_type accepts field alignment overrides
  * respect local variable alignment in async functions
  * rename behavior test files
  * add compile error for await in exported function
  * codegen for async call of blocking function
  * remove `cancel`
  * force static libs for vendored dependencies
  * fix error return traces for async calls of blocking functions
  * basic docs for new async/await semantics
  * zig fmt
  * add assertion about control flow to fix gcc warning
  * fix crash with sometimes type not being resolved
  * note that -mllvm is unsupported

  [ Vexu ]
  * implement new async syntax in self-hosted compiler

  [ Andrew Kelley ]
  * zig fmt: add more test cases
  * zig fmt
  * add compile error for @Frame() of generic function
  * add test for wrong frame type used for async call
  * add test for async call of generic function
  * add tests for bad implicit casting of anyframe types
  * codegen: LLVMConstSub instead of LLVMBuildSub in one place
  * add compile error for casting const frame to anyframe

  [ yvt ]
  * correct LLVM subarch names for arm

  [ Andrew Kelley ]
  * fix and test case for returning from suspend block
  * add test for struct parameter to async function being copied
  * add missing compile error for fn call bad implicit cast
  * target: add missing switch case
  * improvements to std lib for event-based I/O
  * std.event.Loop: fix not waking up after file system I/O
  * fix event loop regression on macos
  * fix compiler not checking alignment of function frames

  [ Vexu ]
  * add compile error for incorrect atomic ordering in fence #3082

  [ Andrew Kelley ]
  * detect non-async function pointer of inferred async function
  * allow implicit cast of fn to async fn

  [ Marc Tiehuis ]
  * std/fmt: Move pointer parsing out of main state machine

  [ Andrew Kelley ]
  * add compile error for async frames depending on themselves

  [ Nick Erdmann ]
  * fix error message when dependency requires position independent code

  [ Marc Tiehuis ]
  * std/fmt.zig: Pass full options struct to all internal functions
  * std/fmt: Make FormatOptions arguments non-comptime

  [ Andrew Kelley ]
  * don't put libc on the elf linker line for objects
  * fix array multiplication not setting parent value info
  * fix void array as a local variable initializer

  [ Aaron Klapatch ]
  * added documentation for field access to C pointers (#3088)

  [ Michael Dusan ]
  * fix @bitCast segfault with literal array param

  [ Andrew Kelley ]
  * solve it a slightly different way
  * fix @bitCast of packed struct literal

  [ Timon Kruiper ]
  * compiler error when variable in asm template cannot be found

  [ Andrew Kelley ]
  * specify the target for the newest test case
  * add std.c.printf

  [ Euan Torano ]
  * Fix InStream.readNoEof
  * fix os.getrandom logic to fill the entire buffer

  [ Andrew Kelley ]
  * fixups
  * update C headers to clang 9.0.0-rc2
  * update embedded LLD to 9.0.0-rc2
  * update libcxx to 9.0.0-rc2
  * LLD patch: workaround for buggy MACH-O code
  * remove incorrect assert regarding 128-bit integers

  [ Marc Tiehuis ]
  * Update hash/crypto benchmark scripts
  * Add more hash functions to benchmark scripts
  * Add iterative-only filter to hash benchmark
  * Inline full slice hashing

  [ Andrew Kelley ]
  * breaking: remove field alignment kludge
  * introduce lazy values
  * add missing "referenced here" notes for lazy values
  * simple self-referential struct is working now
  * fix regressions

  [ Tetralux ]
  * parsing of align(N) on struct fields
  * rendering of align(N) on struct fields

  [ Jonathan Marler ]
  * Encapsulate bigint representation, assert on cast data loss

  [ Andrew Kelley ]
  * add lazy value for fn prototypes
  * allow top level declarations to be lazy
  * pointer types lazily evaluate their element type
  * better handling of lazy structs
  * fix regression with simple pointer to self
  * add lazy value support for optional types
  * fix regression on `@ptrCast`
  * tracking these issues on github now

  [ Marc Tiehuis ]
  * std/hash: Revert crc32 api change

  [ Sahnvour ]
  * auto_hash: better generic hashing implementation
  * hash_map: adding a StringHashMap for convenience
  * wyhash: readd the stateful streaming version so that both are available

  [ Jonathan Marler ]
  * Fix issue 3058: zig build segfault

  [ Andrew Kelley ]
  * hook up unions with lazy values
  * fix behavior test regressions with unions
  * make the zero-bit-ness of pointers lazy
  * behavior tests passing
  * fix resolution detection of pointer types
  * fix assertion tripped instead of reporting compile error
  * make `@alignOf` lazily evaluate the target type
  * fix dependency loop errors with zig build
  * fix some std lib dependency loops
  * fix some compile error regressions
  * fix regression on struct field with undefined type
  * fix regression with global variable assignment...
  * fix regression in ir_get_ref
  * miscellaneous fixes regarding compile errors
  * remove no longer needed gcc8 workaround. add gcc9 workaround
  * fix more compile error regressions
  * fix regression in one of the doc examples

  [ Marc Tiehuis ]
  * Improve siphash performance for small keys by up to 30% (#3124)

  [ Andrew Kelley ]
  * implement and test struct field explicit alignment
  * add a TODO compile error for union field alignment syntax
  * fix not properly casting align values
  * add regression test for bug fixed by lazy values

  [ Marc Tiehuis ]
  * Simplify wyhash and improve speed

  [ Andrew Kelley ]
  * add regression test for bug fixed by lazy values
  * better handle struct depends on itself via optional field
  * add regression test for struct with optional list of self
  * support self-referential struct through a slice of optional
  * add regression test for already fixed bug

  [ Robin Voetter ]
  * add arm32 linux bits definitions

  [ Andrew Kelley ]
  * implement lazy values for error union types

  [ Robin Voetter ]
  * add arm32 syscall conventions

  [ yvt ]
  * Improve the handling of `zig fmt: off/on`

  [ Andrew Kelley ]
  * fix implicit cast from zero sized array ptr to slice
  * add suggestion to AutoHash compile error message

  [ Robin Voetter ]
  * Add more syscall constants
  * Make mmap use SYS_mmap2 if it exists
  * TLS initialization, clone definition and _start functionality
  * fix issues with debug.zig
  * Don't print line info if source is not available

  [ Shritesh ]
  * Use LLVM path provided by homebrew

  [ Andrew Kelley ]
  * fix not fully resolving debug info for structs causing llvm error
  * fix not fully resolving debug info for structs causing llvm error

  [ Robin Voetter ]
  * add __aeabi_read_tp

  [ Andrew Kelley ]
  * make `@sizeOf` lazy
  * comparing against zero participates in lazy values
  * avoid unnecessarily requiring alignment for array elem pointers
  * await does not force async if callee is blocking
  * fix regressions

  [ Hong Shick Pak ]
  * zig fmt: fix nested if
  * run new zig fmt and remove stale comment

  [ Robin Voetter ]
  * Improve comments near un-implemented functionality
  * Remove unneeded os check

  [ Michael Dusan ]
  * fix stage1 to build on macOS + xcode/clang

  [ Andrew Kelley ]
  * align(@alignOf(T)) T does not force resolution of T
  * update process_headers.zig for latest zig
  * musl: fix alltypes.h and syscall.h not being correct
  * support recursive async and non-async functions
  * `@typeOf` now guarantees no runtime side effects
  * improvements to `@asyncCall`

  [ Michael Dusan ]
  * stage1 enhance IR print

  [ Andrew Kelley ]
  * fix `@typeOf` an async function call of generic fn with error union type
  * Revert "Merge pull request #2991 from emekoi/mingw-ci"

  [ Robin Voetter ]
  * Replace legacy 16-bit syscalls with 32-bit versions when appropriate
  * Fix up seteuid and setegid
  * Fix up preadv, preadv2, pwritev and pwritev2

  [ Andrew Kelley ]
  * add regression test for already fixed bug
  * add ability to specify darwin framework search dirs
  * fix using @typeOf on a generic function call

  [ Nick Erdmann ]
  * std/os/uefi: add global_variable guid

  [ Andrew Kelley ]
  * fix recursive call of await @asyncCall with struct return type

  [ Nick Erdmann ]
  * std/os/uefi: add support for getting memory map
  * std/os/uefi: fix ordering of packed bit fields

  [ Andrew Kelley ]
  * fix const result loc, runtime if cond, else unreachable

  [ Michael Dusan ]
  * cmake: improve building without git repository

  [ Andrew Kelley ]
  * omit prefix data for async functions sometimes

  [ Michael Dusan ]
  * test: add compare-panic

  [ Andrew Kelley ]
  * rename compare-panic to compare-stack-traces
  * rename test-compare-panic to test-stack-traces

  [ Vesa Kaihlavirta ]
  * Fix addition direction, remove superfluous loop counter, add tests

  [ Andrew Kelley ]
  * fix stack traces on macos when passing absolute path to root source file
  * fix compiler crash in struct field pointers
  * zig build: make install prefix available to build.zig and

  [ Sahnvour ]
  * changing occurrences of HashMap with []const u8 as keys for StringHashMap
  * add fastpath for std.mem.eql and simplify std.hash_map.eqlString

  [ Andrew Kelley ]
  * fix union field ptr ir instruction

  [ Sahnvour ]
  * error message and test for alignment of variables of zero-bit types

  [ Andrew Kelley ]
  * emit a compile error if a test becomes async

  [ Jonathan Marler ]
  * Add @Type builtin

  [ Robin Voetter ]
  * Add missing clobbers on arm-eabi and arm64 syscall conventions
  * Implement remaining requested changes

  [ Andrew Kelley ]
  * fixups and add documentation for `@Type`

  [ Robin Voetter ]
  * Only check for TLS support on arm if TLS segment exists

  [ Timon Kruiper ]
  * Implicit cast from enum literal to optional enum and implicit cast to payload of error union

  [ Andrew Kelley ]
  * fix typo with tls initialization

  [ LemonBoy ]
  * Add the noinline keyword for function declarations

  [ Michael Dusan ]
  * stage1 enhance IR print

  [ Vesa Kaihlavirta ]
  * Shorten @field documentation and add an example

  [ Jonathan Marler ]
  * Add Array support to @Type

  [ LemonBoy ]
  * Resolve lazy values when checking for definedness
  * Always resolve the struct field types

  [ Timon Kruiper ]
  * Add compile error when shifting amount is not an int type

  [ Andrew Kelley ]
  * I'm pretty sure `sp` is the stack pointer on all ARM
  * prefer result type casting to peer type resolution
  * os: raise maximum file descriptor limit
  * add -l as an alias for --library

  [ Timon Kruiper ]
  * Add compiler error when negating invalid type

  [ Andrew Kelley ]
  * implement `noasync` function calls
  * runtime safety for noasync function calls

  [ emekoi ]
  * fixed compiler error for gcc 9.2.0

  [ Andrew Kelley ]
  * fix await used in an expression generating bad LLVM
  * implement spills when expressions used across suspend points
  * properly spill expressions with async function calls
  * update process_headers tool for glibc 2.30
  * update glibc headers to 2.30
  * update glibc ABI lists to 2.30
  * fix suspensions inside for loops generating invalid LLVM IR

  [ Gustav Olsson ]
  * forward framework dirs to embedded clang in addition to linker on osx

  [ Andrew Kelley ]
  * move logic for propagating framework dirs to zig cc

  [ Michael Dusan ]
  * test-stack-traces: add FreeBSD

  [ Sahnvour ]
  * use /debug:fastlink when building with msvc and debug info

  [ Andrew Kelley ]
  * release builds of stage1 have llvm ir verification
  * implement spilling when returning error union async function call

  [ LemonBoy ]
  * Allow comparison between union tag and enum literal
  * Comptime folding of enum/union comparisons
  * Fix typo in TLS initialization code

  [ Andrew Kelley ]
  * fix bad LLVM IR when for target expr needs to be spilled

  [ LemonBoy ]
  * Adjust the stdlib to be 32bit compatible

  [ Andrew Kelley ]
  * fix a var decl in scope preventing for loop spills

  [ Michael Dusan ]
  * fix tests.addPkgTests to always run native target

  [ Sahnvour ]
  * forbid opaque types in function return types

  [ LemonBoy ]
  * Force LLVM to generate byte-aligned packed unions

  [ daurnimator ]
  * std: add BloomFilter data structure

  [ Andrew Kelley ]
  * make the std lib support event-based I/O
  * -fstack-report outputs JSON

  [ LemonBoy ]
  * Accept void argument for @cDefine value
  * Resolve lazy arguments passed to @compileLog
  * Don't forget to resolve the pointee type

  [ Andrew Kelley ]
  * update embedded LLD to 9.0.0rc4
  * lld: apply patch: [mach-o] Extend LC_DATA_IN_CODE support to x86_64
  * update C header files to clang 9.0.0rc4

  [ Michael Dusan ]
  * fix build on macOS + xcode + clang

  [ stratact ]
  * Get more of the tests passing for FreeBSD (#3197)

  [ Andrew Kelley ]
  * update glibc src files to 2.30
  * async function calls re-use frame buffers
  * disable runtime safety in std.io.InStream
  * add behavior test for `@enumToInt(enum(u1){x}.x)`

  [ LemonBoy ]
  * Recognize & skip the UTF-8 BOM

  [ Andrew Kelley ]
  * consolidate std.debug.parseDie and std.debug.parseDie1
  * improvements targeted at improving async functions

  [ LemonBoy ]
  * Correct AT_FDCWD definition

  [ stratact ]
  * Add missing C dl_iterate_phdr function for FreeBSD

  [ LemonBoy ]
  * Make single-element enum default to u0

  [ Andrew Kelley ]
  * fix regression from incorrect conflict resolution in prev commit
  * no-stack-arg-probe only for UEFI

  [ Tetralux ]
  * Add FixedBufferAllocator.reset

  [ Jay Weisskopf ]
  * Fix typos: "seperate" to "separate"

  [ Andrew Kelley ]
  * fix tripping llvm assert
  * update clone on arm32 to latest musl implementation
  * fix tripping llvm assert
  * fix peer result location with typed parent, ...

  [ Shawn Landden ]
  * Fix array->vector and vector->array for many types. Allow vector of bool.

  [ Andrew Kelley ]
  * adjust codegen of casting between arrays and vectors

  [ Shawn Landden ]
  * stage1: proper return type on vector comparisons

  [ Andrew Kelley ]
  * remove TODO regarding lazy values

  [ Shawn Landden ]
  * stage1: add @shuffle() shufflevector support

  [ Andrew Kelley ]
  * rework the implementation
  * relax std.auto_hash requirements regarding vectors

  [ Shawn Landden ]
  * @byteSwap on vectors

  [ Andrew Kelley ]
  * implement runtime `@byteSwap` and other fixups

  [ Shawn Landden ]
  * `@splat`

  [ Andrew Kelley ]
  * fixups for `@splat`
  * add docs for `@splat`

  [ ScorrMorr ]
  * pass param as ref in ZigList::append

  [ Shawn Landden ]
  * Allow Zig programs to implement their own startup (_start) for ELF executables.
  * docs: clarify @clz and @ctz terminology to not be endian-specific.

  [ daurnimator ]
  * src: use zig_panic rather than having LLVM abort

  [ Andrew Kelley ]
  * update std.zig.tokenizer

  [ stratact ]
  * Disable Channel, Future, and Lock tests for FreeBSD (#3253)

  [ Andrew Kelley ]
  * update CI scripts llvm 8 to 9
  * macos ci: RISCV is no longer experimental
  * update remaining llvm 8.0.0 references to 9.0.0

  [ Michael Dusan ]
  * stage1: fix gcc 9.1.0 compiler error on archlinux

  [ Andrew Kelley ]
  * fix typo in docs
  * update README

  [ Timon Kruiper ]
  * Fix comptime bitcast inside an expression

  [ Andrew Kelley ]
  * add test case for already fixed bug

  [ Sahnvour ]
  * reject types of automatic container layout in packed unions

  [ daurnimator ]
  * std: update riscv64 syscalls
  * std: update for linux 5.3

  [ Andrew Kelley ]
  * fix typo
  * add more RISCV64 linux bits to std lib
  * avoid setting `tail` for `@panic`

  [ LemonBoy ]
  * Fix generation of tail fields for packed struct
  * Correct stack alignment for new stack
  * Adjust tests for AArch64
  * Fix a test on ARM due to the use of `undefined` ptr

  [ Tetralux ]
  * Remove 'inline', as per @andrewrk

  [ Andrew Kelley ]
  * add behavior test for float widening f16 to f128
  * zig test: don't skip execution when explicit command provided

  [ LemonBoy ]
  * Fix TLS for VariantI arches with a twist

  [ Michael Dusan ]
  * stage1: fix lost argv[0]

  [ Andrew Kelley ]
  * significantly increase test coverage
  * windows ci: make the case of file names agree
  * fix linux stat struct on aarch64

  [ Euan Torano ]
  * Fix #3272 - update docs

  [ Andrew Kelley ]
  * linux implementation of std.net.getHostName
  * clean up compiler_rt with some enum literals
  * disable running cross compiled macos tests
  * do the release tests last because they take longer
  * ci: update windows image to MSVC 2019
  * remove redundant assert
  * windows CI: use MinSizeRel to work around MSVC bug
  * libc implementation of gethostname
  * more info in assertion failures
  * more helpful error message when failing to parse glibc abi.txt
  * git, I love you, but please stop mangling my files
  * tolerate windows newlines in glibc text files
  * silence nonportable include path warnings when building glibc on windows
  * add emscripten to std.build.Target.defaultAbi
  * mingw-w64 libc: fix incorrect detection of _xgetbv
  * enable test coverage for cross compiling windows mingw-w64
  * windows CI: fix name collision
  * zig build: linkSystemLibrary integrates with pkg-config
  * make type_allowed_in_extern more robust

  [ LemonBoy ]
  * Fix computation of switch coverage
  * Prevent crash with invalid extern type

  [ Jay Weisskopf ]
  * Create user-specified `output-dir`

  [ LemonBoy ]
  * Fix assignment to optional payload
  * Fix result loc unwrapping with optional in error union

  [ Andrew Kelley ]
  * docgen: slightly cleaner display of libc cli args
  * docgen: test blocks support linking libc

  [ Michael Dusan ]
  * add VarDecl support for struct-method call syntax

  [ Andrew Kelley ]
  * better default enabled features for riscv
  * add docs for usingnamespace

  [ LemonBoy ]
  * Correct some RISCV64 bits
  * Add DTP bias according to RISCV ABI
  * Fix llseek behavior

  [ Vexu ]
  * add noasync to zig fmt
  * ran zig fmt on stdlib

  [ Andrew Kelley ]
  * fix building musl on eabihf abis, incorrect include dirs
  * disable known-to-be-failing tests for linux-aarch64-gnueabihf
  * musl [PATCH] arm: fix setjmp and longjmp asm for armv8-a
  * enable test coverage for armv8-linux-musleabihf
  * docgen: slightly better caching
  * macos ci: display system info before running anything
  * mv std/ lib/
  * remove --override-std-dir. fix issues caused by moving std lib
  * zig additionally looks for lib/std/std.zig
  * add -DZIG_SKIP_INSTALL_LIB_FILES cmake option

  [ LemonBoy ]
  * Initial support for mipsel architecture¬
  * Fix wrong IOCTL value

  [ Michael Dusan ]
  * doc: usingnamespace imports only public decls

  [ LemonBoy ]
  * Export _start as __start for MIPS targets
  * Add comments about the test cases that have been disabled

  [ Andrew Kelley ]
  * docs: mention release-small along with release-fast

  [ LemonBoy ]
  * Errno changes for MIPS

  [ Andrew Kelley ]
  * docgen: add "process terminated by signal" to exe_err

  [ LemonBoy ]
  * Don't warn about redeclaration for the same var node

  [ Andrew Kelley ]
  * fix some linux declarations not getting exposed
  * fix mipsel regression in previous commit

  [ Nick Erdmann ]
  * std/os/uefi: add exitBootServices and allocatePool
  * std/os/uefi: add some hii support

  [ Andrew Kelley ]
  * add regression test for alignment of constants

  [ LemonBoy ]
  * Avoid truncating mmap2 offsets if not multiple of page size
  * Backport patch for Musl libc
  * Enable mipsel+libc tests on CI
  * Correct calculation of padding length in struct

  [ Andrew Kelley ]
  * fully specify padding bytes when necessary

  [ meme ]
  * support Android NDK and bionic

  [ Andrew Kelley ]
  * std.os.fstat: EINVAL => unreachable

  [ meme ]
  * fix building static Android executables

  [ Andrew Kelley ]
  * avoid duplicated code of specifying the default glibc version
  * fix glibc builds on aarch64-linux-gnu

  [ meme ]
  * do not link against gcc runtime on Android target
  * minor tweaks

  [ Andrew Kelley ]
  * RISC-V: get to the linking phase of behavior tests

  [ Nick Erdmann ]
  * std/os/uefi: fix Guid alignment in rng protocol

  [ Andrew Kelley ]
  * docgen: support code examples for riscv target
  * detect the windows um include directory
  * detect the shared windows include dir as well
  * docs: docgen supports release safe exe code examples
  * remove unhelpful/outdated/unused doc file
  * Release 0.5.0
  * langref: add 0.5.0 docs link

  [ SamTebbs33 ]
  * Replace code occurences of --override-std-dir with --override-lib-dir

  [ LemonBoy ]
  * Correct signal bits for MIPS

  [ Andrew Kelley ]
  * translate-c: make trans_implicit_cast_expr use zig_clang.h
  * fix tripping LLVM assertion in const unions
  * more conversion of translate_c.cpp to use zig_clang.h
  * llvm 9.0.0 => llvm 10.0.0
  * we have to use c++14 now for llvm10
  * finish conversion of translate_c.cpp to use zig_clang.h
  * docs: use the updated png favicon
  * zig build: fix exe file ext to match target.cpp

  [ LemonBoy ]
  * Fix pipe syscall for MIPS

  [ Andrew Kelley ]
  * add -fdump-analysis to dump type information to json
  * handle when std lib is unused
  * fix noreturn attribute for msvc

  [ Michael Dusan ]
  * stage1: fix compile error on macOS Xcode 11.1

  [ Andrew Kelley ]
  * langref: no viewport
  * proof of concept of stage1 doc generation
  * generated docs: navigable packages
  * generated docs: navigable types

  [ Michael Dusan ]
  * fix container member access for fn/struct-fn

  [ Andrew Kelley ]
  * generated docs: add navigation bar
  * generated docs: render functions
  * generated docs: show public stuff only
  * generated docs: canonical package paths

  [ LemonBoy ]
  * Initial support for i386-windows-msvc target
  * Support for TLS on Win32

  [ Andrew Kelley ]
  * generated docs: docs/ instead of doc/
  * stage1 parser supports doc comments

  [ Matt Keeter ]
  * Fix typo in docs

  [ Nick Erdmann ]
  * unicode character literals

  [ Andrew Kelley ]
  * move doc/ to docs/
  * generated docs: show doc comments on functions
  * generated docs: logo and basic search proof of concept
  * generated docs: better navigation
  * generated docs: fix search stuff
  * generated docs: keyboard shortcuts modal
  * generated docs: navigable search results
  * generated docs: search cleanup
  * generated docs: smart ignore case
  * generated docs: sort search results
  * stage1: enable PIC for libuserland
  * generated docs: prioritized sort ranking
  * generated docs: highlight active package
  * generated docs contain generic instantiations and comptime calls
  * generated docs: function parameters have links
  * generated docs: bool type and fix error for some fns
  * generated docs: functions with inferred error sets display nicely

  [ Christine Dodrill ]
  * src/main: minor grammar fix in the help for `zig builtin`

  [ Timon Kruiper ]
  * Add initial support for struct fields in the docs

  [ Andrew Kelley ]
  * generated docs: error sets in fn docs
  * generated docs: consistent coloring
  * generated docs: add global variables
  * generated docs: global vars in a table
  * generated docs: render var decls
  * generated docs: separate Error Sets from Types
  * generated docs: functions in a table with descriptions

  [ Alva ]
  * Correct std.os.connect_async docs

  [ Timon Kruiper ]
  * Docs: adds docs comments to struct fields

  [ Andrew Kelley ]
  * improve names of error sets when using merge error sets operator
  * add comments about why we choose pentium4 for i386 target
  * generated docs: show error sets pages
  * zig build: bump default max exec output size to 400 KB
  * generated docs: separate section for namespaces
  * generated docs: more verbose fields

  [ LemonBoy ]
  * Shuffle around some stack-probing functions
  * Fix compilation w/ clang
  * Remove x86/Windows name mangling hack
  * Compile the architecture-specific mingw sources
  * Add a bunch of mingw lib32 .def files

  [ Michael Dusan ]
  * stage1: fix root top-level-struct typename

  [ Andrew Kelley ]
  * generated docs: refactor how type kinds work
  * generated docs: render values
  * generated docs: add array type support
  * generated docs: avoid clobbering browser shortcut keys
  * generated docs: better handle when root is std

  [ Vexu ]
  * implement doc generation for union and enum

  [ LemonBoy ]
  * Patch lld to have a more sensible kill-at implementation
  * Add i386/mingw to the test rooster
  * Fix stack-probe symbol redefinition

  [ Timon Kruiper ]
  * Generated docs: store static container info in a containerDecl astNode
  * Generated docs: Add function paramater names

  [ Michael Dusan ]
  * cleanup: unused imports in test
  * stage1: fix ir_resolve_str() to return slice

  [ Andrew Kelley ]
  * generated docs: better listing of functions

  [ Rocknest ]
  * Change layout and styles
  * Add transtition to search field

  [ Andrew Kelley ]
  * generated docs: css: wider tables

  [ LemonBoy ]
  * Extern unions should not trigger active field check

  [ Andrew Kelley ]
  * generated docs: clean up type names and param names

  [ Rocknest ]
  * Fix dark mode
  * Changes from master

  [ Andrew Kelley ]
  * generated docs: better rendering of unknown decls
  * better debug info for integers
  * generated docs: add optional type support

  [ Rocknest ]
  * Changes from master

  [ Andrew Kelley ]
  * codegen.cpp: remove unused variable
  * miscellaneous improvements to generated docs

  [ LemonBoy ]
  * Fix cross-compilation to i386-windows-msvc

  [ Andrew Kelley ]
  * merge dumps tool: merging ast nodes
  * merge targets of generated docs

  [ LemonBoy ]
  * Add dlltool functionality
  * Revert LLD patch
  * Fix lld search path
  * Replace usage of createDriverOptTable
  * Add/shuffle several enum members to match Clang's API
  * Replace llvm::make_unique with std::make_unique
  * More clang API changes
  * Correctly mangle frameaddress intrinsic name

  [ Rocknest ]
  * Consistent margins

  [ LemonBoy ]
  * Add support for the statx syscall
  * Fix signedness for some fields in ARM stat definition
  * Add ELF architecture constant for RISC-V
  * Fix fp-based backtracing on RISC-V
  * Propagate user-defined function alignment to LLVM IR

  [ Sahnvour ]
  * ci: use parallel msbuild.exe processes for faster building on windows

  [ LemonBoy ]
  * Adapt to clang API additions
  * Fix stack iteration stop condition

  [ Vexu ]
  * fix struct align fmt

  [ Andrew Kelley ]
  * fix non-byte-aligned packed struct field...

  [ tgschultz ]
  * Replaced setTag hack in Deserialize with @unionInit

  [ dtw-waleee ]
  * Fix keyboard layout issue with help-modal
  * fix small misstake, 'escape' v. 'Escape'

  [ Andrew Kelley ]
  * generated docs: further clean up keyboard shortcut handling
  * merge analysis dumps tool handles errors
  * generated docs: progress towards generic types being useful
  * add cross compiling support for opengl32.dll
  * add more cross compiling support for windows system dlls
  * only look for .defs when needed; remove samsrv.dll cross compiling support

  [ Nick Erdmann ]
  * std/os/uefi: add Guid format()

  [ Andrew Kelley ]
  * [breaking] standardize std.os execve functions

  [ Nick Erdmann ]
  * std/os/uefi: add documentation

  [ Andrew Kelley ]
  * add -I command line parameter, same as clang
  * improve docs and field names of Statx struct

  [ LemonBoy ]
  * Fix compilation of updateTimes on 32bit platforms

  [ Andrew Kelley ]
  * add docs for std.fs.File.updateTimes

  [ Emeka Nkurumeh ]
  * fix std.mem.AsBytesReturnType (#3442)

  [ Sebsatian Keller ]
  * Add 'missing' consts to math.zig

  [ Andrew Kelley ]
  * turn comments into doc comments

  [ Rocknest ]
  * Changes from master
  * Cleanup

  [ Sahnvour ]
  * stage1: override cmake's default compilation flags to statically link the CRT on windows
  * msvc: reduce inlining aggressivity to workaround a codegen bug in cl.exe cf. #3024

  [ Andrew Kelley ]
  * update CI script for windows static builds
  * ref more math decls for better docs
  * remove -DZIG_FORCE_EXTERNAL_LLD=ON
  * update musl headers to v1.1.24
  * update musl src to v1.1.24
  * mipsel: fix padding on stat struct

  [ Luna ]
  * add lib/std/progress.zig

  [ Andrew Kelley ]
  * rework the progress module and integrate with stage1
  * improve progress reporting

  [ Nick Erdmann ]
  * std/os/windows: remove subsystem detection for uefi
  * std/build: make subsystem configurable

  [ Andrew Kelley ]
  * add -DZIG_ENABLE_MEM_PROFILE option and -fmem-report flag
  * reduce the size of IrInstruction by 8 bytes on 64 bit targets

  [ LemonBoy ]
  * Fix crash when generating constant unions with single field
  * Prevent too eager constant-folding of switch expression

  [ stratact ]
  * Use 8192 sized buffers and remove allocator parameters

  [ Felix Queißner ]
  * Starts to implement markdown parser. Implemented: strong, emphasis, strikethrough, underline, code blocks, ulist, olist, paragraphs, headings. Planned: Links, Images, internal references.

  [ LemonBoy ]
  * Resolve lazy slice start/end values

  [ Andrew Kelley ]
  * breaking: improve std.fs directory handling API

  [ LemonBoy ]
  * Fix crash with peer type resolution & error unions

  [ Andrew Kelley ]
  * [wip] use NtDll APIs on Windows to implement std.fs.Dir
  * adjust test runner to print the test name when error occurs
  * test runner: refresh display before running test
  * fs.Dir.openDir: use empty object name for "." on Windows
  * darwin: add AT_* bits
  * cleanup
  * add freebsd AT_* bits
  * test runner: restore previous behavior when...
  * fix os.unlinkatW implementation
  * test runner: restore previous behavior of printing all tests passed

  [ Vexu ]
  * remove pub syntax for container fields

  [ Jonathan Marler ]
  * Fix accept function API

  [ Andrew Kelley ]
  * std.os.accept4: improve docs and integrate with evented I/O

  [ Felix Queißner ]
  * Adds documentation for std.fmt.format grammar and customization. (#3474)

  [ Maximilian Hunt ]
  * Add documentation on function parameter type inference.

  [ Andrew Kelley ]
  * integrate stage1 progress display with semantic analysis

  [ emekoi ]
  * explicity linked ntdll on mingw-w64

  [ Andrew Kelley ]
  * main.cpp: fix not ending progress node for zig build
  * implement safety for resuming non-suspended function

  [ Jonathan Marler ]
  * Handle TERM=dumb for stdout/stderr

  [ Andrew Kelley ]
  * move types from builtin to std
  * refAllDecls in a test block to limit when it gets run
  * get rid of std.os.foo.is_the_target

  [ Sebastian Keller ]
  * Added 'writeJson' to write_stream.zig:

  [ Andrew Kelley ]
  * Add missing compile error when ptr used instead of array

  [ Sebastian Keller ]
  * Shortened switch statement

  [ Andrew Kelley ]
  * implement partial C ABI support for aarch64
  * avoid passing -march=native when not supported
  * add Drone Cloud CI configuration
  * disable static build for now until the docker image is ready
  * fix 32-bit build of translate_c.zig
  * ci: drone tests only aarch64 with docker image
  * ci: add s3 secrets to drone config
  * ci: use x86_64 namespaced docker image
  * ci: build docs, fix PR logic
  * os.dup2: handle EBAF
  * disable not working stuff
  * ci: add aarch64 to download page
  * ci: force git name-rev to be 9 on all targets
  * ci: perform git config inside zig git repo dir
  * fix regression in `zig run`

  [ Michael Dusan ]
  * stage1: fix compile error on macOS Xcode 11.2

  [ Andrew Kelley ]
  * ci: enable more passing tests on aarch64-linux

  [ Timon Kruiper ]
  * Translate-c: Fix a segfault when to many errors are emitted

  [ Andrew Kelley ]
  * ci: -Dskip-release for aarch64 to hit 1 hour time limit

  [ Noam Preil ]
  * Don't save/restore stack on newStackCall to noreturn function
  * Don't use SSE on freestanding

  [ Andrew Kelley ]
  * ci: disable test-compare-output on aarch64

  [ Luna ]
  * fix std.os.accept4
  * std: make addr_size parameter be a pointer to socklen_t

  [ xackus ]
  * fix json parser crashing on empty input remove unreachable code

  [ Benoit Giannangeli ]
  * lib/std/target.zig: Added missing 'mem' constant

  [ Andrew Kelley ]
  * std.target: use mem instead of std.mem

  [ Henry Wu ]
  * generated docs: vertically align fns with comments

  [ Sebastian Keller ]
  * Unified public api
  * Added test for 'emitJson'

  [ xackus ]
  * make implicit cast of tagged unions to enums easier to find in docs
  * better test name for empty string
  * rename error and specify it in function

  [ Nathan Michaels ]
  * Add some documentation for standard library things. (#3540)

  [ Andrew Kelley ]
  * synchronize the target features for compiling C code

  [ Timon Kruiper ]
  * Std docs: Fix a js error that would cause some function to be not rendered

  [ Andrew Kelley ]
  * remove dead tls code
  * detect async fn recursion and emit compile error
  * std.net.getAddressList
  * partial no-libc implementation of std.net.getAddressList
  * fix regression in translate-c
  * move libc/linux bits around
  * basic DNS address resolution for linux without libc

  [ Jonathan Marler ]
  * Add tests for ip address formatting

  [ Andrew Kelley ]
  * implement CNAME expansion
  * std.net: port the RFC 3484/6724 destination...

  [ lukechampine ]
  * inline path separator loop

  [ Andrew Kelley ]
  * std lib networking improvements, especially non-blocking I/O
  * rename std.net.Server to TcpServer and simplify it
  * fix regression in behavior tests
  * fix std.net tests and std.net.TcpServer docs

  [ Nathan Michaels ]
  * Document PriorityQueue.

  [ Andrew Kelley ]
  * std.net: enable test for resolving DNS
  * fix regressions
  * fixes for macos and 32 bit arches
  * make std.net more portable
  * canonicalize std.os IPPROTO constants
  * fix os.sockaddr being a union instead of a struct

  [ Henry Wu ]
  * generated docs: move color to box-shadow CSS prop

  [ Tse ]
  * DragonFlyBSD support

  [ Andrew Kelley ]
  * add comments to disabled tests linking to the tracking issue
  * std.net: fix reference to incorrect constant name
  * startup code sets up event loop if I/O mode is declared evented
  * util.cpp: canonicalize the order of includes

  [ Tse ]
  * DragonFlyBSD tidyup

  [ Andrew Kelley ]
  * fix regression in std.os.dirent64 on linux
  * startup code respects root source file's event_loop if present

  [ lukechampine ]
  * crypto: Add AES implementation

  [ Andrew Kelley ]
  * std.os: fix sendto, poll, recvfrom when linking libc

  [ Luna ]
  * add FileNotFound error to os.connect
  * add FileNotFound to os.ConnectError error set

  [ Michael Dusan ]
  * stage1: add linux XDG Base Directory support

  [ Andrew Kelley ]
  * ci: stop assuming that azure will complete last
  * ci: use heredoc and alpine/edge for faster sr.ht job
  * ci: avoid leaking oauth access token
  * ci: hail mary running git.exe in the windows bat file
  * ci: work around pip install permission denied
  * ci: more fixes for update_download_page script

  [ kprotty ]
  * Remove StaticallyInitializedMutex

  [ Andrew Kelley ]
  * ci: workaround PATH apparently not working

  [ LemonBoy ]
  * Fix cmpxchg trying to execute at CT

  [ daurnimator ]
  * std: close is OSX specific
  * std: Add definitions for (deprecated) futimes and utimes C functions

  [ Vexu ]
  * improve ipv6 parsing and formatting
  * support ipv4-mapped ipv6 addresses

  [ Brendan Hansknecht ]
  * Add karatsuba to big ints

  [ Luke Champine ]
  * remove speculative AES TODOs

  [ LemonBoy ]
  * Make the `leb` module available to non-std code
  * Correctly process errors for invalid types in fn call
  * Fix crash in #3483
  * Prevent crash when slicing undefined ptr to slice
  * Fix #3558

  [ Andrew Kelley ]
  * std.os.read can fail with ConnectionResetByPeer

  [ data-man ]
  * Replace AES variables to constants

  [ daurnimator ]
  * std: Add fifo useful for buffers

  [ kprotty ]
  * adaptive SpinLock
  * Move hybrid yielding into its own struct

  [ lukechampine ]
  * crypto: Add support for AES-CTR

  [ Shawn Landden ]
  * remove duplicate isNan implementation
  * fix noreturn function that may return.

  [ LemonBoy ]
  * Mark type fields as CT

  [ Vexu ]
  * add special formatting for ipv4-mapped ipv6 addresses

  [ Andrew Kelley ]
  * runtime load vector element with comptime index
  * comptime load of vector element
  * implement store of vector element with comptime index
  * implement loading vector elements via runtime index
  * implement storing vector elements via runtime index
  * fix initialization of vector in a struct field
  * fix incorrect type name on bit field pointers
  * zig build: addIncludeDir does -I instead of -isystem

  [ kprotty ]
  * make SpinLock.Backoff pub
  * ThreadParker implementation
  * Adaptive Mutex: - uses std.ThreadParker - supports static initialization (deprecates StaticallyInitializedMutex)
  * Disable asm("yield") for arm in SpinLock.yieldCpu() because of CI

  [ Vexu ]
  * fix translate-c arrow deref

  [ Sebastian Keller ]
  * Fixed a leak in the json parser.

  [ Brendan Hansknecht ]
  * add token for parsing pointer dereference

  [ Andrew Kelley ]
  * improve the start code for evented I/O

  [ Vexu ]
  * use global event loop in std.event types
  * fix NodeErrorSetDecl rendering

  [ Sebastian Keller ]
  * std.json.Value: added dumpStream(), utilize WriteStream for dump()

  [ shiimizu ]
  * Add error when too few arguments are provided to std.fmt

  [ kprotty ]
  * skip std.ThreadParker test on single-threaded

  [ Andrew Kelley ]
  * allow type coercion from *[0]T to E![]const T

  [ Nick Erdmann ]
  * std/os/uefi: loading images
  * std/os/uefi: snp, mnp, ip6, and udp6 support
  * std/os/uefi: protocol handling improvements

  [ LemonBoy ]
  * Fix ptrCast of array references to fn
  * Add small tokenizer test case for #3468

  [ Shawn Landden ]
  * correctly use llvm undef in release modes

  [ Vexu ]
  * self hosted compiler: fix zig_llvm.h function signature
  * self hosted compiler: fix internal build info
  * self hosted compiler: remove await async pattern
  * self hosted compiler: replace Promise with Frame and AnyFrame
  * self hosted compiler: update to new std.event
  * self hosted compiler: unify Target and std.Target
  * self hosted compiler: fix calling convention in type.zig
  * self hosted compiler: use enum literals
  * self hosted compiler: small fixes to imports and declarations
  * self hosted compiler: comment out event.fs stuff

  [ kprotty ]
  * lock the mutex on pthread_cond_signal()

  [ Vexu ]
  * make callMainAsync async
  * allow Group to optionally manage function frames' memory
  * self hosted compiler: move functions to util.zigto avoid defining llvm instricts.

  [ Andrew Kelley ]
  * ci: bump ubuntu from 16.04 to 18.04

  [ kprotty ]
  * move SpinLock definitions around
  * remove WaitOnAddress backend in std.ThreadParker
  * fix SpinLock.yield for pull/3626

  [ Vexu ]
  * self hosted compiler: various small fixes

  [ kprotty ]
  * pthread_sched_yield -> sched_yield
  * Use `system` instead of `builtin.link_libc`
  * missing `os` declaration

  [ Andrew Kelley ]
  * ci: add srht oauth token to drone cloud script

  [ kprotty ]
  * handle NtCreateKeyedEvent failure by spinning to ensure correctness
  * cleanup getEventHandle

  [ Andrew Kelley ]
  * fixups and zig fmt
  * introduce `@as` builtin for type coercion
  * update the codebase to use `@as`
  * fix result loc of cast not finding parent
  * more regressions fixed
  * behavior tests passing
  * update more of the std lib to use `@as`
  * initial docs for `@as`
  * passing std lib tests
  * fix regressed tests and update docs to use "type coercion"
  * fix type cast in windows child process code

  [ Luna ]
  * rename IpAddress to Address, add Address.unix
  * replace Address.parse Address.parseIp

  [ dimenus ]
  * missed cast in std/target.zig

  [ Luna ]
  * add Address.parseUnix and Address.format support for AF_UNIX

  [ Sahnvour ]
  * build: initial support for using vcpkg libraries

  [ Luna ]
  * rename TcpServer -> StreamServer
  * make StreamServer.listen family-agnostic

  [ LemonBoy ]
  * Fix initialization of union references

  [ Luna ]
  * miscellaneous fixes
  * use at-as
  * add errors/panics for unsupported OSes

  [ dimenus ]
  * minor fix due to recent directory handling API changes

  [ Luna ]
  * use hasDecl instead of switch on builtin.os
  * replace panic to unreachable
  * add sockaddr_un to os/bits/windows
  * remove builtin.os check in Address.initUnix

  [ Andrew Kelley ]
  * std.ChildProcess.spawn has a consistent error set

  [ xackus ]
  * Unescape JSON strings
  * Fix and document

  [ Felix Queißner ]
  * Fix missing @as cast in std.fmt.formatInt (#3650)

  [ Andrew Kelley ]
  * stop accepting deprecated `use` keyword

  [ xackus ]
  * minor fixes

  [ Andrew Kelley ]
  * stage1 parser code for anon container lit
  * implement anon struct literal syntax
  * add behavior test case for anon union literal
  * add behavior test case for anonymous list literal syntax
  * zig fmt: support anon struct and anon list init syntax
  * fix anon literal used with return result loc

  [ xackus ]
  * json: surrogate pair support
  * Fix bugs in JSON parser
  * Stricter tests for non-streaming parser

  [ Andrew Kelley ]
  * fully anonymous struct literals
  * add test for missing const in slice with nested array type
  * implement fully anonymous list literals
  * update docs for anonymous struct/list literals
  * fix unresolved type making it to codegen
  * fix assertion failure in init_const_undefined

  [ Vexu ]
  * support atomic operations with enums
  * use enum with atomics in std lib

  [ Andrew Kelley ]
  * fix assertion failure in ptrToInt

  [ Vexu ]
  * add @atomicStore builtin
  * use @atomicStore in std lib
  * fix comptime atomicStore and add tests

  [ Andrew Kelley ]
  * fn parameters participate in result location semantics
  * fix anonymous struct literal assigned to variable
  * std.io.getStdOut and related fns no longer can error
  * README: update the short description of what zig is

  [ Vexu ]
  * add compile error for @atomicRmw on enum not being an .Xchg

  [ daurnimator ]
  * std: add windows FILE_DEVICE_ defines
  * std: add windows ioctl transfer types
  * std: add FILE_ANY_ constants for windows
  * std: add CTL_CODE function for windows
  * std: add windows socket constants
  * std: add winsock some definitions
  * std: add DeviceIoControl and GetOverlappedResult for windows
  * std: add WSASocketW for windows

  [ Andrew Kelley ]
  * rework comptime struct value layout, removing 1/2 hacks
  * rework layout of struct type fields

  [ Vexu ]
  * implemented container doc comments in stage 2

  [ LemonBoy ]
  * Update discriminant value also for zero-sized unions

  [ Andrew Kelley ]
  * remove no longer correct comment

  [ daurnimator ]
  * std: add WSAStartup and WSACleanup for windows
  * std: add NtDeviceIoControlFile definition for windows
  * std: add pieces for WSAIoctl on windows

  [ Vexu ]
  * implemented container doc comments in stage 1
  * add container doc comments to generated docs
  * fix containerdoccomment not handled in docgen.zig

  [ daurnimator ]
  * std: fix outdated valgrind module
  * std: use enum literals in valgrind module
  * std: fix use of old syntax in std.valgrind.memcheck
  * std: fix missing @ptrToInt in valgrind.memcheck
  * std: add a couple of tests to valgrind module

  [ Vexu ]
  * properly parse anon literal in array

  [ LemonBoy ]
  * Catch invalid type from peer resolution

  [ daurnimator ]
  * fix bug on empty error union

  [ Andrew Kelley ]
  * add regression test case
  * add regression test case. closes #3007
  * add regression test case. closes #2889
  * add regression test case. closes #2980

  [ daurnimator ]
  * translate-c: add support for MacroQualified definitions

  [ frmdstryr ]
  * Make StreamServer return address of accecpted client

  [ dbandstra ]
  * add `std.math.tau` constant (equivalent to 2 * pi)

  [ Johan Bolmsjö ]
  * std.testing.expectEqual: show differing pointer values

  [ Benjamin Feng ]
  * Use wasm_allocator
  * WASI time_t / timespec
  * WASI clock functions
  * WASI isatty
  * Work around WASI's nonexistent @returnAddress()
  * Add .enable_wasmtime build flag

  [ Andrew Kelley ]
  * remove dead code shebang support from self-hosted tokenizer
  * self-hosted tokenizer handles \r in string literals
  * add std.fs.Dir.openRead
  * improve std.fs.selfExePath and related functions on Windows

  [ Benjamin Feng ]
  * Replace magic numbers with named constants

  [ Andrew Kelley ]
